2007-06-29  Matti Aarnio  <mea@zmailer.org>

	* ChangeLog, configure.in:
	    Mark version as 2.99.57

2007-06-28  Matti Aarnio  <mea@zmailer.org>

	* include/vis.h, lib/fdstatfs.c, libc/getnameinfo.c, 
	  router/functions.c, router/shliaise.c,
	  router/zrfilter/zrfilter.c:
	    Propitiating GCC on Solaris 10 (SPARC) to accept
	    compilation..

2007-02-13  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtphook.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h:
	    A bit more generalized interfaces for perl hook,
	    compile-checked this time...
	
	* smtpserver/subdaemon-trk.c:
	    Share input language processing in between the internal
	    clients and the cluster peers.
	    (TODO: don't tell to self over the cluster!)

	* transports/smtp/smtp.c:
	    When doing fallback lock release via diagnostic() calls,
	    always report them as EX_TEMPFAIL.  In fallback they were
	    not yet properly processed.

2006-12-13  Matti Aarnio  <mea@zmailer.org>

	* proto/smtpserver.conf.in, smtpserver/cfgread.c,
	  smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtpcmds.c,   smtpserver/smtpdata.c,
	  smtpserver/smtphook.c:
	    Perl-hook revision from Daniel Kiper.

	* man/smtpserver.8.in:
	    Initial comments on  perl-hook   mechanism.

	* contrib/hrr-srs-zpostgrey/usr/local/lib/zmailer/zpostgrey
	    Small changes to support upcoming call sequence changes.
	    Intention is to permit RCPTs to be given without immediately
	    issuing greyfilter on them, but doing reporting when it is
	    time for DATA/BDAT LAST.

2006-12-07  Matti Aarnio  <mea@zmailer.org>

	* router/zrfilter/Makefile.in, router/zrfilter/vis.c,
	  router/zrfilter/zrfilter.c:
	    More feeding of Daniel Kiper's bits.

	* smtpserver/smtpserver.c:
	    Sometimes there is a long delay from incoming connection
	    to its IP address' proper resolving.  Report at first
	    arriving connection with IP literal, and latter with
	    resolved reverser.  Also, start session specific log
	    delta-timer right at the connection time, not way latter
	    eg after resolving incoming connection IP address reversers.

	* utils/smtp-contentfilter.in:
	    The perl prototype of content filter service didn't
	    like at all when I force-fed it the '-Z zconf' parameter.
	    Had to alter  "while (<>) .." to "while (<STDIN>) .."
	    construction.

2006-12-06  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    To polish a very fine point, SMTP reply for MAIL FROM
	    does not allow "450", but "451" is acceptable.

	* smtpserver/smtpserver.c:
	    Feed a NUL-byte on ARGV-overwrite simulation of  setproctitle()
	    in systems that have to do that..

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-ctf.c:
	    Pass  -Z zconf  -option for the called execl()s.

	* smtpserver/subdaemons.c:
	    Pass  -R  routerprog   option to called sub-instance
	    of the smtpserver.

2006-12-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c, smtpserver/smtpauth.c,
	  smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtphook.c,   smtpserver/smtpdata.c:
	    Compiled and linked in support for Perl hooks crashes
	    in case the actual hook is not properly initialized.
	    Only if the init-call yields success, do enable hook
	    calling!

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtpcmds.c:
	    Analyze, verify and report (in "rcvdfrom" envelope
	    header ending up in syslog, and in message Received:
	    header) both remote host source IP reversing success,
	    that reversed name had also the remote IP address in
	    its set, that helo/ehlo-command input syntax is ok
	    (in strict sense!), and that given parameter yields
	    same IP address as remote host has.
	    This may end up in policy controls, or possibly not.

2006-12-03  Matti Aarnio  <mea@zmailer.org>

	* configure.in, Makefile.in:
	    More feeding of Daniel Kiper's bits.
	    SRS related configuration environment bits

	* smtpserver/policytest.c, smtpserver/policytest.h,
	  smtpserver/smtpauth.c, smtpserver/smtpdata.c,
	  smtpserver/smtphook.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h:
	    More feeding of Daniel Kiper's bits.
	    These rewrite (in a big way) the external perl hook
	    mechanism, and with supplied sample elsewere, can
	    be used to implement hookup to e.g. PostGrey server.

2006-12-02  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtptls.c,
	  transports/smtp/smtpauth.c:
	    More feeding of Daniel Kiper's bits.
	    This might actually fix one of the occasionally observed
	    busyloops of the SMTP TA program.

	* router/Makefile.in, router/db.c, router/functions.c,
	  router/prototypes.h, router/rfc822.c, router/shliaise.c,
	  router/unvis.c, router/vis.c, include/vis.h:
	    Bit by bit feeding in  SRS support written by
	    Daniel Kiper <dkiper@netspace.com.pl>

2006-12-01  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.h, transports/smtp/smtp.c,
	  transports/smtp/smtptls.c:
	    Changed this last big user of select()  to use  zmpoll()
	    API instead.

	* include/hostenv.h, include/libz.h, include/mailer.h
	    Ugly static defines to prevent Solaris 10 from including
	    <sys/stream.h> in lowish level API calls of network stuff.

	* router/daemonsub.c, scheduler/mq2.c, scheduler/transport.c,
	  smtpserver/smtpserver.c, smtpserver/subdaemon-ctf.c,
	  smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-trk.c,
	  smtpserver/subdaemons.c:
	    On Solaris 10 the POLLIN does not happen when socket has
	    EOF condition on it!  It gives POLLHUP !

2006-11-30  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/mxverify.c, smtpserver/smtptls.c,
	  smtpserver/subdaemons.c, smtpserver/subdaemon-rtr.c,
	  smtpserver/subdaemon-ctf.c, smtpserver/subdaemon-trk.c:
	    Reworked things to use  zmpoll()  API in place of old
	    select() API.

	* smtpserver/mxverify.c:
	    Verify MX target IP addresses to be in A/B/C classes, and
	    not 0/8, 10/8, 127/8, 169.254/16, 172.16/12, 192.168/16 nets.
	    This blocks some subsets of spammers quite nicely, when
	    claimed message source address routes emails to loopback,
	    and some such cases...

	* lib/zmpoll.c:
	    Mistake in the  zmpoll_addfd():  didn't add fd=0 cases
	    into poll datasets!

2006-10-23  Matti Aarnio  <mea@zmailer.org>

	* include/libc.h, include/mail.h.in, libc/mail.c, libc/sfmail.c,
	  scheduler/msgerror.c, transports/errormail/errormail.c,
	  transports/reroute/reroute.c:
	    Use nanosecond resolution file timestamps at spoolid,
	    if available.

	* libc/inet_ntop.c, lib/killprev.c, smtpserver/policytest.c,
	  smtpserver/zpwmatch-pipe.c:
	    Appeace compiler.

	* proto/cf/aliases.cf:
	    Move interactivity shortcut test into proper place.
	    ( this permitted every sort of *-owner@domain  addresses
	      as valid ones..  after the fix, only existing ones. )

	* scheduler/scheduler.h, scheduler/mq2.c, scheduler/prototypes.h,
	  scheduler/transport.c:
	    Use  zmpoll()  in scheduler properly.
	    Dawid Kuroczko wrote first version, Matti completed things to
	    include mailq support subsystem.

2006-07-10  Matti Aarnio  <mea@zmailer.org>

	* lib/zgetbindaddr.c, transports/smtp/smtp.c, smtpserver/cfgread.c,
	  lib/Makefile.in, lib/zgetgindaddr-test.c:
	    Hunted for the non-functionality of the smtp TA's  -L  option.
	    Found out that calls and behaviours were inconsistent - now
	    the parameter is "address family" value, not magic boolean.

	* smtpserver/smtpdata.c:
	    In status-line, report last received msg "size=" value, not
	    semi-mysterious "tell=" (per UNIX syscall..)

2006-06-26  Matti Aarnio  <mea@zmailer.org>

	* configure.in, man/scheduler.8.in, router/rfc822.c,
	  lib/taspoolid.c, scheduler/msgerror.c, scheduler/scheduler.c,
	  scheduler/scheduler.h, scheduler/threads.c,
	  smtpserver/smtpdata.c, transports/libta/ctlopen.c,
	  transports/mailbox/mailbox.c, transports/errormail/errormail.c,
	  transports/reroute/reroute.c:
	    Modified the  taspoolid()  to produce nano-second resolution
	    representation of file modification time -- unfortunately most
	    real filesystems do not support such...

	* smtpserver/smtpserver.h, smtpserver/subdaemon-ctf.c,
	  smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-trk.c,
	  smtpserver/subdaemons.c:
	    Instead of "void *", so pass in a typed structure
	    so help intercept wrong declarations and usages.

2006-06-24  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h, 
	  smtpserver/subdaemons.c, smtpserver/subdaemon-trk.c:
	   Sun SUNWspro compiler v.11 practically wants all
	   global variables that signal handlers modify to be
	   of type "volatile".  --  Nope, didn't help...
	   Latter found extraneous pointer formation and usage
	   where such were not necessary and caused observed
	   misbehaviour...

2006-06-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/cfgread.c:
	    Found incorrect call to  cfg_add_bindaddr() ...
	    Routine had no ANSI prototype, thus compiler didn't
	    flag it during compile..

	* smtpserver/subdaemon-rtr.c:
	    Hunting a bad select() detection..

	* configure.in:
	    Autodetect sys/poll.h,  and  poll() functions.

	* lib/Makefile.in, lib/zmpoll.c, router/daemonsub.c:
	    Introduce internal  zmpoll()  API.

	* router/functions.c:
	    Remove internal explicite 'extern int errno';

	* transports/libta/mimeheaders.c:
	    Compiler complained about untyped (default int) function parameter.

2006-04-06  Daryl L. Miles  (forgotten commits)
	
	* smtpserver/zpwmatch-pipe.c:
	    Remember to mark wfp closed by NULLing the pointer.

	* smtpserver/smtptls.c:
	    SSL library has some local data, make our own copy of it
	    so that we can correctly free it latter..

	* utils/policy-builder.sh.in:
	    Having multiple (different) policy datasets does 
	    benefit of having an option to explicitely refer to
	    particular basename.

2006-03-25  Matti Aarnio  <mea@zmailer.org>  (forgotten commits)

	* smtpserver/smtpcmds.c, man/smtpserver.8.in,
	  proto/smtpserver.conf.in:
	    Turn opposite the meaning of 'f' and 't' style flags;
	    from now on there must be 'F' and/or 'T' style flag
	    if you do NOT want to use internal router to verify
	    MAIL FROM and RCPT TO verb addresses.

	* proto/zmailer.sh.in:
	    Run also policy-builder.sh  after  newdb in case
	    there was some source database that was used in both
	    sets.

2006-03-24  Matti Aarnio  <mea@zmailer.org>

	* include/libz.h:
	    Add the generic "struct sockaddr" into Usockaddr union
	    to be used in syscalls so that no casts are needed.

	* utils/makedb/makedb.c:
	    One (integer) parameter was not typed at all, which
	    defaulted it to be integer...  just some compilers
	    warned about this case...

	* smtpserver/cfgread.c, smtpserver/smtpserver.c, TODO,
	  smtpserver/smtpserver.h, smtpserver/subdaemon-trk.c,
	  man/smtpserver.8.in, smtpserver/subdaemons.c:
	    Half-way completed smtpserver tracker cluster protocol
	    implementation.

	* smtpserver/smtpserver.c:
	    Under some test conditions the 'stdin' file descriptor
	    talking to the smtpserver process is not the same one
	    that is under 'stdout'.

	* smtpserver/zpwmatch.c:
	    Add a note, that yes, it is perfectly normal to get
	    some compiler complaints here...

	* scheduler/scheduler.c:
	    Change scheduler's message about "should not happen"-
	    type happening with a job file.

	* man/man-index.sh, man/man-to-html.sh, doc/manual/zinstall.sgml,
	  doc/manual/zmanual.dsl, doc/manual/ztutorial.sgml,
	    Usage of Google-Analytics at ZMailer.ORG site did affect
	    slightly also publishing scripts...

2006-01-28  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpetrn.c:
	    Make the scheduler's ETRN request file creation to happen
	    within transport subdirectory tree, and be safe by using
	    mkstemp().  Previously code created it (safely) in public/
	    subdirectory, but after adding support for separation of
	    public+router+queue  and  transport  directory trees, code
	    no longer was successfull at creating the file in separated
	    transport -directory (filesystem).  Selection of use of
	    mkstemp() and only that was a bit of lazyness from my part.
	    There is different mechanism that should be used primarily
	    for ETRNs (see for smtpserver's ETRN-cluster thing,) this
	    is a backup mechanism.

2006-01-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/rfc821scn.c:
	    After years of operation, learned that bad EHLO-parameter
	    with 8-bit chars is able to crash the smtpserver in 
	    rfc821_domain() when it checks bytes (characters) being
	    in some class or other, and encounters 8th-bit-set one.
	    Everywhere else the input is pre-sanitized of characters
	    outside printable ASCII range.
	    This was observed on a 2.6.x Linux running on x86-64 hardware,
	    with the character classification table at the beginning of
	    the .data section below of which there was non-mapped range..
	    .. upon which referral a SEGV was generated.
	    
	    Made also the used character classification dataset
	    to be 'const', which it is...

	    Btw: this is NOT a SECURITY bug, code never writes into that
	    array, only reads from it, and as a result (depending on
	    multiple things in your runtime environment) may just read
	    junk, or segfault.  Gigo rule.

2006-01-03  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Version: 2.99.57.pre4

	* configure.in:
	    SASL2 needs some m4 define() macros...

	* transports/smtp/appendlet.c:
	    Couple debugging printouts fixed.

	* scheduler/transport.c:
	    Oops..  Error detection failures in select processing.
	    Correct errno/err variable use.

	* transports/smtp/smtp.h, smtpserver/smtpetrn.c:
	    OpenSSL API has changed a bit, must now explicitely
	    include  <openssl/md5.h>

2005-09-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Clean (and simplify) data input error detection.
	    Will now complain correctly about 8-bit chars, etc.

2005-09-22  Nick Briggs <briggs@parc.com>

	* smtpserver/policytest.h:
	    Missed  "HAVE_DB4"  instance definition.

2005-08-18  "Darryl L. Miles" <darryl@netbauds.net>

	* smtpserver/smtpauth.c:
	    Under SASL2 mechanisms, follow restructurings
	    a month and half ago.

2005-07-02  Matti Aarnio  <mea@zmailer.org>

	* doc/guides/smtp-msa-mode:
	    Note about document being rather obsolete,
	    and what did replace it...

	* doc/guides/smtpauth-login-pam-support:
	    Do read  smtpserver(8) man-page about these
	    details.

	* man/smtpserver.8.in:
	    Lots of revision work to update the manual towards
	    what the system implements, and how to use it.

	* proto/smtpserver.conf.in:
	    Revised and updated default file for current
	    recommended setup.

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/cfgread.c,    smtpserver/smtptls.c,
	  smtpserver/policytest.h, smtpserver/policytest.c,
	  smtpserver/smtpauth.c,   smtpserver/smtpcmds.c,
	  smtpserver/smtpdata.c,   smtpserver/smtpetrn.c,
	  smtpserver/subdaemon-rtr.c:
	    - Big restructuring, where some three dozen
	      parameters were moved into groups, and a way
	      for parameter groups to be created, and then
	      used was implemented.
	    - Allows clean(er) parametrization of TLS, and
	      AUTH setups per served port.
	    - Should still be able to parse and use configuration
	      file from years past...
	    - Realized, why 'debug' mode hung-up customer
	      interaction, and fixed it.

2005-06-30  Neal Morgan <Neal@Morgan-Systems.com>

	* smtpserver/smtpserver.c, smtpserver/policytest.h,
	  smtpserver/policytest.c:
	    Additional work on WHOSON machinery support.
	    Matti thinks that this thing is superceded by the SMTP AUTH
	    mechanisms, but if people want to use it...

2005-06-27  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c, transports/mailbox/dotlock.c:
	    Learned an error in my ways of doing dot-lock
	    acquisition -- FIRST DOTLOCK, THEN open mailbox file!
	    This harmed certain NFS users...
	    (While debugging proper dotlocking, added some debug
	     verboselog prints also...)

2005-06-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/smtptls.c:
	    Reworked the ungetc processing that recognizes, when
	    Outlook is sending SSL crypto to port other than 25
	    (and other than 465, a.k.a. SMTPS) where it should not.
	    This is mainly for handling that braindead thing, when
	    it happens at 587 a.k.a. SUBMISSION.
	    (Once upon a time it worked, but not anymore..  now
	    it works again..)

2005-06-22  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    Slight change on "In SUBMISSION mode.." error message text.

	* smtpserver.c, smtpserver.h:
	    Log the port on which the connection arrived into.
	    It is somewhat difficult to make difference of SUBMISSION
	    and plain SMTP without it...

	* man/smtpserver.8.in, smtpserver/cfgread.c,
	  smtpserver/smtpauth.c, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c, proto/smtpserver.conf.in:
	    - PARAM no-smtp-auth-on-25
	    - PARAM smtp-auth-username-prompt "..."
	    - PARAM smtp-auth-password-prompt "..."

2005-06-20  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpauth.c:
	    Add  smtp_tarpit()  calls on auth-failures...

	* smtpserver/zpwmatch-pipe.c
	    Do socket (pipe) cleanup after calls to external authentication
	    program.

2005-06-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    Log smtp-auth data into envelope meta-data so that external
	    hook programs can look into it.

2005-06-16  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8.in:
	    A bit more words about various aspects of the policy code.

2005-06-07  Matti Aarnio  <mea@zmailer.org>

	* man/router.8.in:
	    Add some words about 'relation' parameters, and auxiliary
	    configuration files for SleepyCat DB, and LDAP ...

	* transports/smtp/smtp.c:
	    Some very odd timeout handling things -- missed the need
	    for setting command timeout before each smtpwrite() call.
	    Indeed I suspect that pipelining needs a bit more complex
	    timeout level tracking...

2005-06-04  Matti Aarnio  <mea@zmailer.org>

	* transports/hold/hold.c:
	    Of course the 'hold age:nnn' had internal comparison wrong way..

2005-05-19  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/ldap.c:
	    Indicate failure, if ldap session definition, or bind fails
	    in any way.

2005-05-09  Alex Kiernan <alex.kiernan@gmail.com>

	* sfio/src/lib/sfio/sfhdr.h:
	    "I've been applying this as long as I can remember to make
	     builds work on Solaris"

2005-05-06  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Make '--disable-ndbm' and '--disable-gdbm' work as
	    their name implies.  Also have '--without-ipv6'

	* router/libdb/ldap.c
	    Integrated and debugged "ldap-new" into ldap.c.
	    Missing thing was automagic LDAP connection rebind,
	    when a lookup fails (after LDAP server restarts, or
	    connection does otherwise break.)

	* router/libdb/ldap-new.c:
	    Removed as unnecessary

	* transports/smtp/smtp.c:
	    For IPv4 the connect() used wrong size 'address-size' parameter,
	    and recently Linux systems have become lot more picky about it...

2005-04-27  Matti Aarnio  <mea@zmailer.org>

	* transports/hold/hold.c, man/hold.8.in:
	    Support holding until message age is at least specified.
	    A variation of "timeout", but in a more generic form.

2005-03-24  Matti Aarnio  <mea@zmailer.org>

	* man/smtp.8.in, transports/smtp/smtp.c, transports/smtp/smtp.h:
	    New '-O ignore-ezmlm' option.

	* transports/libta/ctlopen.c, include/ta.h,
	  transports/expirer/expirer.c, man/expirer.8.in,
	  man/manual-expirer.8.in:
	    Added optional '-u' selector for expirer to help
	    queue purge tasks in some situations, when target
	    X has lots of recipients, and only one of them is
	    failing with 400 codes and thus filling the queue...

	* smtpserver/smtpserver.c, smtpserver/policytest.h, 
	  smtpserver/mxverify.c,   smtpserver/policytest.c,
	  smtpserver/cfgread.c,    man/smtpserver.8.in:
	    - PARAM policydb-submit  -- separate DB for SUBMISSION
	    - GCC-4.0.0 fixes.

	* utils/vacation/vacation.c:
	    Match SleepyCat DB 4.1 API

	* scheduler/prototypes.h, scheduler/mailq.c:
	    GCC-4.0.0 fixes.

	* transports/smtp/smtp.c, transports/smtp/smtptls.c:
	    GCC-4.0.0 fixes.

	* transports/errormail/errormail.c:
	    Hardwire the default-form in with a bit more elegance, also
	    output all recipients on visible headers!

	* transports/libta/dnsgetrr.c:
	   Drop off  res_hnok() and res_dnok()  calls, which are
	   unnecessary in our use..

	* transports/smtp/smtp.c:
	    Debugging some suspicuous EZMLM-mode behaviour.

	* router/router.c, router/functions.c, router/prototypes.h:
	   Eliminate the need for 'struct shCmd' in prototypes.h
	   by moving a bit of code from  router.c  to functions.c.

2005-02-18  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c, transports/mailbox/mboxpath.c:
	    Versatilize -DD..  -PP..  and  -XX..   options.

	* man/mailbox.8.in, man/mboxpath.1.in, man/vacation.1.in:
	    Document better the existing machinery.

	* doc/guides/smtpserver-spf:
	    Email from Darryl L. Miles about usage of SPF.

2005-01-27  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Copy all  optarg  string data that remains in use
	    for more than getopt() loop time.

	* lib/zgetbindaddr.c:
	    Parse bindaddr data so that if we are expeciting IPv4, don't
	    accept IPv6 address text (and vice versa.)

	* smtpserver/cfgread.c:
	    Parse IPv6 and IPv4 versions of the bind-parameter addresses,
	    complain (to log) if failing somehow.
	    FIXME: Still possibly needs revising .. 

	* smtpserver/smtpserver.c:
	    Revised listening server socket creations.
	    Still sometimes failing to create listening sockets,
	    if previous smtp server instance is still around..

	* smtpserver/smtpserver.c:
	    The logfp  is possibly to be opened, and again closed
	    within the  reaper()  routine.  (Hmm..  is it _truly_
	    safe there ?   After all, the signals can arrive
	    at any time...)

	* smtpserver/mxverify.c:
	    Track debug stuff of  'mxislocal'  kind.

	* smtpserver/zpwmatch-pipe.c:
	    Note about built-in presumptions.

	* lib/selfaddrs.c:
	    different things for library function API in test-mode

	* proto/smtpserver.conf.in:
	    Add couple new examples

2005-01-03  Matti Aarnio  <mea@zmailer.org>

	* proto/db/smtp-policy.src:
	    Set the "senderokwithdns" attribute to have value "-"
	    (HARD error) instead of "+" (SOFT error).

	* smtpserver/mxverify.c:
	    Treat  dnsmxlookup() result value 2 always as a "hard error".

2004-12-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    Revert 2004-06-22 "in MSA-mode, _ignore_ 'relaycustnet +'
	    attributes" change.  It got bypassed with 2004-10-19
	    change to demand authentication in SUBMISSION/MSA mode.

2004-11-28  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c, transports/smtp/smtp.c,
	  transports/smtp/getmxrr.c:
	    IPv6 basic socket api specification update (RFC 3493)
	    has obsoleted EAI_NODATA error codes, and FreeBSD 5.3
	    has dropped it from headers...

	* smtpserver/subdaemons.c, smtpserver/smtpserver.c,
	  smtpserver/subdaemon-ctf.c, smtpserver/subdaemon-rtr.c,
	  smtpserver/subdaemon-trk.c:
	    Remove unnecessary (and in fact harmfull) SIGCHLD
	    ignoring commands.

	* router/daemonsub.c, router/router.c:
	    Disable an attempt at handling the router SEGV fault
	    reporting in a gracefull manner printing to log...

	* router/daemonsub.c, router/rfc822.c:
	    Improve router queue tracking so that it won't leak messages
	    in queue counts (or no that much) - and will reset itself
	    quick enough to be unnoticable.

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/subdaemons.c, smtpserver/subdamon-rtr.c,
	  smtpserver/subdaemon-ctf.c:
	    Cleaned error situation processing rollback,
	    and child death reaping.

2004-11-18  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpauth.c:
	    Darryl L. Miles  found a \0xB4 character in logfile
	    debug output data.  I didn't notice it myself, as my
	    display shows it nearly the same as "'".

2004-11-04  Matti Aarnio  <mea@zmailer.org>

	* proto/newdbprocessor.in:
	    Change in the way, how generated lookups are handled,
	    we have no need to NAME our passed on parameters at all.
	    Less pressure on variable lookup processing, and storage.

	* proto/cf/process.cf:
	    Remove unnecessary '\n' pair from "log info: recipients .."
	    line, thus removing unbalanced quote created in previous
	    patch.

2004-10-28  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/standard.cf, proto/cf/process.cf:
	    Decrease amount of logging.  No point in logging all
	    manner of details into the router log file.
	    Place there only things that report about BIG PROBLEMS.

	* router/daemonsub.c, include/zmsignal.h, router/router.c:
	    (about those PROBLEMS...)
	    I have seen router processes failing with SEGV, but
	    without further information, understanding and fixing
	    them is difficult.  This patch uses SIGNAL_ACTION
	    machinery to process child deaths, and report also
	    the address at which the fault happened (program counter ?
	    pointed destination ?)  This SIGNAL_ACTION is implemented
	    as a macro, and it exists only in POSIX.1 branch.
	    If your system needs something else..  well, it
	    isn't then POSIX.1 compliant and we have to start
	    thinking about it then... Probably we could just
	    ingore it..

2004-10-24  Matti Aarnio  <mea@zmailer.org>

	* libsh/listmalloc.c:
	    Profiling claimed to show, that 70% of router's time
	    is spent in running garbage collection!  EErrgh.. Uh..
	    It was being called by every 8000 newcell() calls, and
	    the count of those calls per address appears to be in
	    order of 2000-2500 per address.  Also grew the conscell
	    slab size by a factor of 16, as the trace counters have
	    shown, that heavily used system can use around 80k
	    conscells at max.

2004-10-23  Matti Aarnio  <mea@zmailer.org>

	* router/router.c, router/daemonsub.c, scheduler/scheduler.c:
	    Having hard time at profiling router .. must reset
	    the profiling timer after forks.  Attempting to make
	    the additional code profiling agnostic.  It will work,
	    if environemnt initialized profiling, otherwise it won't
	    do a thing...

	* router/router.c:
	    Unnecessarily open file found in router, too..

	* scheduler/scheduler.c:
	    Hunting unnecessarily open file-descriptors in scheduler,
	    and its TimeServer subprocess.

	* lib/zshmmibattach.c:
	    Don't keep around the file descriptor associated with
	    the opened memory segment.  It isn't needed, and uses up
	    some resource space in the system, anyway.

	* router/prototypes.h, router/rfc822.c, router/rtsyslog.c:
	    Track and report process RUSAGE (user and system CPU times)
	    if support for that is available.  Can be used to understand
	    system load developments.

	* transports/libta/mimeheaders.c:
	    Sometimes malformed messages undergoing format conversion
	    did cause smtp to drop core.  Turned out to be a mistaken
	    inclusion of the ASCII NUL into scan comparison range of
	    a string scanning.

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-ctf.c:
	    Made slight text changes to help on scanning the log
	    for appearance of internal "<subsys> DELAY %d SECONDS"
	    notes.

	* utils/policy-builder.sh.in:
	    Added a small sed-spell to remove input text line ends
	    since first '#' character in a line.  This allows now
	    adding comments on input line after initial data with
	    that '#' character:
	        example.com   # Added on 2004-Oct-23

2004-10-20  Matti Aarnio  <mea@zmailer.org>

	* transports/errormail/errormail.c, transports/expirer/expirer.c,
	  transports/hold/hold.c, transports/mailbox/mailbox.c,
	  transports/reroute/reroute.c, transports/sm/sm.c,
	  transports/smtp/smtp.c, utils/vacation/vacation.c:
	    Assign 'progname' ALWAYS before  readzenv() call !

2004-10-19  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    Report loudly (into log), when DNS lookups take more
	    than 30 seconds.

	* smtpserver/subdaemons.c:
	    There must be at least a dummy pointer init for rate-tracker, too.

	* include/shmmib.h, scheduler/mailq.inc:
	    Added couple subserver task queue tracker variables,
	    and their printouts.  These are debug stuff, but still..

	* smtpserver/smtpserver.c:
	    Note pipeline input along with lack of EHLO greeting!

	* smtpserver/smtpcmds.c:
	    Demand user to authenticate for SUBMISSION/MSA mode
	    MAIL/RCPT commands.

	* smtpserver/smtpserver.h, smtpserver/subdaemon-ctf.c,
	  smtpserver/subdaemon-rtr.c, smtpserver/subdaemons.c:
	    - Subdaemon ran sub-servers have idle-apoptosis
	    - Arrived jobs are queued in strict order of arrival,
	      and they can become revoked from the queue if the
	      client has disconnected before the job goes into
	      processing.

2004-10-07  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemon-ctf.c:
	    Match interactive content-filter call interface with
	    documented behaviour (and what the router does).

	* smtpserver/subdaemons.c, smtpserver/subdaemon-rtr.c:
	    Reworked (more carefully) of how the round-robin job
	    queueing should work.  Now there is perhaps a bit of
	    fairness in job processing.

	* man/smtpserver.8.in:
	    Document (in man-page) about the 'msgratelimit nn,mm'
	    syntax parameter.

	* smtpserver/subdaemons.c, smtpserver/smtpserver.h:
	    When having received a job from a peer, mark it in
	    a separate flag, and use that flag then to talk with
	    the processing subprograms.  Also switched back to
	    "serve first the lowest number peer fd" system.

2004-09-27  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c, smtpserver/smtpserver.h,
	  smtpserver/subdaemon-trk.c:
	    A bit more of rate-limitter updates to complete things.
	    Rate-counters now return two values instead of one, recognize
	    that in policytest.  Moved  call_rate_counter() code into
	    subdaemon-trk.c, where it is a bit more "local" stuff.

2004-09-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    Use rate-limiter ONLY to make REJECTs, don't use "not limited"
	    to mean: "acceptable!"

2004-09-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c, man/smtpserver.8.in:
	    Remove the old hard-coded '+' RBL macro that is no longer valid..
	    Also warn about RBLs being rather ephemeral in nature..

	* smtpserver/policytest.c, smtpserver/subdaemon-trk.c:
	    Some initial experiments on adding RCPT counting in
	    rate-tracking.

	* smtpserver/subdaemon-rtr.c:
	    Report (into log) if the i-router subsystem response
	    time exceeds 30 seconds.

	* smtpserver/subdaemons.c:
	    Change a bit of the round-robinny processing details.
	    It may (or may not) improve sometimes observed long
	    delays..

2004-09-10  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemons.c:
	    Changed the client input pickup methodology back into
	    "prefer lowest slot" (instead of round-robin).
	    It just didn't work :-(  (probably broken logic
	    somewhere in there..)

	* smtpserver/smtpchild.c:
	    Account childs by type, not all together..  (oops..)

2004-09-09  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemon-rtr.c:
	    Changed subprocess instance abstraction details
	    so, that there are no absolutely fixed array sizes.

	* smtpserver/subdaemons.c:
	    Changed processed client input pickup methodology into
	    "process in round-robin manner" (as opposed to "lowest
	    slot first -- which can be seriously pessimal approach.

2004-09-07  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c:
	    Source DNS verification went into woods a bit...
	    If the intention is to accept the MAIL FROM, if
	    it has just any DNS data, do so.

2004-09-06  Matti Aarnio  <mea@zmailer.org>

	* include/mailer.h, include/libz.h, lib/rfc822scan.c,
	  router/functions.c, router/prototypes.h, router/rfc822.c,
	  router/rfc822hdrs.c, router/shliaise.c:
	    Removed all vestiges of detecting '#' at the lead of
	    the address lines, and considering it as an indication
	    of a comment.  Doing that comment-skipping in callers,
	    where appropriate at all.

	* scheduler/mq2.c, scheduler/mailq.inc:
	    Added (into the scheduler's "MAILQ -QQQQ" processing)
	    a way to call external arbitrary command, whose output
	    is collected into the command output.  This allows
	    "easy" addition of custom system monitoring data
	    into the output.  Something will get added into "contrib".

2004-09-05  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    Realized that under some conditions it is possible to
	    spin in place of the automagic "this rcpt domain is
	    my local".

2004-09-03  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemons.c, smtpserver/smtpserver.h,
	  smtpserver/subdaemon-ctf.c, smtpserver/subdaemon-rtr.c:
	    Always watch for subdaemon client connection readability,
	    and do read it.  If it yields EOF, kill the peer..

	* router/router.c, router/router.h, router/rfc822.c:
	    Slight alteration in router's unremovable console
	    logging..  now it can be removed with '-l' option.

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-ctf.c:
	    SIGTERM reaction corrections in "clients" when talking
	    (or trying to) with the subdaemon.

	* smtpserver/smtpserver.c:
	    Make the SMTP speaker loop to obey SIGTERM, and to
	    drop everything it was doing... (gracefull death of
	    server instance.)

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/smtpchild.c:
	    Do classfull connection accounting statistics.

	* smtpserver/smtpserver.c:
	    setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY, (void*)&on, sizeof(on))
	    (if available, binds the IPv6 socket only to v6 version
	     of the protocol port, not v4+v6 combined space!)

	* smtpserver/subdaemons.c:
	    Process customer inputs in fair round-robin manner.
	    Otherwise customers who have gotten lowest socket
	    numbers might just dominate the server, and those
	    that have higher numbers would starve.

2004-08-22  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, man/smtp.8.in:
	    Added  -1  option to order SMTP connection shutdown after
	    every message delivery.  This isn't quite the same thing,
	    as "one MAIL-transaction per connection" under all operational
	    conditions (e.g. if 'listexpand's' EZMLM-mode is used) but
	    it definitely is for all normal cases.

2004-08-20  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtphook.c, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c:
	    If the "my_perl" flag is not set, don't even let procedure
	    stack init (macro embedded) codes to run in hooks.
	    Call  ZSMTP_hook_set_ipaddress()  at the start of the
	    smtpserver() function loop.

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtptls.c, smtpserver/smtpcmds.c, smtpserver/smtpauth.c:
	    Reworked the 'with' clause data presentation in style of
	    the RFC 3848.

2004-08-12  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemons-ctf.c:
	    Eugene crosser noted two buglets in subdaemon
	    communication protocol processing.

	* smtpserver/smtpserver.c, man/smtpserver.8.in,
	  proto/smtpserver.conf.in:
	    Added a POSSIBILITY to report contacting IP address
	    literal in the initial 220 greeting line.

2004-08-04  Matti Aarnio  <mea@zmailer.org>

	* configure.in, man/smtpserver.8.in, proto/smtpserver.conf,
	  smtpserver/cfgread.c, smtpserver/policytest.c,
	  smtpserver/policytest.h, 
	    Igor Milyakov sent some new SPF related patches.

	* smtpserver/mxverify.c, smtpserver/policytest.c,
	  smtpserver/smtpserver.c, smtpserver/subdaemon-rtr.c:
	    Ran "gcc -ansi -pedantic"  and got a bunch of warnings.
	    This tries to fix most of those.

	* router/libdb/ldap-new.c:
	    Experimental fixes, and updates from Jeff Warnica.
	    He asked this to be stored into some other file,
	    rather than into baseline of ldap.c.

2004-07-14  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Version 2.99.57.pre3

	* smtpserver/smtptls.c:
	    Dist-cache disabled compilation fixed.

	* smtpserver/smtphook.c:
	    A bit work to please the compiler (to silence it, that is)

	* configure.in, smtpserver/smtptls.c:
	    Know  --enable-distcache  -- code modelled after
	    the one in Apache-2.0 mod_ssl module.
	    (Distributed Session Cache)

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/smtpauth.c, smtpserver/smtphook.c,
	  smtpserver/smtp-perl-hooks.pl.in:
	    First write-thru of perl-hooks for smtpserver.

2004-07-11  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/cfgread.c,
	  smtpserver/policytest.c, smtpserver/smtpauth.c,
	  smtpserver/smtphook.c,   smtpserver/smtpserver.h:
	    More of perl-hook machinery.

	* smtpserver/policytest.c:
	    Reorganized  pt_mailfrom()  logic.

	* smtpserver/smtpserver.c, smtpserver/smtpauth.c,
	  smtpserver/smtpserver.h:
	    Treat whoson result equal to authentication
	    (to some extent.)

2004-07-10  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpchild.c,
	  smtpserver/smtpserver.c, smtpserver/subdaemons.c:
	    Child reaper/reap-tracker changes to manage
	    detecting death of subdaemons, and to report it,
	    and even restart them.

	* smtpserver/smtpserver.c:
	    logfile tagging logic changes to tag more stuff
	    from master.

	* smtpserver/smtpcmds.c:
	    Reply message ENHANCEDSTATUSCODES massage.

	* smtpserver/smtphook.c:
	    A bit more of hook stuff..

	* man/smtpserver.8.in:
	    Add couple words about socket-type content-filter
	    interface.

2004-07-09  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemons.c, smtpserver/subdaemon-ctf.c:
	    Contentfilter interface to socket required some
	    additional fixes.  Waiting for a report from Eugene.

	* proto/cf/aliases.cf:
	    Third try to get Eugene Crosser's DOMAIN_AWARE_GETPWNAM
	    to work correctly..  (I applied the thing by hand, and
	    were sloppy reader :-( )

	* smtpserver/smtpcmds.c, smtpserver/smtpserver.c:
	    When i-router replies a message, do issue its possible
	    ENHANCEDSTATUSCODE value in proper position of the reply
	    (in addition to the "Hi [1.2.3.4]," prefix..)
	    Also added several of those messages, and moved the
	    "boo boo, you are in our blacklists" replies around
	    so that a microsoft user getting only the last reply line
	    from the server will get something usefull.

	* configure.in, smtpserver/Makefile.in, smtpserver/policytest.c,
	  smtpserver/smtpserver.h, smtpserver/smtphook.c:
	    Added begins of embedded perl hooking into smtpserver so that
	    folks can install their own policy stuff, as they want..
	    THIS IS NOT YET USABLE!

	* smtpserver/policytest.c:
	    Moved 'state->authuser' check onwards within  pt_mailfrom().
	    And added hardwired 'verify that mail from domain does exist'
	    into it.

2004-07-08  Matti Aarnio  <mea@zmailer.org>

	* configure.in, smtpserver/cfgread.c, smtpserver/policytest.c,
	  smtpserver/smtpdate.c, smtpserver/policytest.h, 
	  smtpserver/smtpserver.h:
	    SPF_ALT to SPF2 library support migration.

	* smtpserver/cfgread.c:
	    SPF parameter parsing bug fix from Eugene Crosser.

2004-07-07  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Version 2.99.57.pre2

	* configure.in:
	    New:  --with-resolvlib="-L ... -R ... -lxxx"
	    Allow manual definition of linking-time of possibly
	    esoteric resolver library name, and linking rules.

	* include/libsh.h, libsh/interpret.c, router/daemonsub.c:
	    Moved  traphup()  prototype into  libsh.h, and
	    fixed wait() prototype in interpret.c.

2004-07-06  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemon-rtr.c:
	    Compiling in Solaris  with Sun CC shows subtle bugs..
	    (of dead code, removed it)

	* proto/cf/server.cf, proto/cf/aliases.cf, proto/cf/rrouter.cf:
	    No more using  $(dequote .. )  function, but using
	    explicite patterns in  ssift  clauses to handle couple
	    forms of quoted localparts.

	* libsh/execute.c, libsh/listutils.c:
	    Found dangerous code deep inside the execute.c handling
	    stream redirections under some esoteric conditions.

	* smtpserver/Makefile.in, router/Makefile.in, snmp/Makefile.in,
	  utils/vacation/Makefile.in, utils/makedb/Makefile.in:
	    Rearranged library specifications so that --generic-lib=
	    parameters will lead the linking (in case -L is used!)

	* libsh/trap.c, router/daemonsub.c:
	    Noticed that in Solaris the master router leaves zombies.
	    This is a bit uncertain attempt at handling that by regularly
	    collecting all zombies, and instantiating processing vectors.
	    Eventually:  wait4(-1 ..) is wrong, correct is:  wait4(0 ..)

	* libsh/trap.c:
	    Nick Briggs reports odd compiler things on Solaris
	    with Sun compilers in strict ANSI mode...  I tried
	    to introduce safe fallbacks.

	* smtpserver/mxverify.c, smtpserver/policytest.c,
	  smtpserver/policytest.h:
	    Hunted down (finally) conditions of when MX testing
	    lets thru something into %-hack

2004-07-01  Matti Aarnio  <mea@zmailer.org>

	* router/db.c:
	    In some situations we leaked db lookup keys into memory.
	    Plugged that leakage hole.

2004-06-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Found a long-lurked bug in reporterr().
	    It did refer to wrong data in Solaris -> SEGV.
	    Oops..  Corrected printf()-like parameters, and
	    now it should not fault.  This happened in
	    the tail of failing SMTP session, so it didn't
	    matter for message reception.

2004-06-22  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c:
	    Move the verbose-tracing a bit earlier in the processing.

	* router/rfc822.ssl:
	    Remains of an attempt to modify the local-part address
	    semantics...  Not a success :-(

	* router/lib/header.c:
	    Change parsing rules for envelope headers.

	* smtpserver/policytest.c:
	    When in MSA-mode, _ignore_ 'relaycustnet +' attributes.
	    Will then always demand user to authenticate!

	* smtpserver/rfc821scn.c:
	    Deep reading of RFC 2821/2822 did show, that we had
	    a wee bit wrong type encodings for '"', '.', and '@'.
	    Corrected those, and under non-strict conditions did
	    modify the parsing to allow e.g.:  .foo.@example.com

	* smtpserver/smtpserver.c:
	    At the star of incoming session, report (into log) also
	    the PID of the running smtpserver process.  Helps to debug
	    couple odd problems that I have seen.

	* smtpserver/subdaemons.c:
	    Error-code  EBADFD  is something that exists only at Solaris,
	    and at Linux, not at FreeBSD..

2004-06-02  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    Fixed the rate-tracker to function again.
	    For a while the rate tracker responses were just ignored...

2004-05-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemons.c:
	    After exec()ing actual subdaemons, the  subdaemon_nofiles
	    variable must be reinitialized -- doing it in
	    subdaemons_loop() now.

2004-05-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c:
	    Report the content-filter result message as single message,
	    if at all possible.

	* smtpserver/subdaemon-ctf.c:
	    Detect and process EOF from subdaemon subserver correctly.

2004-05-11  Matti Aarnio  <mea@zmailer.org>

	* utils/vacation/vacation.c, man/vacation.1.in:
	    Experiment a bit with attempting to reply with
	    the address that the message came in with.
	    (Pick: user, orcpt, inrcpt   in that order.
	     Last found stays in effect.)

	* utils/vacation/vacation.c, man/vacation.1.in:
	    Make the code to match the man page (-r option),
	    then realized that -t option document matches
	    current behaviour..   Anyway, 1.00 days is much
	    better default interval.

	* include/libz.h, lib/parseintv.c:
	    Change the passed parameters to be of 'const' type.
	    This code does not alter them.

2004-05-10  Matti Aarnio  <mea@zmailer.org>

	* router/router.c, router/shliaise.c, proto/cf/standard.cf:
	    Change the router's log thingie to log with
	    spoolid, instead of message-id.

2004-05-09  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtptls.c:
	    Detect if there is known EOF coming up in read pipe.
	    This is meaningfull to check in case we are very early
	    in SMTP session, and somebody is feeding us spam...

	* smtpserver/policytest.c, smpserver/smtpauth.c:
	    Compiler said "uname might be used uninitialized"..
	    Actually it is not used in the policy code
	    either, but that is another story...

2004-05-08  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/subdaemons.c:
	    For Solaris environemnts...  start the smtpserver's
	    subservers via execl(), actually does it for all
	    environments, but still...

	* include/shmmib.h, scheduler/scheduler.c,
	  transports/mailbox/mailbox.c, transports/smtp/smtp.c,
	  transports/expirer/expirer.c, transports/errormail/errormail.c,
	  transports/hold/hold.c, transports/sm/sm.c,
	  transports/reroute/reroute.c:
	    Changed SHMMIB area variables all to be of "volatile" kind.

	* smtpserver/smtpcmds.c, 
	    Changed report output a bit, don't give router output
	    directly to type() as a format string.

	* smtpserver/smtpserver.c:
	    Implement  zsleep()  by means of calling select(2).

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemons.c:
	    Reworked subprocess error (EOF) processing a bit.
	    Perhaps now dying router will automagically recover
	    loosing only the session currently underway.

2004-05-07  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/cfgread.c, smtpserver/subdaemons.c,
	  man/smtpserver.8.in, proto/smtpserver.conf.in:
	    Change the tarpit parameters to be of 'double'
	    type, instead of 'int'.  Allows slower growth
	    of the exponent value..  Also do sleep()s
	    with  select().  Also tuneup of tarpit calls.
	    They are not used in all rejects...

	* smtpserver/kissig/*:
	    Removed old code predating present policy material.

2004-05-04  Matti Aarnio  <mea@zmailer.org>

	* router/functions.c:
	    In  rfc822syntax  do report errors to stderr ONLY
	    if the system is tty interactive!

2004-05-02  Matti Aarnio  <mea@zmailer.org>

	* proto/smtpserver.conf.in, smtpserver/cfgread.c,
	  smtpserver/policytest.c, smtpserver/policytest.h,
	  smtpserver/smtpauth.c, smtpserver/smtpserver.h,
	  smtpserver/subdaemon-trk.c:
	    - Track the number of FAILED SMTP AUTHs, and refuse
	      to do any if there are too many failures from given
	      IP address.  This is, of course, somewhat troublesome
	      under some conditions -- one user can cause DoS for
	      others...  But avoids password breaking oracle service.
	    - Count _all_ RCPTs, not just accepted ones..
	    - Count data-aborts too.

	* lib/symbol.c:
	    When called upon NULLing the internal default
	    symbol database that hasn't been initialized,
	    just _don't_.  Otherwise NULL referral leads
	    to madness .. and core files..

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtpetrn.c:
	    Something bothered me in variable names,
	    and I changed one.  I added "Hi <remoteip>, .."
	    for many error messages to aid troublesome
	    host pickup by means of simple grepping...

2004-04-30  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8.in, proto/smtpserver.conf.in,
	  smtpserver/cfgread.c, smtpserver/smtpserver.h,
	  smtpserver/subdaemon-rtr.c:
	    Cloned content-filter interaction machinery
	    also into router interactions, now there
	    can be multiple instances of the router
	    if single isn't enough..  By default there
	    can be 2 i-routers.

	* smtpserver/smtpserver.h, smtpserver/subdaemons.c:
	    "Test and debug before release..."  Damn..
	    Ok, now that subdaemon_send_to_peer() works.
	    At the same time reworked the peer buffer
	    allocations to happen _late_, that is, when
	    a peer interaction is created, not at boot..
	    Shrinks server memory consumption considerably.

	* smtpserver/subdaemons.c: subdaemon_send_to_peer()
	    Internal code was .. not my best writing.
	    Rewrote it to be somewhat more sane..

	* smtpserver/subdaemon-trk.c:
	    When outputing the "Z-REPORT DUMP", start it with datetime,
	    and end it with data line count..  Similar with SIGUSR1
	    processing.

	* smtpserver/subdaemons.c:
	    Deep within fdgets() a read(2) call did yield EBADFD,
	    treat that as "EOF", and let auto-recovery handle it.

	* smtpserver/smtpserver.h:
	    Shrunk memory block pre-allocated for each potential
	    client from 7 kB to about 3 kB.  In systems with 1024
	    as "ulimit -n", this shrinks process image by 4 MB...

	* smtpserver/policytest.c, smtpserver/subdaemon-trk.c:
	    Styling beauty-warts, and correcting internal
	    communications primitives to match client, and
	    server to each other...

	* smtpserver/smtpreport.c:
	    When processing the authorization file, turn on root-powers
	    to access the file, then return into trusted mode.

	* include/libsh.h, include/splay.h, lib/splay.c,
	  lib/symbol.c,libsh/interpret.c, libsh/zmsh.c,
	  router/db.c, router/libdb/hreader.c, router/libdb/incore.c,
	  scheduler/mailq.c, scheduler/msgerror.c,
	  scheduler/prototules.c, scheduler/qprint.c,
	  scheduler/readconfig.c, scheduler/scheduler.c,
	  scheduler/threads.c, transports/mailbox/mailbox.c:
	    Changed the API of  sp_scan()  function, especially
	    the API of the CALLED function f.  Now can supply
	    an opaque (to splay) parameter that is passed on to
	    item processor.   (Eliminated a bunch of static globals
	    from all over the code...)

	* transports/mailbox/mailbox.c:
	    Reworked the rwhois/rbiff related splay-code.
	    Not so sure if it is _correct_, as I don't use it anymore
	    anywhere...  It _should_ be ok, but I have done mistakes
	    before...

	* transports/smtp/smtp.c:
	    Don't burn cycles to CNAME map MAIL FROM domain..
	    That isn't absolutely necessary...  Still doing
	    RCPT TO domain CNAME mapping.

	* smtpserver/subdaemon-trk.c, smtpserver/policytest.c:
	    - Format fixes
	    - Don't log Z-REPORT replies into smtpserver log file.

2004-04-28  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/subdaemon-ctf.c,
	  smtpserver/subdaemon-rtr.c, smtpserver/subdaemon-trk.c,
	  smtpserver/subdaemons.c:
	    Modify underlying details in fdgets() handling to use
	    larger read() operations, than 1 byte at the time..
	    This gives slight speedup, ... well, at least nicer
	    kernel call traces...

	* smtpserver/Makefile.in, smtpserver/contentpolicy.c,
	  smtpserver/mxverify.c, smtpserver/policytest.c,
	  smtpserver/policytest.h, smtpserver/smtpcmds.c,
	  smtpserver/smtpdata.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h, smtpserver/subdaemon-trk.c:
	    - Reworked parameters of the policy related functions
	      to use only one state variable pointer.
	    - Add accounting of recipients of messages in
	      addition to the counting of messages.
	      Won't (yet) have _limit_ on number of recipients..
	
	* smtpserver/subdaemon-rtr.c:
	    The interactive router complained in manual
	    test mode.  Perhaps should develop a fallback
	    interactive router mode for these test things.

2004-04-27  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Noticed, that after "550" rejection at connection,
	    the system still did print out "220 " greeting line.
	    Adding couple grouping brackets solved that thing.

	* smtpserver/smpserver.h,
	  smtpserver/smtpreport.c, smtpserver/policytest.c,
	  smtpserver/subdaemon-trk.c, man/smtpserver.8.in:
	    - Added a "z-report uu pp dump" subcommand, that
	      does pretty much the same as SIGUSR1, but over
	      the SMTP channel.
	    - Track number of excesses, if a user _ever_
	      exceeds his/her ratelimit, then that IP will
	      be forever in tracking.

	* smtpserver/subdaemon-ctf.c:
	    Some oddball core-dumps being eliminated..

	* proto/cf/SMTP.cf.in, proto/cf/SMTP+UUCP.cf.in,
	  proto/cf/TELE-FI.cf.in, proto/cf/UTAI.cf,
	  proto/cf/UTGPU.cf, proto/cf/UTdefault.cf.in:
	    Copied better comments from UT*.cf files
	    into standard SMTP and SMTP+UUCP templates.
	    Tweaked all files slightly.

2004-04-23  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/rrouter.cf:
	    Bug in treatment of addresses where the domain part
	    has IP address literal:  local@[1.2.3.4]
	    The net result was scary attempt of execution of
	    commands that have names like:  "1.2.3.4",
	    which naturally always failed resulting failure
	    of doing detection of intended "this is local IP
	    address in this system".

2004-04-22  Matti Aarnio  <mea@zmailer.org>

	* SiteConfig.in, man/man-index.sh, man/smtpserver.8.in:
	    More man-page style editing.  The result is nice to read..
	    (and oddly a bit TeXish in feel...)

	* smtpserver/policytest.c, smtpserver/subdaemon-trk.c,
	  man/smtpserver.8.in:
	    Improved  "Z-REPORT"  command verb processing.
	    Document for it is in the man-page..

	* smtpserver/subdaemon-ctf.c, smtpserver/subdaemons.c:
	    Don't (conditionally) start any sort of content-filter.

	* man/smtpserver.8.in, man/Makefile.in:
	    Produce the PDF files via DVI file route.
	    The resulting file is _a_lot_ nicer to look at!

2004-04-20  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8.in, proto/smtpserver.conf.in:
	    Document "PARAM contentfilter-maxpar 2".

	* smtpserver/subdaemons.c, smtpserver/subdaemon-ctf.c,
	  smtpserver/cfgread.c:
	    Run parallel contentfilters in case one isn't
	    enough..  Startup code side-effect is that when
	    one is needed, _max_set_ will be started.
	       "PARAM contentfilter-maxpar nn"
	    limits the number of parallel started contentfilters.
	    Hard-limit inside the code is 20, above which this
	    parameter can not increase the number of CFs.

2004-04-19  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/contentpolicy.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h, smtpserver/subdaemon-ctf.c:
	    Cleaning the new contentfilter interface, dead
	    code, etc.

	* transports/smtp/smtp.c:
	    Slight change in outbound EZMLM mode MAIL FROM
	    addresses; added spoolid on the generated "local-part".

	* man/scheduler.8.in, man/smtpserver.8.in:
	    Document editing; Z-REPORT ACL explanation,
	    although not result explanation...
	    Smtpserver's document updates.

	* smtpserver/contentpolicy.c, smtpserver/policytest.h,
	  smtpsever/smtpserver.h, smtpserver/subdaemon-ctf.c:
	    Rearranged things so that content-policy happens
	    under the centralized management daemon of its own.
	    Presently only one ContentFilter instance can be
	    running there, which might be a wee bit too little..

	* smtpserver/subdaemon-trk.c:
	    Report tracking slot allocation age in addition to
	    the total number of MAILs ("RATE"s) queried at it.
	    (If the tracking never yields all slots zero, then
	    the entry may get rather old, and the MAILs count
	    very high...)

	* smtpserver/smtpserver.c:
	    Renamed "IDENT" to "Z-IDENT", and "DEBUG" to "Z-DEBUG".

	* smtpserver/smtpserver.c:
	    Code rearrange; K&R doesn't like some C99 things..

	* smtpserver/subdaemon-trk.c:
	    Unused variables, and occasional lack of init..

2004-04-16  Matti Aarnio  <mea@zmailer.org>

	* include/shmmib.h, smtpserver/smtpreport.c,
	  smtpserver/Makefile.in, smtpserver/smtpserver.h,
	  smtpserver/policytest.h, smtpserver/policytest.c,
	  smtpserver/subdaemon-trk.c:
	    Created  "Z-REPORT <user> <password> IP 1.2.3.4" command
	    into SMTP responder that will query the internal rate-tracker
	    server for more details about rating counters.
	    (Won't say a thing about _limits_ at all!)
	    Can use  scheduler.auth   file for user+password+ACLs,
	    no need to have separate file..

	* smtpserver/smtpcmds.c, smtpserver/smtptls.c:
	    Extra White-space sloppy-scanner fixes.

	* smtpserver/policytest.c:
	    SPF api tracking fix from Eugene Crosser.

	* smtpserver/cfgread.c, 
	    Implemented  BindSmtp, BindSmtpS, BindSubmit PARAMs for
	    the system.  Also PARAM report-auth-file.

	* man/smtpserver.8.in, proto/smtpserver.conf.in:
	    - Update the sample  smtpserver.conf  to match current
	    - Mention new  BindSmtp/BindSmtpS/BindSubmit PARAMs, and
	    - PARAM report-auth-file ...

	* proto/cf/server.cf, smtpserver/smtpcmds.c:
	    Do support running HELO/EHLO string thru the interactive
	    router...  although that isn't all the most brightest
	    thing to do...  (nor the example router script really
	    works at all..)

	* scheduler/mq2.c, scheduler/mq2auth.c, scheduler/prototypes.h,
	  smtpserver/smtpreport.c:
	    Revised somewhat the  scheduler.auth  file parsing, and
	    reused same code (AND SAME DATA FILE!) for ACLs of
	    various things.

	* scheduler/prototypes.h, scheduler/scheduler.c,
	  scheduler/transport.c:
	    Reworked the 'mailq' TCP socket binding somewhat.
	    Depending on system modes, IPv6 binding may or may not
	    support also IPv4 connections.  Handling that by creating
	    at first the IPv6 socket bound on any6/mailq port, and then
	    a IPv4 socket is attempted to bind of  any/mailq.
	    If the IPv4 doesn't bind successfully, will be using
	    IPv6 listening socket for everyhing.

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    Reworked the listen socket binding codes.
	    Background includes abovementioned IPv4 vs. IPv6 issues.

	* lib/selfaddrs.c:
	    Instead of casting, use Usockaddr pointer.

	* lib/zgetbindaddr.c, lib/zgetifaddress.c:
	    - Added magic literals: "any", "any6"
	    - Noticed several deficiencies in address pickup at least
	      of Linux IPv6 kind.. (link-local isn't very usefull...)

	* proto/post-install.sh.in:
	    A bug report from  Volker Stolz  about typo in
	    $POSTOFFICE  directory creation (I always have that
	    as its own filesystem -> never noticed this one...)

	* lib/prversion.c:
	    Update the integrated year...

2004-04-14  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf:
	    Finally did the fix that Eugene Crosser pushed me to do
	    for quite a while..  Damn typo.

	* smtpserver/policytest.c, smtpserver/policytest.h:
	    - Internal rcpt_nocheck variable is not set
	      anywhere -> dead code
	    - Make SMTP AUTH, and 'full_trust' to be exactly equal
	      (they were similar, now they are equal)
	    - Make WHOSON equal to 'always_accept' processing
	      (now that 'always_accept' has been demoted slightly
	       to make various possibly rejecting checkups before
	       accepting the message.)

2004-04-12  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/server.cf:
	    Do "db flush expansions"  and "db flush hostexpansions"
	    for all "from" and "to" addresses at start.

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemons.c:
	    Remove a bunch of debugging printouts.

	* lib/fdpassing.c, smtpserver/smtpserver.h:
	    Do proper includes for <fcntl.h>

	* router/daemonsub.c, router/prototypes.h, router/router.c,
	  smtpserver/subdaemon-ctf.c, smtpserver/subdaemon-rtr.c:
	    Handle gracefully subdaemon router process death,
	    (and have it die gracefully.)

	* router/router.c, proto/cf/server.cf:
	    Automated 'server purge' every about 1000 interactions.
	    Also call 'server init' before start.

	* lib/fdpassing.c, lib/zshmmibattach.c, subdaemon-rtr.c:
	    Add a few  fcntl(fd,F_SETFD,FD_CLOEXEC)  calls into
	    selected places so that exec()ed subprocesses won't
	    inherit undesirable filehandles.

	* include/libz.h, transports/mailbox/mailbox.c,
	  transports/mailbox/mboxpath.c:
	    Match prototypes of crc32() and pjwhash32() properly..

	* router/daemonsub.c, router/functions.c, router/prototypes.h,
	  router/router.c, include/libsh.h, libsh/builtins.c,
	  router/db.c:
	    Couple additional fixes on memory allocation/free strategies.
	    Improved memory recycling, freeing objects no longer needed.
	    (Also cleaning up a bit of extern declarations..)

	* smtpserver/policytest.h, smtpserver/subdaemon-trk.c:
	    Oops..  Reserved too small buffer for IPv6 address
	    hex storage. (Used in rate-tracking.)

	* include/libz.h:
	    Publish prototypes for crc32*() functions.

	* include/io.h:
	    Allow selective io-redirection disabling

	* router/router.c,  man/router.8.in, proto/cf/aliases.cf,
	  proto/cf/fqdnaliases.cf, proto/cf/server.cf,
	  router/functions.c, router/prototypes.c:
	    Created  -Ismtpserver  function mode, that calls
	    the router script interpreter's  "$(server ..)" function
	    in definitely secure manner.  This is for use under
	    new smtpserver's router interaction logic.
	    Also created  $(isinteractive)  script function, that
	    can be used in short-circuiting potentially lengthy
	    expansions that are not really interesting in this mode.

	* router/router.c, router/router.h, router/daemonsub.c,
	  router/Makefile.in, router/dateparse.c, router/db.c,
	  router/functions.c, router/prototypes.c, router/rfc822.c,
	  router/rfc822hdrs.c, router/rfc822walk.c, router/rtsyslog.c,
	  router/shliaise.c:
	    Created "router.h"  and used it as only include file
	    for all source files.

	* smtpserver/contentpolicy.c, smtpserver/policytest.c:
	    Minor edits.

	* smtpserver/smtprouter.c, smtpserver/Makefile.in:
	    Killed the file.  All the functionality went into
	    subdaemon-rtr.c  file.

	* smtpserver/smtpserver.c:
	    Removed vestiges of router running as a sub-process of
	    current SMTP interaction instance.

	* smtpserver/smtpserver.h:
	    Couple new prototypes, plus handling fd_set passed as
	    a pointer.

	* smtpserver/subdaemon-rtr.c, smtpserver/subdaemons.c
	    Running one interactive router sub-instance under the
	    multiplexing server.  Possibly need to have more ???

	* smtpserver/subdaemon-trk.c, smtpserver/subdaemons.c:
	    Moved  fdgets()  function into subdaemons.c file
	    (common use..)  Added non-blocking operation mode for it.

2004-04-09  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Move the subdaemons_init() again.  Place it now right
	    after becoming stand-alone daemon right before creating
	    listening sockets.

	* smtpserver/subdaemon-ctf.c:
	    Minor coding style edit (use calloc() instead of
	    malloc+memset).

	* smtpserver/subdaemon-trk.c:
	    Add timeout handling into fdgets() code.  The intention
	    being, that system not responding properly within user-
	    supplied time-limit can be detected.

	* smtpserver/subdaemons.c:
	    Rework subdaemon forking code to properly close client-end
	    of the rendezvous-sockets within the subdaemons.  Don't close
	    quite every possible file descriptor, but do close several..

2004-04-08  Matti Aarnio  <mea@zmailer.org>

	* doc/guides/smtp-policy:
	    Document somewhat about the "ratelimitmsgs 300" attribute
	    pair.

	* include/shmmib.h, scheduler/mailq.inc:
	    Store, and print PIDs of these subdaemons.

	* smtpserver/subdaemon-trk.c:
	    Security-first; unlink() target dump file name,
	    then open it exclusively.

	* smtpserver/policytest.c:
	    Store into log file the result that the ratetracker gave.

	* smtpserver/policytest.c, smtpserver/policytest.h,
	  smtpserver/readpolicy.c:
	    - Rearranged MAIL FROM processing code, allowing rate-limit
	      to be used, as well as reworking things in IP address space
	      (where its variables need to be set..)
	    - Enabled compiling policy rulesets with 'ratelimitmsgs nnn'
	      settings.

	* smtpserver/smtpserver.c:
	    Moved subdaemons_init() a bit latter than previously..

	* smtpserver/subdaemon-trk.c, smtpserver/subdaemons.c:
	    Testing and debugging until it begun to work, and die
	    after all tracking clients have disconnected, and not
	    die at weird moments, and ...

	* include/libz.h, lib/fdpassing.c:
	    - Modify the call interface to always support only
	      bidirectional pipe kind of thing.  One fd for the client
	      side, one for the server side.  Not two.
	    - The fdpass_sendfd() returns now 0 for successfull send
	      (that is, sendmsg syscall), and -1 for other situations.

	* include/policy.h, smtpserver/policytest.c,
	  smtpserver/policytest.h, smtpserver/policydata.c,
	  smtpserver/smtpserver.h, smtpserver/subdaemon-trk.c:
	    First scriblings on how to make one fully functional
	    subdaemon server (rate-tracker), but it is still
	    missing some intermediate bits and pieces...

	* include/splay.h, lib/splay.c:
	    Convert the splay block (spblk) to be slab-allocated
	    cellish thing (like conscell:s in router) along with
	    a chain of free spblk:s in the stree chain.

2004-04-05  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/subdaemon-ctf.c, smtpserver/subdaemon-rtr.c,
	  smtpserver/subdaemon-trk.c, smtpserver/smtpserver.c,
	  smtpserver/subdaemons.c:
	    Split the growing file into smaller slices...

2004-04-04  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Version label: 2.99.57-pre1

	* include/netdb6.h, lib/fdpassing.c, libc/fullname.c,
	  libc/myhostname.c, router/libdb/ndbm.c, smtpserver/cfgread.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c, ssl/ssl.c,
	  router/libdb/yp.c:
	    Some SunPro C-compiler warnings silenced...

	* smtpserver/subdaemons.c, smtpserver/Makefile.in,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    Coding subdaemon-server subsystem; initial steps,
	    not yet in use in any form or shape...

	* proto/post-install.sh.in:
	    Do CONDITIONALLY create individual subdirectories
	    inside the $POSTOFFICE  when called.  E.g. if a directory
	    does already exist, don't remake it, but possibly make
	    its subdirectories!

	* lib/fdpassing.c:
	    Pass a fd thru a given handle to another process.

	* scheduler/pipes.c -> lib/pipes.c,  scheduler/resources.c ->
	  lib/resources.c, include/libz.h, scheduler/prototypes.h,
	  router/daemonsub.c, lib/Makefile.in, scheduler/Makefile.in,
	  router/Makefile.in:
	    Moved the pipes.c, and resources.c files from scheduler/ to
	    lib/,  it has uses outside the scheduler, after all...

2004-04-01  Matti Aarnio  <mea@zmailer.org>

	* README.UPGRADING, include/libz.h, include/shmmib.h,
	  lib/fdstatfs-test.c, lib/fdstatfs.c, lib/zshmmibattach.c,
	  router/rfc822.c, scheduler/mailq.inc, scheduler/scheduler.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtpserver.c:
	    - new gauges tracking the number of i-nodes available/used
	      in various partitions where ZMailer has activity.
	      (If those filesystems are separate to begin with...)
	      (Spending reserved spaces in the memory block, no
	       need to change block magic numbers :) )
	    - allowing split of $POSTOFFICE into two separate
	      filesystems, although "transport/" MUST be mounted
	      as  $POSTOFFICE/transport/ !

2004-03-31  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/gdbm.c, router/libdb/ndbm.c, router/db.c:
	    Hunting strange memory corruptions, which turned out to
	    be my own mistakes from about 20 hours ago...  Damn.

	* proto/scheduler.conf.in:
	    Add  "smtp-par/*"  clause, explicite parallellism
	    to be used, if postmaster so desires (to some target
	    where there is lots of traffic...)

	* router/libdb/gdbm.c:
	    Eugene Crosser reports odd gdbm database opening problems
	    in, and I see the same in Solaris, but not in Linux...
	    Adding now some extra debug stuff to see what goes wrong.
	    .. Looks like 'make clean; make' would help ?
	    My own Solaris problem was bad ZENV setup.

	* include/sleepycatdb.h, lib/sleepycatdb.c, man/smtpserver.8.in,
	  smtpserver/policytest.h, smtpserver/policytest.c:
	    Dot in some notes about SleepyCat DB RPC mechanisms..
	    More is yet in "TO DO" list...
	
	* router/libdb/bsdbtree.c, router/libdb/bsdhash.c:
	    Do a bit more elaborate comparison set on database alteration
	    from underneath ourself.

	* utils/perl/Makefile.in,  configure.in:
	    More hoops to get perl setup parameter feed in,
	    and to make installation into non-root DESTDIR=
	    to succeed.

	* configure.in:
	    Accept environment variables  LIBDB3,  LIBDB4,  which
	    have effect if system has  <db3/db.h>  and  <db4/db.h>
	    headers, respectively.

	* router/libdb/gdbm.c:
	    Urgh, folks have repeatedly told me that this gdbm
	    interface leaks fds like no tomorrow..  I finally
	    tried it myself, and it was ... most educative.
	    Looks like sip->dbprivate datablock introduction
	    code mutation was never completed.

	* router/libdb/ndbm.c:
	    Did same code mutation as gdbm.c has, and completed it
	    all in one go..  (compile tested in Solaris 8)

	* libsh/isterminal.c, libsh/execute.c, libsh/sslwalter.c,
	  include/libz.h:
	    New  z_isterminal(fd)  function.  If it yields false,
	    execute.c will cry out missing external program with
	    LOG_EMERG level message.

	* configure.in:
	    AC_HEADER_CHECK(termios.h)

2004-03-19  Matti Aarnio  <mea@zmailer.org>

	* TODO, lib/sleepycatdb.c:
	    Add some markers for RPC access mode; work to be done...

	* packaging/rpm/README-RPM, packaging/rpm/zmailer.spec:
	    Xose Vazquez  sent some updates.

	* proto/cf/fqdnalias.cf, proto/cf/p-routes.cf:
	    Differentiate route lookup (especially for DEFAULT)
	    in between 'sender' and 'recipient' modes.

	* man/smtpserver.8.in, proto/smtpserver.conf.in,
	  smtpserver/cfgread.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h:
	    Contact-pointer message tunability feature into
	    smtpserver from Eugene Crosser.


2004-03-11  Matti Aarnio  <mea@zmailer.org>

	* utils/makedb/makedb.c, utils/makedb/dblook.c,
	  lib/sleepycatdb.c, smtpserver/policytest.c:
	    Support for SleepyCat DB 4.2

	* smtpserver/policytest.c:
	    "TrustWhosOn" shotgun patch from
	    ("Neal Morgan" <Neal@Morgan-Systems.com>)
	    Another patch from Eugene Crosser to
	    add back a (state->always_accept) test.
	    Which one of those now does the fix ?
	    Hmm..

	* config.h.in, configure.in, include/policy.h,
	  man/smtpserver.8.in, proto/smtpserver.conf.in,
	  proto/db/smtp-policy.src,  smtpserver/Makefile.in,
	  smtpserver/cfgread.c, smtpserver/policytest.c,
	  smtpserver/policytest.h, smtpserver/readpolicy.c,
	  smtpserver/smtpdata.c, smtpserver/smtpserver.h:
	    Eugene Crosser <crosser@rol.ru> sent big
	    patch for implementing SPF in ZMailer.
	    I don't quite agree with the ideas in
	    SPF, but...

	* transports/smtp/appendlet.c:
	    sfputc() alone does never indicate EOF,
	    that must be checked explicitely!
	    (Andrey Blochintsev <bag@iptelecom.net.ua>)

	* include/zmclib.c, lib/zmclib.c:
	    A work-in-progress of librarizing multicast communication
	    setup things.  The darn thing is _very_ complex, when one
	    must handle multiple interfaces, including talking MC
	    somewhere, where system default MC routes don't point
	    to... (e.g. some backend lan..)

	* proto/cf/aliases.cf:
	    Eugene Crosser found out that I had been wrong all along..
	    "bug in treating of domain_aware_getpwnam"

	* proto/cf/aliases.cf:
	    MailMan 2.0.5 integration scripts from 
	    Xose Vazquez Perez <xose@wanadoo.es>

	* snmp/README.NET-SNMP, snmp/Makefile.in, snmp/mta.h,
	  snmp/mibs/MTA-MIB.txt, snmp/mibs/ZMAILER-MIB.txt,
	  snmp/mibs/.index, snmp/mibs/NETWORK-SERVICES-MIB.txt,
	  snmp/mta_columns.h, snmp/mta_enums.h, snmp/mta.c:
	    Work in progress, can't say much yet...


2003-11-29  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf, proto/cf/fqdnaliases.cf,
	  proto/db/dbases.conf, proto/cf/crossbar.cf, proto/db/userdb,
	  proto/cf/crossbar.cf:
	    Went thru details about 'userdb' processing, and why the
	    'user:mailname' things didn't produce public results.
	    Support is present for mapping  user+foo  to
	    user.name+foo@domain  thru %-substitution.

	* transports/smtp/appendlet.c:
	    Slipped a brain-fart into this code during the earlier
	    "Don't use BDAT every time" thing.  Oops!
	    The bug: Failure to do the "dot-duplication" algorithm
	    in DATA mode for non text/plain messages!  :-(

2003-11-27  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/ldap.c:
	    Found a sneaky typo - for some reason my compilations
	    don't compile LDAP by default :-(

2003-11-24  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtpauth.c:
	    Suspend logging on '-l' file as well as verbose-log,
	    while writing the secret on outgoing SMTP stream.

2003-11-23  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtpauth.c, TODO:
	    Testing, and correcting the -A option 'smtpauth()'
	    processing while feeding test messages to
	    Cyrus IMAP 2.2.2 (BETA) server.  Interesting beast this...
	    PROBLEM: Reveals in  -l  option file, as well as  verboselog
	    the outgoing _secret_ data in authentication!

	* proto/cf/router.cf, proto/cf/server.cf, proto/cf/SMTP.cf.in:
	    Changes In order to get one system to report straight from
	    'routes' database an entry like following:
	      foo.dom  error!nosuchuser!explanation text here
	    straight into online router processing, like:
	      554 5.0.0 unresolvable address <...>; nosuchuser; explanation txt

	* man/smtp.8.in, transports/smtp/smtp.h, transports/smtp/smtp.c,
	  transports/smtp/Makefile.in, transports/smtp/smtpauth.c,
	  doc/guides/cyrus-imap:
	    Initial write-through of simple SMTP client authentication
	    against selected remote clients - this is intended to be
	    used under some sort of protection, like TLS, or very least
	    within a protected network.  Indeed it is only written to
	    work against Cyrus IMAP LMTP server over loopback network.

2003-11-21  Xosé Vazquez Peres  <xose@wanadoo.es>

	* proto/cf/aliases.cf:
	    mailman-zmailer integration.

2003-11-21  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8.in, smtpserver/smtpserver.c,
	  smtpserver/smtpauth.c, smtpserver/smtpcmds.c,
	  smtpserver/smtpdata.c:
	    Created "-s sloppy" runtime option to turn
	    on fully sloppy behaviour with no expection
	    to get HELO greeting, nor "<"/">" pair in
	    email addresses.

2003-11-20  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Don't use BDAT mode, if the message size estimate
	    is larger, than our outgoing BDAT buffer Chunk-Size.

	* proto/scheduler.conf.in, scheduler/msgerror.c,
	  scheduler/readconfig.c,  scheduler/prototypes.h,
	  transports/errormail/errormail.c, man/scheduler.8.in,
	  man/errormail.8.in:
	    Added "PARAMstore-error-on-error = 1" parameter
	    into the scheduler.  And added "discard error-on-error"
	    cases into errormail.

	* configure.in, router/daemonsub.c:
	    Buggy (in Solaris et.al.) autoconf of  dirfd()  thing
	    in they fchdir() callbacks.   Probably should redo
	    the thing somehow differently...  (This is for users
	    of  ROUTERDIRHASH=1  and multiple  ROUTERDIRS  directories.)

	* scheduler/msgerror.c, transports/errormail/errormail.c:
	    Add "Return-Path:" data label into produced
	    error messages.

2003-11-18  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Mark the version as  2.99.56  (finally!)

2003-11-16  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf:
	    More patches from Eugene Crosser (actually something
	    I omitted by accident when applying things manually;
	    as in "retyping" ..)

	* smtpserver/policytest.c:
	    Moved target specific rejects early -- so that we can
	    reject some targets even for cases where e.g. message
	    source IP address carries "relay all thru us".

	* transports/smtp/smtp.c:
	    More of wrong return code hunting.
	    It turns out, that reopening has been done without
	    resetting MX index, and that omission caused in some
	    case at some targets the reopen to fail with fatal
	    error code.

2003-11-07  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Tracked connection restart problems, specifically against
	    HOTMAIL, which runs things in highly questionable manner,
	    but that may happen with other systems, too.
	    (Apparently HM hangs up the inbound smtp connection
	    right after receiving end of previous message.)

	* compat/sendmail/sendmail.c, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c, smtpserver/smtpcmds.c:
	    - When 'sendmail' is called with '-bs' option, let it
	      call the subsequently started  smtpserver as:
	      "sendmail-smtp-in".
	    - Don't call policy database functions, when the program
	      isn't being run under a network socket.

2003-11-07  Eugene Crosser  <crosser@rol.ru>
             
	* proto/cf/aliases.cf:
	     Define "sysuser" variable that is either "user" or
	     "user@domain". Use this as argument to 'homedirectory' and
	     'login2uid' functions that ultimately call getpwnam()

	* proto/cf/server.cf:
	    Strip off domain part of "user" variable only if getpwnam()
	    is not domain-aware.  As far as I can tell, this variable  
	    is unly used in 'login2uid' and 'fullname' functions.

	* transports/mailbox/fmtmbox.c:
	    If getpwnam() is domain-aware, pwd->pw_name may contain
	    username@domain; but we need to compute hash of local part
	    only, because otherwise hash("user@mydomain.com") and
	    hash("user") would differ, and "defaultdomain" feature would
	    break.  "address" is always the local part (domain has been 
	    cut off before).

	* transports/mailbox/mailbox.c:
	    If DOMAIN_AWARE_GETPWNAM=1, do not rfc822localize() the user,
	    just strip off quotes in case they are present (no syntax 
	    check here, just delete any double quote that is not
	    backslash-escaped).  Thus further zgetpwnam() will be called
	    on user with domain.

2003-11-06  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c, smtpserver/policytest.c:
	    More of Mariano's question analysis.
	    Found out that I were slightly too paranoid about
	    T_TXT object length, and actually cut back one char
	    from all objects.  Now will log lookup results
	    into smtpserver's commentary side-stream.

	* smtpserver/mxverify.c, smtpserver/policytest.c:
	    Mariano Absatz wanted DNS RBL tests (results, at least)
	    to be logged into smtpserve log.

	* smtpserver/readpolicy.c:
	    Looked deeper into policy database compilation process.
	    Behold; sysadmin can create attributes that are TOO LONG.
	    Now the sysadmin can't.  Pattern compilation will fail
	    at such.

2003-11-05  Andrey Blochintsev <bag@iptelecom.net.ua>

	* smtpserver/readpolicy.c:
	    Allow '_' prefixed user names to be used.

2003-11-04  Matti Aarnio  <mea@zmailer.org>

	* router/daemonsub.c:
	    Well, things weren't proper for tasks in the primary router
	    directory.  My testing was with alternates...

	* smtpserver/policytest.c:
	    Roy Bixler reported that his smtpserver does hang up
	    when processing (rather long) DNS BL datasets.
	    It turned out that policy compiler uses unsigned char
	    for various things, including attribute length (thus
	    up to 255-2 is ok for an attribute data), but my interpreter
	    referred to it as signed char, and things larger than 127
	    became negative in length all the sudden...

	* configure.in, SiteConfig.in:
	    From Eugene Crosser:  Configure system-wide  SYSLOGFLG=,
	    SNMPSHAREDFILE=, and  DOMAIN_AWARE_GETPWNAM= ZENV variables.

	* configure.in:
	    Test and determine, how one can find out the FD associated
	    with  opendir() target object. To be used in  router process,
	    when a   fchdir()  is needed.

	* libc/mail.c, libc/sfmail.c:
	    A wee bit of adaptations to compile the beast in Windows
	    (cygwin, that is..)

	* proto/cf/process.cf, router/daemonsub.c, router/rfc822.c:
	    Support input files going into ROUTERDIRHASH= sublevel,
	    and don't do unnecessary rename()s if the original file
	    has proper name ( = i-node number in decimal ) already.
	    The   process   function may get scalled as:
	      process B/123456
	    which is now perfectly legal.
	    NOTE: The daemon subsystem will do file locking on the
	    original file for the duration of file staying in the
	    processing!

2003-10-26  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/ldap.c:
	    Patches to support LDAPv3 (via option setting)
	    thru a  "protocol 3" line in the configuration file.

2003-10-07  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtptls.c:
	    In some rare occasions the discipline processor loops
	    forever in errno processing, when it has received an
	    EINTR during a syscall.

2003-10-03  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Compressed logged commentary lines a bit.
	    Remote host reversed name, and its actual IP address
	    are listed in same line.

2003-10-01  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    When outputing commentary data to spool file, quote
	    all chars outside normal printable ASCII range, and
	    some inside it...

2003-09-27  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Changed the  --without-ldap   to   --with-ldap
	    and worked a bit in other internal related things.

2003-09-26  Matti Aarnio  <mea@zmailer.org>

	* include/mail.h.in, libc/mail.c, libc/sfmail.c:
	    New variants of *mail_close*() functions, now
	    can control the asynchronity of the close()
	    thing.  Essentially controlling use of  fsync(2)
	    on outgoing spool file descriptor.

	* man/scheduler.8.in, proto/scheduler.conf.in,
	  scheduler/msgerror.c, scheduler/prototypes.h,
	  scheduler/readconfig.c, scheduler/scheduler.c:
	    Added  "PARAMmsgwriteasync = 1" option that
	    can control the asynchronity in mail.c/sfmail.c
	    library routines.

	 * transports/smtp/smtp.c, man/smtp.8.in:
	     From Andrey Blochintsev <bag@iptelecom.net.ua> an option
	     to allow connection to IP addresses of the same host.

2003-09-25  Matti Aarnio  <mea@zmailer.org>

	* configure.in, router/db.c, router/libdb/gdbm.c,
	  router/libdb/ldap.c:
	    - A bunch of "--without-*" things:
	    	    --without-ndbm
		    --without-gdbm
		    --without-ldap
	      To disable some autodetections.
	    - Removed traces of SDBM autoconfig;
	      a once-upon-a-time replacement for NDBM.

	* smtpserver/smtpcmds.c:
	    When reporting various rejections, do report also
	    peer IP address.  This to help some analysis, and
	    to some extent, to help users.

	* configure.in:
	    - Default builtin value for SCHEDULEROPTIONS is
	      now changed to  "-S -H".
	    - Fixed a missing comma from  --with-perl-installdirs
	      option parameter processing.
	    - Added some AC_MSG_RESULT()s about NDBM library
	      pickup processing.

	* proto/cf/fqdnaliases.cf:
	    One instance of  $(listexpand .. ) call needed
	    "-N -" parameter as not to do DSN expansions.

	* proto/forms/delivery
	    - Added "ADR Bcc: <nobody>" to drain  errors-on-error
	      reports.
	    - Made small URL change

	* utils/perl/Makefile.in:
	    Removed (from 'install' target) explicite PREFIX=
	    value setup. Possible PREFIX= value can be set
	    thru configure time  --with-perl-installdirs="..."
	    parameter.

2003-09-09  Matti Aarnio  <mea@zmailer.org>

	* configure.in, utils/perl/Makefile.in:
	    have  --with-perl-includedirs="INCLUDEDIRS=vendor"
	    option at configure time.  It seems to be usefull
	    (or at least working) thing at RedHats, but the same
	    doesn't hold true with all other perl environments
	    that I use...

2003-09-08  Matti Aarnio  <mea@zmailer.org>

	* man/Makefile.in:
	    Replaced (in 'make install' target) literal
	    'zm' suffix in files with '$Z' substitution.

	* man/aliases.5.in, man/newaliases.1.in,
	  man/smtpserver.8.in:
	    Man-page text updates.

2003-09-05  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Patch from Jerzy Sobczyk about outgoing SMTP not
	    always honouring '-h' option set local hostname
	    in outbound EHLO/HELO greetings.

2003-09-03  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/contentpolicy.c:
	    Patch from Eugene Crosser to run be able to run
	    content-filter as an AF_UNIX socket server.

2003-09-02  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/appendlet.c:
	    Oops, readalready processing bug.

	* transports/sm/sm.c, transports/mailbox/mailbox.c:
	    Code rearrangements during verification job that
	    similar bugs don't exist as in appendlet..

2003-09-01  Matti Aarnio  <mea@zmailer.org>

	* scheduler/prototypes.h:
	    Change 'const char *log;' to 'const char *logfn;'

	* utils/perl/Makefile.in:
	    Deeper study of what to do in perl module compilation.
	    Now  "make install DESTDIR=.." parameter should have
	    real effect in the underlying  Makefile.PL  files.

	* transports/libta/ctlopen.c:
	    One test of  ta_use_mmap  was slightly wrong, and
	    end result was faulty  let_buffer()  initialization.

2003-08-29  Matti Aarnio  <mea@zmailer.org>

	* debian/*
	    Debian packet builder scripts from 
	    Xose Vazquez Perez <xose@wanadoo.es>

	* include/libz.h, lib/zgetbindaddr.c, scheduler/transport.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/cfgread.c, transports/smtp/smtp.c:
	    Added third parameter into  zgetbindaddr()  function,
	    namely: what address family should be used ?
	    Entry parameter is: AF_INET / AF_INET6 (0 == AF_INET)
	    That is needed for  "iface:..." binding mode.

	* utils/smtpserver-log-parser.pl.in:
	    Found a bug in the 'pid-parser', changed the RE patterns,
	    and system that formerly leaked a lot of memory does now
	    only a little bit..

	* man/scheduler.8.in:
	    Fixed a typo in  PARAMauthfile= document.

	* proto/smtpserver.conf.in:
	    Documentary comment changes in the end of the file
	    in the 'style-flags' section.

2003-08-28  Matti Aarnio  <mea@zmailer.org>

	* man/Makefile.in, SiteConfig.in, man/zmailer-conf-generate.pl,
	  man/mailq-m-generate-pl:
	    New generator (zmailer.conf.5zm), and typo fix in the old.
	    Also source changes in SiteConfig.in  which is used as
	    input for the  zmailer.conf.5zm  file.

	* configure.in, transports/libta/ctlopen.c, SiteConfig.in:
	    Change the  --with-ta-mmap  to control what  SiteConfig
	    file (and thus  zmailer.conf  file) gets about TA_USE_MMAP=
	    variable value.

	* man/*:
	    Massive rework of man-pages; all cross-references will
	    be using suffix names like:  (8zm).  Man-sections got
	    "zm" tagged to them to ease the placement into various
	    systems, like with 'inn' that has 'sm.8' ...

	* smtpserver/contentpolicy.c, smtpserver/smtpdata.c:
	    - Typo in debug texts of contentpolicy filter harness.
	    - Small default-text code rearrangements in smtpdata.c

	* man/man-to-html.sh:
	    Apparently we can be without 'groff -c' option, and still not
	    get colour output to produced HTML..   Oh yes, that was when
	    using '-Thtml' output driver.  Present HTML generation uses
	    '-Tascii' and magic state processor to convert produced
	    (with occasional escapes) text file into fixed width courier
	    font HTML.

2003-08-26  Matti Aarnio  <mea@zmailer.org>

	* proto/smtpserver.conf, smtpserver/smtpcmds.c:
	    In prototype smtpserver.conf: comment away 'localhost'
	    case with 'f' and 't' flags.  People do get surprises
	    when using those, and skipping some notes in INSTALL.
	    ALSO: Made 'enable_router' to semi-silently to control
	    even looking into router controlling flags.  If router
	    is not enabled, it is not complained about.

	* SiteConfig.in,  include/ta.h, transports/libta/ctlopen.c,
	  transports/libta/lockaddr.c, transports/mailbox/mailbox.c,
	  transports/sm/sm.c, transports/smtp/smtp.h,
	  transports/smtp/smtp.c, transports/smtp/appendlet.c:
	    Changed compile time configured  TA_USE_MMAP  feature
	    to runtime configured  ZENV variable  TA_USE_MMAP,
	    whose existence uses the thing, and nonexistence
	    does read message into limited size internal buffer...
	    ACTUALLY TESTED CODES ARE: 'mailbox' AND 'smtp'.
	    THE 'sm' IS NOT TESTED AT THIS POINT!

2003-08-25  Matti Aarnio  <mea@zmailer.org>

	* utils/makedb/makedb.c, utils/policy-builder.sh.in:
	    Code crashed in case the input wasn't like it was wanted..
	    Oops.

	* smtpserver/policytest.c, doc/guides/smtp-policy,
	  man/smtpserver.8.in, proto/db/smtp-policy.src:
	    Document editing, and at policytest.c: localizing
	    pbuf[] variable to its actual use.
	  
	* transports/smtp/smtp.c:
	    Conditionalize one ESMTP_STARTTLS referral, that
	    was added recently.

2003-08-22  Matti Aarnio  <mea@zmailer.org>

	* proto/db/smtp-policy.src:
	    Couple comments on input syntax.

	* utils/policy-builder.sh.in, utils/makedb/makedb.c:
	    "makedb -p" crashed in some situations, fixed
	    NULL referral.  Also report about exit code of
	    the makedb  in  policy-builder.sh  script.

	* configure.in:
	    Version 2.99.56.pre9

	* smtpserver/smtpserver.h, smtpserver/cfgread.c,
	  smtpserver/contentpolicy.c, smtpserver/smtpdata.c,
	  man/smtpserver.8.in:
	    Support multiline replies from the content-policy program.
	    Separator in between lines is '\r' (CR) character!

	* Makefile.in:
	    Added target "make autoconf" -- to help myself...

2003-08-22  gettextize  <bug-gnu-gettext@gnu.org> / Matti Aarnio

	* configure.in (AC_CONFIG_FILES), aclocal.m4, config.sub,
	  config.guess. config.rpath, include/gettext.h, po/*, m4/*
	  ABOUT-NLS, intl/*:
	    Ran  "gettextize --c --intl", and did what it told to do.
	    Introduced also m4/ directory.

2003-08-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/contentpolicy.c:
	    One extra newline in comment logging into a file.

	* transports/mailbox/mailbox.c:
	    Didn't always yield diagnostics for the outgoing
	    messages.  My bad..  (EDQUOT processing in particular.)

	* transports/libta/diagnostic.c, include/ta.h:
	    Make sure we always have NOTARY 'action' value
	    set for something!

2003-08-20  Matti Aarnio  <mea@zmailer.org>

	* libc/Makefile.in, libresolv/Makefile.in, man/Makefile.in,
	  utils/Makefile.in, utils/makedb/Makefile.in,
	  utils/mxverify/Makefile.in, utils/perl/Makefile.in,
	  utils/vacation/Makefile.in:
	    DESTDIR= defined where it overrides inherited
	    thing from environment.  Don't define it!

2003-08-19  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Moving variable 'int s' into places where
	    it is actually used.

2003-08-15  Matti Aarnio  <mea@zmailer.org>

	* sfio2002/*
	    Removing the entire tree, won't be using that one,
	    way too much demanding stuff, like threads...

	* man/smtpserver.8.in, smtpserver/cfgread.c,
	  smtpserver/smtpauth.c, smtpserver/smtpserver.h:
	    A bit more of SASL related things.
	    Added "PARAM sasl-mechanisms ...", copied a bit
	    more of sendmail code into here, and used it.
	    Still my tests failed to login...

	* scheduler/scheduler.c:
	    Jerzy Sobczyk reported bug in 'Z' option processing

	* smtpserver/smtpserver.c, smtpserver/smtpauth.c,
	  smtpserver/smtpserver.h,  man/smtpserver.8.in,
	  proto/smtpserver.conf.in, smtpserver/Makefile.in,
	  smtpserver/cfgread.c:
	    Complete the  Cyrus-SASL-2  code integration,
	    quite experimental yet!
	    In early tests the SASL library appears to use
	    /dev/random,  which is very bad news...

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/cfgread.c, man/smtpserver.8.in:
	    Support multiple instances of  "PARAM BindAddr"
	    Also massive code rearrangement around the primary
	    accept() call.

	* smtpserver/smtpdata.c:
	    Use  smtp_tarpit()  calls instead of local own response
	    delayer..

	* include/policy.h, smtpserver/readpolicy.c,
	  smtpserver/policytest.c, smtpserver/policytest.h,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:	  
	    Eugene Crosser's IP source configurable maxparallelipconnects

	* proto/zmailer.sh.in:
	    Couple typos in -Z/--zconfig parameter passing

	* router/db.c, router/libdb/ldap.c, configure.in:
	    Synced to be in par with OpenLDAP 2.1.25, should also
	    work with older ones.

	* proto/cf/aliases.cf, proto/cf/fqdnaliases.cf:
	    Support (convert!)  (.+)--(.*)  in place of  ([^+]+)\+(.*)

	* scheduler/scheduler.c:
	    Move the first getzenv() call to be after readzenv() call,
	    if any.

	* smtpserver/rfc821scn.c:
	    Comment away an unused variable.

2003-07-23  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.c:
	    Found a likely reason for scheduler's file descriptor
	    leakage..    The sfio-package does something wrong in
	    odd case used in log-file re-opening, and filehandle
	    recycling.

	* scheduler/scheduler.c:
	    Don't unlink the message file in case its opening fails.
	    (Like when scheduler/system has ran out of fd's)

	* scheduler/mailq.c:
	    Count also files in the $POSTOFFICE/queue/, and show it,
	    if it
	
	    _differs_ from  $POSTOFFICE/transport/  count.
	    Changed also slightly the output texts, which _MAY_
	    affect some management scripts!

2003-07-01  Matti Aarnio  <mea@zmailer.org>

	* doc/guides/smtp-policy, proto/smtpserver.conf.in,
	  proto/db/smtp-policy.src:
	    Typo fixes

	* transports/libta/ctlopen.c, transports/libta/mimeheaders.c,
	  transports/smtp/smtp.c:
	    Semi-meaningless changes to assist trace debugging of
	    memory leaks.  No idea if that finds my last 1-2 % of
	    memory leaks that I still see...

2003-06-27  Matti Aarnio  <mea@zmailer.org>

	* README.LICENSES, LICENSES/README, LICENSES/ARTISTIC,
	  LICENSES/BSD, LICENSES/GPL-2, LICENSES/LGPL-2:
	    Clarifying the license issues of ZMailer.

2003-06-25  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Changed version number to more RPM-friendly one, e.g. no
	    hyphen in it.

	* transports/smtp/smtp.c:
	    The  getmxrr()  calls in cname_lookup() did leak AI and NAME
	    objects.  Freeing collected (and unneeded) data there.

2003-06-24  Matti Aarnio  <mea@zmailer.org>

	* configure.in, scheduler/mailq.inc, scheduler/mailq.c,
	  scheduler/mq2.c:
	    Auto-config test to find  getloadavg()  function
	    (BSD, Solaris 8, Linux, ... a de-facto API for this
	    data, in libc !)  and to print  1 and 5 minute
	    load-averages into the scheduler's "mailq -M"
	    report.

	* transports/libta/diagnostic.c, transports/smtp/getmxrr.c:
	    Moving variable declarations around a bit, and not doing
	    initializations for NULLs/zeroes, thus letting things
	    to be placed into BSS instead of initialized read/write
	    data segment.

2003-06-22  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/mimeheaders.c:
	    Last detected memory leak in header parsers.

2003-06-21  Matti Aarnio  <mea@zmailer.org>

	* include/ta.h, transports/libta/ctlopen.c,
	  transports/libta/diagnostic.c, transports/libta/mimeheaders.c:
	    More memory leak tracking related work.  Most fumbling in
	    the dark, I am afraid..

2003-06-20  Matti Aarnio  <mea@zmailer.org>

	* include/ta.h, transports/libta/ctlopen.c,
	  transports/libta/Makefile.in, transports/sm/sm.c,
	  transports/smtp/smtp.c, transports/mailbox/mailbox.c,
	  transports/hold/hold.c, transports/errormail/errormail.c,
	  transports/expirer/expirer.c, transports/reroute/reroute.c:
	    Removed  rp->routermxes  field, data format parsing, and
	    support calls for it from system.  It never materialized
	    fully, and is weaker method, than original (not materialized
	    either) X-or recipient addresses..

	* transports/mailbox/mailbox.c, transports/sm/sm.c,
	  transports/smtp/appendlet.c:
	    Still tracking memory leaks.  Apparently the SFIO library
	    doesn't free up memory in all cases.  Namely  sfnew()
	    call has a bit of problems, especially when  sfdisc() sets
	    processing discipline, and likely reallocs buffer..
	    Now altering code to use heap based static buffers.
	
2003-06-19  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c, router/functions.c:
	    - Removing dead code (lots of it)
	    - Reworked a bit the  reject()  function address processing,
	      now also the originally intended error recipient will
	      receive the message. (Thanks to Peter Ip to raise my
	      attention at it.)
	    - All router internal  mail_open()  calls are wrapped with
	      runastrusteduser()/runasrootuser() calls, so that created
	      message file's owner will be 'trusted'.  Is THAT an ok
	      thing in all situations ?  No definite idea...

	* proto/cf/standard.cf:
	    Rearranged the list of known top-level domains, and added
	    'info', 'biz', 'name', 'eu'.
	
	* transports/mailbox/mailbox.c, transports/libta/mimeheaders.c,
	  transports/libta/ctlopen.c:
	    Been hunting memory leaks...  Have found a bunch more..

	* transports/smtp/smtptls.c:
	    When there was no logging file of any kind, this used to
	    send TLS related diagnostics to the scheduler's log, which
	    didn't work very nicely in one of my systems..
	    Now changed so that if there is verbose-log, printouts
	    go there, and independent of that, if there is smtp
	    transport-agent log,  printouts go also there.
	    If there are neither, nothing is printed.

2003-06-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    If MAIL FROM test had  'rejectsource -' and/or
	    'freezesource -'  attributes in  'user@do.main'
	    lookup, disable lookups of those same things from
	    fallbacks of 'do.main'  lookup.

	* transports/mailbox/mailbox.c, transports/libta/mimeheaders.c,
	  include/ta.h, transports/smtp/smtp.c:
	    Track a bit more of allocated memory chunks, and provide
	    explicite free() routines for them. (Hunting originally
	    memory leaks in  mailbox.)

	* transports/mailbox/mailbox.c, man/mailbox.8.in:
	    Added option "-F edquot"  to instantly fatalify quota-exceed
	    condition of the baseline code.

	* libc/getaddrinfo-test.c:
	    Another test-harness..

2003-06-09  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Mark version 2.99.56-pre7

	* include/libz.h, include/shmmib.h, lib/fdstatfs-test.c,
	  lib/fdstatfs.c, lib/zshmmibattach.c, router/daemonsub.c,
	  scheduler/mailq.inc, scheduler/scheduler.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtpserver.h:
	    - When wanting to add used spool space gauges into
	      SHM segment header, realized that it does not have
	      32 spare uint variables..  Oops..  Had to change
	      block layout -> new MAGIC, full rearrancement of all
	      so far accumulated small counters, etc..
	    - renamed  fd_statfs()  into  free_fd_statfs(), and
	      added a cousin for it:  used_fd_statfs().  Both return
	      space in kilobytes (e.g. can describe up to 2 TB...)
	    - Removed  RT.StoredRecipients  gauge, which the router
	      can't maintain anyway.

	* lib/fdstatfs.c, lib/zshmmibattach.c, scheduler/scheduler.c,
	  smtpserver/smtpserver.h, smtpserver/smtpcmds.c,
	  smtpserver/smtpdata.c, smtpserver/smtpserver.c:
	    Changed the  fd_statfs()  to report KILOBYTES of free space,
	    while still returning it via mere 'long' variable in all
	    systems (e.g. may have limit of LONG_MAX a.k.a. around 2 G,
	    which in kilobytes means: around 2 Terabytes ..)
	    Also re-juggled codes using this free-space data.

	* man/Makefile.in, man/mailq-m-generate.pl, scheduler/mailq.inc,
	  man/man-to-html.sh, man/mailq.1.in:
	    Generating "mailq-m(5)" man-page from within mailq.inc
	    stored XMLish comments.

	* include/shmmib.h, router/daemonsub.c, router/rfc822.c,
	  smtpserver/smtpserver.c, smtpsserver/smtpdata.c:
	    - Count router process faults explicitely
	    - Let smtpserver to count attempted incoming recipients
	      (similarly with ss.ReceivedMessages counter)
	    - Let smtpserver to count instances, when arriving
	      connection has been summarily closed due to too high
	      a load.  (Limit criterias are PARAM parametrizable.)
	    - Track router actual job processing instances failing
	      somehow, and count those separately. 

2003-06-05  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mailq.inc:
	    Print added seen EHLO-capability counters, and sent SMTP
	    options counters.

2003-06-04  Matti Aarnio  <mea@zmailer.org>

	* include/shmmib.h, smtpserver/smtpcmds.c,
	  transports/smtp/smtp.c:
	    Count several ESMTP options seen, (and used) by the smtp-ta,
	    and used by the smtp clients.

	* include/shmmib.h, scheduler/mailq.inc, smtpserver/smtptls.c,
	  transports/mailbox/mailbox.c, transports/smtp/smtp.c,
	  transports/hold/hold.c, transports/errormail/errormail.c,
	  transports/sm/sm.c, transports/expirer/expirer.c,
	  transports/reroute/reroute.c:
	    Changed names of a number of variables, and added basic
	    counters into all transport agents, which didn't have
	    anything.

	* Makefile.in, compat/Makefile.in, doc/Makefile.in,
	  lib/Makefile.in, libc/Makefile.in, libident/Makefile.in,
	  libmalloc/Makefile.in, libresolv/Makefile.in, libs/Makefile.in,
	  libsh/Makefile.in, man/Makefile.in, proto/Makefile.in,
	  router/Makefile.in, scheduler/Makefile.in, sfio/Makefile.in,
	  smtpserver/Makefile.in, ssl/Makefile.in,  utils/Makefile.in,
	  transports/Makefile.in:
	    "make mostlyclean" -- clean everything except SFIO library.
	    (Which is stand-alone in itself..)  This is side-result from
	    SHMMIB-block tunings.

	* configure.in, proto/zmailer.sh.in, transports/sm/sm.c,
	  transports/smtp/smtp.h, transports/smtp/smtp.c,
	  transports/mailbox/mailbox.c:
	    While going over some unrelated things, spotted
	    mentions about mailbox "From " header syntax details.
	    Its presumed syntax is very particular, and needs
	    care with correct values.  Particular danger is of
	    getting some odd system-wide locale setting to wreck
	    proper date presentation rules.  Best solution would
	    most likely be to open-code the presentation of time,
	    instead of using  ctime(3), but ...

2003-06-02  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Wondering, if we are sometimes missing closing of
	    smtp sessions in SMTP transport agents.  Just in case
	    we do, added an   atexit()  mechanism to handle it.
	    Latter experiments of shutting down the scheduler, and
	    observing that eventually the outgoing socket gauges
	    do go to zero..  all is thus well.

2003-05-30  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mailq.c:
	    Just before closing the MAILQ-v2 command socket, do
	    send there "QUIT\n" command too!  Sure the EOF handles
	    the cleanup too, but ...

	* scheduler/mq2.c, scheduler/mailq.pl, scheduler/update.c:
	    Andrey Blochintsev <bag@iptelecom.net.ua>  sent patch
	    to implement "KILL MSG" type functionality via the MAILQ-v2
	    socket command.  Client to implement it is in (surprise),
	    the perl-testbench of MQ2...  Yours Truly did small style
	    edits (like C99/C++ style "//" comment change to "/*" )

2003-05-29  Matti Aarnio  <mea@zmailer.org>

	* include/shmmib.h, scheduler/scheduler.c, scheduler/mailq.inc:
	    Count for scheduler's time-server starts, and last
	    start-time.

	* transports/smtp/smtp.c:
	    Count pipelining transmits only when doing connection
	    open, not for every sent message...

2003-05-27  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c:
	    Examples in RFC 2034 weren't the best possible, practice has
	    shown, that "250 2.6.0 .." isn't quite what is intended.
	    Sending now (like sendmail) "250 2.0.0 ..."

	* include/shmmib.h, scheduler/Makefile.in, scheduler/mailq.inc,
	  scheduler/scheduler.h, smtpserver/smtpcmds.c,
	  smtpserver/smtphelp.c, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c, transports/smtp/smtp.c:
	    More simpleish counters and gauges...

	* transports/smtp/smtp.c, include/shmmib.h, scheduler/mailq.inc:
	    Count outgoing sessions where we use PIPELINING.

	* scheduler/scheduler.c:
	    Fix the  LogFreeSpace-kB-G  to be filled (instead of
	    overwriting  SpoolFreeSpace-kB-G !)

	* include/shmmib.h, transports/smtp/smtp.c, scheduler/mailq.inc:
	    Added smtp TA process creation counter, and a gauge to
	    observe how many there are running in parallel.

2003-05-26  Matti Aarnio  <mea@zmailer.org>

	* bin/mkdep.in, bin/mklibdep.in, compat/rmail/Makefile.in,
	  compat/sendmail/Makefile.in, lib/Makefile.in,
	  libc/Makefile.in, libident/Makefile.in,
	  libresolv/Makefile.in, libsh/Makefile.in,
	  router/Makefile.in, router/libdb/Makefile.in,
	  scheduler/Makefile.in,  sfio/Makefile.in,
	  smtpserver/Makefile.in, transports/errormail/Makefile.in,
	  transports/expirer/Makefile.in,
	  transports/fuzzyalias/Makefile.in, transports/hold/Makefile.in,
	  transports/libta/Makefile.in, transports/mailbox/Makefile.in,
	  transports/reroute/Makefile.in, transports/sm/Makefile.in,
	  transports/smtp/Makefile.in, utils/makedb/Makefile.in,
	  utils/vacation/Makefile.in:
	    Fixed the "make depend" processing, now it works also when
	    compiling in "adjacent directory" (tested only in that,
	    though..)

	* include/libz.h, include/shmmib.h, lib/fdstatfs.c,
	  router/daemonsub.c, lib/zshmmibattach.c, router/rfc822.c,
	  scheduler/mailq.c, scheduler/mq2.c, scheduler/scheduler.c,
	  scheduler/threads.c, scheduler/transport.c, scheduler/update.c,
	  smtpserver/smtpchild.c, smtpserver/smtpcmds.c,
	  smtpserver/smtpdata.c, smtpserver/smtpetrn.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/smtptls.c, transports/smtp/smtp.c,
	  transports/smtp/smtp.h:
	    Reworked a bit more of the monitor counters and gauges.
	    (Actually a lot..  Added first glimmers even to SMTP-ta.)


2003-05-25  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Account incoming SMTP protocol command lines, and
	    some part of bad inputs.

	* lib/zshmmibattach.c:
	    Fixes around the file locking mechanisms.
	    flock/fcntl/lockf supported.

	* scheduler/scheduler.c:
	    Fixed the StoredReceipients and ReceivedRecipients
	    accounting counters.  Primarily that gauge, secondarily
	    moved the received counter next to the gauge.
	    (The gauge was incrementing twice for each received
	    recipient, and decremented once for each sent ...)

	* router/rfc822.c:
	    Track the number of recipient addresses before routing
	    those addresses (and possibly expanding them).

2003-05-24  Matti Aarnio  <mea@zmailer.org>

	* include/shmmib.h, lib/zshmmibattach.c, router/daemonsub.c,
	  router/router.c, scheduler/mailq.c, scheduler/mq2.c,
	  scheduler/scheduler.c, scheduler/scheduler.h,
	  scheduler/threads.c, scheduler/transport.c, scheduler/update.c,
	  smtpserver/smtpchild.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h:
	    - Added fields of primary daemons start times, and counters
	      of how many times they have been started in this block..
	    - Fixed the scheduler process accounting, and for a good
	      measure, threw in thread, vertex, and recipient gauges.

	* utils/perl/Makefile.in:
	    As the "mailq" needs to be copied from its original location,
	    when processing building in "adjacent directory",
	    the "make clean"  will need to remove it under same
	    conditions.

	* router/router.c, router/daemonsub.c, scheduler/scheduler.c,
	  smtpserver/smtpserver.c:
	    Moved  Z_SHM_MIB_Attach()  into a place where these programs
	    have _not_yet_ detached themselves from the console, and will
	    loudly complain if the SHM attachement fails (presuming that
	    SNMPSHAREDFILE  ZENV variable is set at all.)

	* scheduler/mailq.c, scheduler/mq2.c, utils/perl/mailq/mailq.pm,
	  man/mailq.1.in:
	    A new primitive:  "SHOW COUNTERS", which can be invoked
	    with "mailq -QQQQ" and is same text as local memory attached
	    "mailq -M" -- but can be at remote system.

	* man/Makefile.in, man/man-to-html.sh, man/zmailer.3.in:
	    Using GNU Makefile "pattern rules" to do things that
	    had been open-coded into the makefile.  Also support
	    referring to  e.g.  ZMailer::mailq(3)  in hyperlinks.

	* configure.in, lib/zshmmibattach.c, include/libz.h,
	  scheduler/mailq.c:
	    Added test for <sys/file.h> header,  Added  flock()/lockf()
	    locking of the shared segment storage, and detailed error
	    status returning from Z_SHM_MIB_Attach() so that  "mailq -M"
	    can report what exactly happened, when things didn't work.

	* include/libz.h,  lib/zshmmibattach.c,  smtpserver/smtpdata.c,
	  scheduler/scheduler.c, smtpserver/smtpcmds.c, scheduler/mailq.c:
	    More text changes, implemented two instances of spool free
	    space gauge.  (That thing peaks at about 2 GB, only when
	    space goes BELOW it, there is a reason to watch for it..)

	* smtpserver/fdstatfs.c, smtpserver/fdstatfs-test.c,
	  smtpserver/Makefile.in, lib/fdstatfs.c, lib/fdstatfs-test.c,
	  lib/Makefile.in:
	    Moved the fdstatfs*.c files from one directory to another.
	    Did that also in CVS repository, and thus preserved revision
	    data..

	* scheduler/mailq.c:
	    More 'mailq -M' printouts.

	* include/shmmib.h, router/daemonsub.c, router/rfc822.c,
	  scheduler/scheduler.c, scheduler/transport.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtpetrn.c, smtpserver/smtptls.c:
	    - New counter variables, changed the magic version
	      (mapping will be rejected if there is old persistent file
	       in the system!) 
	    - More code to do SHM counting/tracking

	* utils/webtools/mailq-m.php,  utils/webtools/mailq-q.php,
	  utils/webtools/mailq-v.php:
	    An experimental set of web-tools to do ZMailer status
	    display in web..  Developed for friends to look into
	    a busy system without using command-line tools..
	    Also as concepts for doing some advanced tinkering.

2003-05-23  Matti Aarnio  <mea@zmailer.org>

	* lib/zshmmibattach.c, include/libz.h, include/shmmib.h,
	  scheduler/scheduler.c, router/daemonsub.c, scheduler/update.c,
	  scheduler/threads.c, lib/Makefile.in, SiteConfig.in,
	  scheduler/mailq.c, man/mailq.1.in, router/router.c,
	  smtpserver/smtpserver.h, smtpserver/smtpchild.c,
	  smtpserver/smtpserver.c:
	    - Added new library function -- attach global
	      MTA-instance specific shared memory mapped file
	      to some particular running process.
	    - Added new counters and gauges, far in excess of
	      official RFC listed gauges..  SNMP shall coalesc
	      subsystem counters and gauges.
	    - Using this global shared segment for the time-server, too.

	* utils/perl/Makefile.in:
	    Doing "make clean" shall not crash even if previous
	    "make" hasn't been run in a subdirectory, where things
	    are done with 'Makefile.PL' way...

	* transports/smtp/smtp.c:
	    Additional "once" counter that breaks the loop, if
	    other ways don't stop it -- when doing "more recipients"
	    retry things.

2003-05-22  Matti Aarnio  <mea@zmailer.org>

	* configure.in, transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Had a deeper look into "NAGLE" code, and realized that
	    we didn't  #include  <netinet/tcp.h>,  which carries the
	    necessary socket-option tokens,  thus no "NAGLE" control
	    was ever done.

	* sfio/bin/iffe, sfio/src/lib/sfio/Stdio_b/features/stdio,
	  sfio/src/lib/sfio/features/common, sfio/src/lib/sfio/features/sfio:
	    Picked the 'iffe' script from SFIO-2002, as well as
	    'features/sfio', and 'features/common', the 'features/stdio'
	    did need a bit of manual fixing, as there is no equivalent in
	    newer version.  (SFIO-2002 usage is -- seriously in doubt
	    due to its overflowing of thread stuff.)

2003-05-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtprouter.c:
	    When encountering "*INTERNAL*ERROR*" do report with '400'
	    status, instead of '500' status...

	* proto/db/smtp-policy.src:
	    In boilerplate texts, say "Your address is not liked .."
	    instead of "Your domain is not liked ..".

	* transports/smtp/smtp.c:
	    The SMTP "NOOP" shall timeout in 30 seconds..
	    Otherwise it lingers around with DOT-timeout (20 minutes)..
	    Also report this process state in proctitle data.

	* transports/smtp/smtp.c:
	    In EZMLM mode the SMTP TA didn't unlock all recipients,
	    which did cause considerable amount of  "#resync" activity
	    in between the scheduler, and SMTP TA.
	    Replaced a ton of 'return's with 'goto more_recipients;'
	    in order to coherently handle the EZMLM mode in all of
	    its forms.  Also unbroke the rp-chain (which is broken in
	    EZMLM detection)

	* sfio/src/lib/sfio/sfsetbuf.c, sfio/src/lib/sfio/sftable.c,
	  sfio/src/lib/sfio/sfvprintf.c, sfio/src/lib/sfio/Sfio_dc/sfdcdio.c:
	    Small fixes to silence the compilation warnings.

	* scheduler/scheduler.c, scheduler/update.c:
	    Moved  global_wrkcnt,  and  MIBMtaEntry->mtaStoredMessages
	    counter managements around so that they are essentially
	    tracking on how many memory instances there are of the
	    'struct ctlfile' objects.  Strictly speaking this isn't
	    the same as count of jobs, but a lot simpler to do..

	* scheduler/update.c:
	    When reporting 'multiple processing of address ...',
	    do mention also channel & host data for the _process_
	    which is reporting.

2003-05-20  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Mark version: 2.99.56-pre6

	* router/rfc822.c:
	    Eugene Crosser reported that envelope header
	    "with" without a value does cause router process
	    to drop core.  Indeed it does that.  Oops.
	    (denial of service attack is possible from
	    inside the system.)

	* man/smtpserver.8.in, man/zmailer.3.in:
	    Reworked/updated environment variable pickups of these
	    programs.

	* smtpserver/smtptls.c:
	    Instead of picking the POSTOFFICE location all by itself,
	    use smtpserver process global value.

	* smtpserver/smtpserver.c:
	    Andrey Blochintsev <bag@iptelecom.net.ua>  sent
	    a patch to move  WHOSON  lookup upwards a bit
	    so that the data is available, when it is being
	    logged.

	* INSTALL:
	    Updated to match the reality a bit better, than
	    what it has been for a long time...

2003-05-15  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/contentpolicy.c, smtpserver/smtprouter.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    From  Andrey Blochintsev <bag@iptelecom.net.ua>
	    spotted process deaths by NULL pointer referral
	    during state cleanup.

	* transports/mailbox/mailbox.c:
	    Turning EDQUOT failure to instant permanent failure.

2003-05-13  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c, smtpserver/smtpserver.c:
	    Removed  printf()s  from policy-test debug outputs,
	    and use  type()  instead.

	* smtpserver/policytest.c, proto/db/smtp-policy.src,
	  doc/guides/smtp-policy:
	    From  Andrey Blochintsev <bag@iptelecom.net.ua>
	    a bit more code, and commentary updates in boilerplate.

	* transports/smtp/smtptls.c:
	    Oops, when "HAVE_OPENSSL" is inactive, still supply
	    msg_info() function to be used, as well as  FILE *vlog.

	* libc/strsignal.c:
	    Matching tests with earlier autoconf rewrites

	* configure.in, man/Makefile.in, man/*:
	    Changed ALL man-page files to be autoconf generated
	    so that @MAILBIN@ substitutions (et.al.) can be
	    done into the files.  (Also renamed files in the
	    CVS repository to reflect changed names in order
	    to preserve the change history.)

	* proto/post-install.sh.in:
	    Added '--destdir' option.

	* Makefile.in:
	    DESTDIR value dependent reminder notes referring to
	    "postinstall" tool.

2003-05-10  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Increase the timeout_data to 5 minutes by default to
	    match timeout_cmd -- in PIPELINING mode we had a bit
	    too low timeouts..

	* proto/scheduler.conf.in:
	    By default, comment away the "ageorder" flag.
	    When a troublesome message jams the queue, allow
	    the queue to be randomized so that the troublesome
	    message won't stay in its head.

	* smtpserver/policytest.c:
	    From  Andrey Blochintsev <bag@iptelecom.net.ua>:
	
    Is it possible to setup smtp-policy to block
    almost all mail (exept to: abuse@ or to: postmaster@)
    from some networks?

    It seems for me settings like:
	_rbl0          rcpt-dns-rbl      +:dul.maps.vix.com....
	_rbl1          test-rcpt-dns-rbl +
    doing that for RBL-listed network[s], but it is not possible
    to have analogous setup for locally listed (in smtp-policy.*)
    networks.

    The patch below solves this problem.
    To activete you need add rcpt-dns-rbl attributes starting
    with '_' ('_' symbol is not allowed in dns names).

    With this patch settings
	[10.10.10.25]/32      rcpt-dns-rbl "_+"
	[10.10.10.0]/24       rcpt-dns-rbl "_TEST reject msg"
	postmaster@my.domain = _full_rights
    means that:
    Mail from 10.10.10.0/24 to postmaster@my.domain -- accepted
         from 10.10.10.25 accepted/rejected by other rules (relaytarget +/- ...)
         from 10.10.10.0/24 to other will be rejected with
           "550 5.7.1 Policy analysis reported: TEST reject msg rcpt=<bag@i.kiev.ua>"
    diagnostic
	

2003-05-09  Matti Aarnio  <mea@zmailer.org>

	* libsh/io.h, libsh/io.h, libsh/builtins.c:
	    While trying to implement a sh_read(), with a lot less
	    incomprehensible code, had to introduce fgetc() redirecting.

	* proto/cf/fqdnalias.cf, proto/cf/aliases.cf, router/functions.c:
	    Correcting a bit of the 'listexpand'  treatment of DSN data
	    in expanded addresses.  When expanding thru LISTS, new ORCPT
	    (and new Return-Path) will result.on each recipient address,
	    but when expanding thru ALIASES (and .forward), ORCPT and
	    Return-Path will stay unmodified.
	    Disabled former (now unused)  "listaddresses"  function,
	    which does a small part of the job...

	* scheduler/scheduler.c:
	    Andrey Blochintsev reported typo in  setproctitle()
	    call.  (***BSD specific thing.)

	* proto/zmailer.sh.in:
	    Eino Tuominen spotted that I still have sloppy style to
	    write scripts without testing them before publishing..
	    ( e.g. users test :-/ )  Missing double-quote in one
	    sh embedded perl script.

	* proto/cf/fqdnalias.cf:
	    Modification typo lurked in the FQDN aliasing script.
	    OUTCH!  Found it when testing local virtualized email
	    service failing to failure, and producing 'deferred'
	    messages...

	* lib/sleepycatdb.c, smtpserver/policytest.c,
	  utils/makedb/dblook.c, utils/makedb/makedb.c:
	    Support compiling against SleepyCat DB 4.1
	    (the C-API has again been changed;  db->open()  got
	     additional parameters...)

2003-05-08  Matti Aarnio  <mea@zmailer.org>

	* libsh/builtins.c:
	    Debugging  sh_read()'s internal buffer
	    re-allocation/extension code.
	    Something is wrong in there, and it grows without bounds..

	* include/listutils.h, libsh/listmalloc.c, router/db.c:
	    "function with parameter that is a pointer to a function
	    with ..."     .. found correct thing.  I wish gcc would
	    tell as much as the Sun WorkShop C compiler tells...

	* configure.in, include/zresolv.h:
	    Solaris 2.6 oops.. u_int16_t isn't known type there..

	* transports/sm/sm.c, transports/mailbox/mailbox.c,
	  router/daemonsub.c, scheduler/transport.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    Worked over the  wait4()/wait3()/waitpid()/wait() usage.
	    Essentially addded  wait4()  to the mix.

	* configure.in, Makefile.in:
	   Syncing things to be in par with  autoconf 2.57, including
	   having it as a pre-req..  Also producing BUGREPORT and VERSION
	   literals from  configure.in  file !
	   

	* configure.in, smtpserver/smtpserver.c, scheduler/scheduler.c,
	  transports/smtp/smtp.c:
	    Andrey Blochintsev reports that FreeBSD 4.x needs
	    to use  setproctitle()  function.  Added autoconfig
	    tests for that.

	* lib/rfc822date.c:
	    Just to be on the safe side, enlarging some buffers,
	    and adding explicite sprintf() string lenth limits.

	* proto/zmailer.sh.in:
	    Refer to inlined perl-script executor with  @PERL@
	    autoconfig token.

	* proto/post-install.sh.in:
	    Typo fix in autoconf patterns.  Should actually rename
	    this either to 'post-install', or 'post-install.pl',
	    as it is a perl script...
	
	* lib/sleepycatdb.c:
	    Andrey Blochintsev reported that things didn't work quite
	    smoothly with only BSD DB 1.x in system. (No SleepyCat's
	    latter versions.)

	* scheduler/conf.c:
	    Lower the  global_report_interval  from 15 to 5 minutes.

2003-05-06  Matti Aarnio  <mea@zmailer.org>

	* lib/zgetbindaddr.c, transports/mailbox/mboxpath.c,
	  router/rtsyslog.c:
	    Looking deep into "gcc -Wall" diagnostic reports.
	    Added includes for missing prototype declarations.

	* router/libdb/bind.c, smtpserver/mxverify.c,
	  transports/libta/dnsgetrr.c, transports/smtp/getmxrr.c,
	  utils/mxverify/mxverify-cgi.c, include/zresolv.h:
	    Modern resolver libraries don't have  _getshort(), and
	    _getlong() as public prototyped entities.  Took model
	    off modern resolver libraries, and used macroes
	    NS_GET16() / NS_GET32() / NS_INT16SZ / NS_INT32SZ.
	    Where macroes are not available, supplying our own
	    versions.  Centralized all related defines.

	* proto/zmailer.sh.in:
	    Reworked  'resubmit'  command internal mechanism
	    to handle cases, where the 'deferred' directory
	    has thousands of messages.  A bit perl required..

	* lib/mail.c:
	    realloc()ing uninitialized variable -- OOPS!
	    (Since 2003-4-17)

	* INSTALL:
	    Small updates, more is needed...

	* Makefile.in, compat/rmail/Makefile.in,
	  compat/sendmail/Makefile.in, libc/Makefile.in,
	  man/Makefile.in, packaging/solaris/Makefile.in,
	  proto/Makefile.in, router/Makefile.in, scheduler/Makefile.in,
	  smtpserver/Makefile.in, transports/errormail/Makefile.in,
	  transports/expirer/Makefile.in,  utils/Makefile.in,
	  transports/fuzzyalias/Makefile.in, transports/hold/Makefile.in,
	  transports/mailbox/Makefile.in, transports/reroute/Makefile.in,
	  transports/sm/Makefile.in, transports/smtp/Makefile.in,
	  utils/makedb/Makefile.in, utils/mxverify/Makefile.in,
	  utils/perl/Makefile.in:
	    Rewriting the virtual-root installation support to use
	    "DESTDIR=" instead of "prefix=".  The Proper Way ...

	* include/mail.h.in, scheduler/readconfig.c,
	  scheduler/scheduler.c, smtpserver/debugreport.c,
	  transports/errormail/errormail.c, transports/expirer/expirer.c,
	  transports/hold/hold.c, transports/sm/sm.c,
	  transports/libta/lockaddr.c, transports/libta/tasysyslog.c,
	  transports/mailbox/mailbox.c, transports/reroute/reroute.c:
	    Further cleanup after inserting Eugene's patch-cluster.
	    Adding   #include "libc.h"  usually, and various other
	    merryments it involves.

2003-05-05  Matti Aarnio  <mea@zmailer.org>

	* SiteConfig.in, configure.in, include/libz.h,
	  scheduler/transport.c, smtpserver/cfgread.c,
	  transports/smtp/smtp.c, lib/Makefile.in,
	  lib/zgetbindaddr.c:
	    Patch cluster from Eugene Crosser to librarize common code,
	    and to introduce 'BINDADDR' ZENV variable.

	* compat/sendmail/sendmail.c:
	    If process environment has ZCONFIG variable set, does read
	    ZENV variables from that place.

	* proto/mailrm.sh.in, proto/newaliases.in,
	  proto/newfqdnaliases.in, proto/post-install.sh.in,
	  transports/expirer/manual-expirer.in,
	  transports/reroute/manual-rerouter.in,
	  utils/policy-builder.sh.in, utils/rotate-logs.sh.in,
	  utils/zmailer.init.sh.in:
	    Eugene Crosser noted, that not all scripts inherit / are
	    otherwise configurable to use alternate (than configured-in)
	    value of  ZCONFIG.

2003-05-02  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/contentpolicy.c, smtpserver/readpolicy.c,
	  include/policy.h, smtpserver/policytest.c,
	  smtpserver/policytest.h, doc/guides/smtp-policy,
	  proto/db/smtp-policy.src:
	    Added 'filtering +' phrase to smtpserver's IP ADDRESS tests.

	* utils/perl/mailq/Makefile.PL, utils/perl/mailq/mailq.pm,
	  utils/perl/mailq/MANIFEST, utils/perl/mailq/README,
	  utils/perl/mailq/Changes, utils/perl/Makefile.in,
	  utils/Makefile.in, configure.in:
	    Made old perl-test tool into proper OO Perl code.
	    Requires perl 5.8. (I think).

	* scheduler/agenda.c, scheduler/msgerror.c, scheduler/threads.c,
	  scheduler/scheduler.c, scheduler/prototypes.h:
	    Debugging the long living thing where "mailq -Q" mode reports
	    negative counts for stored messages.  Apparently fixed it!
	    ( Didn't :-(  )

2003-05-01  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  man/smtpserver.8, proto/smtpserver.conf.in:
	    tar-pit things from James MacKinnon.
	    Actually diff against 2.99.55, which has been adapted to
	    current CVS.

	* proto/zmailer.sh.in:
	    Quote typo introduced when adding  --zconfig   option..
	    Oops.

2003-04-30  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	   Version 2.99.56-pre5

	* README.UPGRADING:
	    The router internal logic change IS script incompatible!
	    Carefull out there with your  aliases.cf,  and
	    fqdnaliases.cf !

	* proto/cf/aliases.cf, proto/cf/fqdnalias.cf, router/functions.c:
	    - When a list-expansions fails to produce recipient list,
	      do produce an error message only, when the message being
	      routed is _not_ an error message in itself.
	    - In scripts, do understand that the 'listexpand' can yield
	      a NULL list, and branch at it conditionally to do different
	      codepath behaviour.

	* scheduler/update.c:
	    Change in debug outputs to use more usefull spoolid
	    reference.

2003-04-28  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/libta/diagnostic.c:
	    Allow multiple calls to  diagnostic()  function,
	    and make sure that only first of them does actual
	    DIAGNOSTIC reporting, all the rest do just logging to
	    given FILE*.

	* transports/smtp/smtp.c:
	    More code re-arrangements regarding connection retries.

	* transports/smtp/smtp.c, transports/smtp/smtp.h:
	    A bit experimental re-arrangements of EZMLM related
	    processing of messages in smtp-level.  Moved  smtp
	    connection formation from before deliver() to within
	    it, so that it can (when needing) re-open the connection.

	* utils/mxverify/mxverify-cgi.c:
	    Auto-detect, if can use IPv6 addresses in testing.

	* scheduler/mailq.c, man/mailq.1:
	    Added '-Z' option to mailq, alike at scheduler, et.al.

2003-04-17  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/ctlopen.c, transports/libta/mimeheaders.c:
	    Cleaning up the for-clause code a bit. Removing unnecessary
	    malloc()/free() things, which are dropping core at one
	    test system.  (In the end it was mallocated buffer end
	    overscribling that dropped those cores at mysterious
	    places, but as this was the only altered place...)

	* man/zmailer.1, proto/zmailer.sh.in, router/router.c,
	  man/router.8, scheduler/scheduler.c, man/scheduler.8,
	  smtpserver/smtpserver.c, man/smtpserver.8, transports/sm/sm.c,
	  transports/smtp/smtp.c, transports/errormail/errormail.c,
	  transports/hold/hold.c, transports/mailbox/mailbox.c,
	  transports/reroute/reroute.c, proto/newdb.in,
	  proto/newdbprocessor.in:
	    - Zmailer, Router, Scheduler, Smtpserver: explicite options
	      to define non-compiled-in path to  ZCONFIG  ZENV file.
	    - Transport Agents: if  ZCONFIG _environment_  variable is set,
	      read ZCONFIG from that file.  Inherits that from scheduler...
	    - Some tools: if  ZCONFIG _environment_  variable is set,
	      read ZCONFIG from that file.  Inherits that from zmailer(1).

	* scheduler/scheduler.c scheduler/agenda.c, scheduler/mq2.c,
	  scheduler/msgerror.c, scheduler/prototypes.h,
	  proto/zmailer.sh.in,  scheduler/transport.c,
	  scheduler/update.c:
	    Automated (within 30 seconds of previous) log-file re-opening

	* man/manual-rerouter.8, man/reroute.8, man/Makefile.in:
	    Man-pages for the reroute transport-agent.

	* transports/hold/hold.c:
	    Long time bug in produced envelope metadata entry.

	* transports/reroute/reroute.c, transports/reroute/Makefile.in,
	  transports/reroute/manual-rerouter.in:
	    Experimental version of reroute -- e.g. command some
	    channel/host target queue back to the router.

	* transports/libta/mimeheader.c:
	    When outputting ORCPT value into "for clause", do
	    decode the XTEXT encoded data into plain format.

2003-04-16  Matti Aarnio  <mea@zmailer.org>

	* SiteConfig.in, transports/libta/mimeheader.c:
	    More beauty tuning of the for-clause processing subroutine.
	    Added also a way to disable the addition of the for-clause
	    via a ZENV variable.

2003-04-15  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c:
	    Another error spotting by Eugene Crosser -- for a while
	    CVS versions have not done any sort of DNS-BL lookups
	    correctly.  (Since 2002-09-01.)

	* transports/smtp/smtp.c:
	    "RSET" processing didn't -- various MAIL FROM related
	    state variables were reset before the optional "RSET"
	    protocol exchange was done, and thus in some cases
	    PIPELINEd processing did lead to undesirable behaviour.
	    This bug was introduced on  2003-02-14   in order to fix
	    scattered around RSET code paths so that there will always
	    be an RSET, when there is need for it.  Urgh.
	    
	    It appeared when a message was tried to send in the
	    connection right after something needing that RSET;
	    thanks to reports about "there seem to be multiple
	    messages to these troublesome destinations" for finally
	    finding this.

2003-04-14  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Quite old configuration thing bites us with newer  autoconf
	    produced sed-scripts.  Namely   @ROUTEUSER_IN_ABNORMAL_UNIX@
	    value in running  $MAILSHARE/zmailer.conf   file  will
	    cause sed to spin in place.

	* include/ta.h,  transports/libta/ctlopen.c,
	  transports/libta/fwriteheader.c, transports/libta/mimeheaders.c,
	  transports/libta/swriteheader.c:
	    Tuning a bit more of "from-clause" processing so that it
	    sticks better within 80 columns.

	* libc/myhostname.c:
	    From  Eugene Crosser:  find out my local
	    hostname only once (e.g. scheduler et.al.
	    long-running processes.)

	* transports/errormail/errormail.c:
	    - If the source address is 'channel error', send
	      the message back to domainless "postmaster" in
	      our own machine.
	    - If the message is to be discarded ("NOTIFY=NEVER"
	      at all recipients, or some such), indicate that
	      at the syslogged string.

	* libc/mail.c, libc/sfmail.c, SiteConfig.in:
	    Add  INPUTDIRS=  ZENV variable processing,
	    also  INPUTDIRHASH=  and  INPUTNOTIFY= !
	    Presently just testing!

	* router/db.c, router/rfc822.c:
	    Been doing a bit of debugging of one odd system
	    built a while ago, with reports "this isn't working.."
	    (definitely it wasn't, wrong configs running...)

2003-04-11  Matti Aarnio  <mea@zmailer.org>

	* SiteConfig.in, configure.in:
	    Updated default configuration values a bit, rearranged
	    SiteConfig.in  parts to be more "groupped by function".

2003-04-07  Matti Aarnio  <mea@zmailer.org>

	* lib/sleepycatdb.c:
	    Eugene Crosser noted, that this file fails to compile,
	    when no SleepyCat DB is available in the compilation
	    environemnt.  Oops!  Adding couple conditionals to
	    appease the compiler...

2003-04-06  Matti Aarnio  <mea@zmailer.org>

	* lib/sleepycatdb.c:
	    Adding debugging things, trying to understand
	    couple CDB-mode related problem things.
	    Possibly this is about a bug in system thread library,
	    which interacts badly with SleepyCat DB 4.0.14  ?

2003-04-04  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Urgh, two chain-gang movement pointer mistakes, and
	    a long running process went into busy spinning...

	* transports/libta/mimeheaders.c:
	    Additional book-keeper things for knowing when
	    the thing can fold, and when it can't.

	* router/rfc822hdrs.c:
	    Tuning (part of) folding header printing code.

2003-04-03  Matti Aarnio  <mea@zmailer.org>

	* transports/sm/sm.c:
	    Oops, bad parameter for  header_received_for_clause()
	    function.  Used one was always NULL, which is kind of
	    bad idea...

	* transports/smtp/smtp.c:
	    Finished complete RFC 1123 part 5.2.2  CNAME rewriting
	    both in MAIL FROM and RCPT TO.  Also cleaned up code
	    somewhat in relevant parts.

	* transports/smtp/smtp.c, transports/smtp/getmxrr.c,
	  transports/smtp/smtp.h:
	    Third round, completing processing also in cases,
	    where target domain is not the same as to what is
	    being used for connection forming.
	
	* transports/smtp/smtp.c, transports/smtp/getmxrr.c,
	  transports/smtp/smtp.h:
	    - getmxrr() -- prepared for further refinements
	      of CNAME cache related lookups.
	    - add_cname_cache(), cname_lookup() -- two interfaces
	      to RFC 821 related RCPT TO rewriting for CNAME
	      aliased domain names.  This DOES NOT touch on
	      visible headers, nor ORCPT data, only RCPT TO
	      domain.  Still a bit incomplete...
	      Actually that reference is: RFC 1123 part 5.2.2

2003-04-02  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8:
	    Forgotten document of several months old
	       PARAM tls-random-source /sock/path
	    parameter.

	* include/ta.h, transports/libta/mimeheaders.c:
	    New  header_received_for_clause()  function to add a FOR
	    clause into top-most RECEIVED: header.

	* transports/smtp/smtp.c, transports/mailbox/mailbox.c,
	  transports/sm/sm.c, transports/errormail/errormail.c:
	    Use  header_received_for_clause()  function.

	* transports/smtp/smtp.c, transports/smtp/getmxrr.c,
	  transports/smtp/smtp.h:
	    Follow strictures of RFC 821 about rewriting RCPT TO
	    envelope domain, if target domain did resolve via CNAME.
	      Actually that reference is: RFC 1123 part 5.2.2

	* transports/smtp/smtp.c:
	   If target system has DSN capability, but our sent address
	   does not (for some reason) have DSN data, generate them
	   from default values...

	* router/daemonsub.c:
	    When the child process closes, as its final act, do: exit(0)

	* smtpserver/cfgread.c:
	    A bit of cleanup of the parser: wrap all OpenSSL related
	    options inside appropriate IFDEF test,  AND  from now on,
	    begin reporting in smtpserver's verbose log, if configuration
	    contains PARAM entry which isn't known/doesn't have enough
	    parameters.  (Helps debugging...)

2003-03-13  Matti Aarnio  <mea@zmailer.org>

	* scheduler/update.c, scheduler/statuslog-ids-to-spoolids.pl,
	  man/scheduler.8:
	    Change in  statistics-log file format to have
	    easier correlation with syslogged data.
	    Also a tool to convert the statistics-log file
	    to new format.

2003-03-06  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/rfc821scn.c:
	    Turned off the code assigning semantic meaning
	    to the local-part contained % and ! characters.
	    Relaying policy control will look at them, but
	    only when the address domain is _local_, and
	    the address is on  RCPT TO.

	* man/smtpserver.8:
	    Cleaned up a bit the OpenSSL/TLS related documentation.
	    Added missing 'h' option document.

	* smtpserver/smtptls.c:
	    Changed couple internal warning texts into a lot less
	    alarmistic "could not load .. from file, will use
	    built-in default" (of DH pamaters.)

	* transports/libta/mime2headers.c:
	    Limit the length of produced "MIME-2" header tokens.
	    This is mostly a beauty-wart, but might in some cases
	    be usefull thing.

2003-03-05  Matti Aarnio  <mea@zmailer.org>

	* include/mailer.h, router/rfc822.c, router/rfc822hdrs.c,
	  router/rtsyslog.c, lib/taspoolid.c, router/prototypes.h,
	  smtpserver/smtpserver.c:
	    - Generate file  taspoolid  at message envelope
	      parse time into  'struct envelope',  and pass it
	      around instead of generating it at multiple times.
	    - In  Received:  header, former   id <spoolid>   is
	      now changed to:   id spoolid  (without angle-brackets)
	    - Message-id generation uses now taspoolid value
	      as one component of its formulation.
	    - explicitely constified some constant data.

	* router/functions.c:
	    Comment away dead declarations.

	* proto/smtpserver.conf.in:
	    Comment away the default  PARAM help  text where
	    "Yoyodyne Propulsion" is mentioned as system
	    owner...   People don't edit those...

2003-02-28  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/standard.cf, router/libdb/header.c:
	    Remove headers which we produce into e.g.
	    messages stored in mailbox / processes run
	    in pipes, etc.

	* router/rfc822hdrs.c:
	    When producing our  Received:  header, don't anymore
	    put the spool-id inside angle-brackets.

2003-02-20  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtptls.c, transports/smtp/smtptls.c:
	    Updated one function prototype to match version 0.9.7.

	* configure.in:
	    In RedHat (8.0 / Rawhide ?) system the OpenSSL 0.9.7
	    is compiled with Kerberos inside it.  Compilation,
	    and linkage will need additional CFLAGS and LIBS
	    to succeed.  To provide those, a system specific
	    pkg-config   tool is used, where available.

	* configure.in:
	    Updated things to match rules of  autoconf 2.57
	    (e.g.  LIBOBJS  is no longer allowed direct assignment)

	* scheduler/mailq.c, smtpserver/smtpserver.c:
	    Typo fixed from Eugene Crosser.

	* TODO:
	    Updated / rearrangements / removing completed items

2003-02-14  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version: 2.99.56-pre4
	    * WILL DO ALSO A RELEASE TARBALL OF THIS, *
	    * BUT DON'T TRUST IT YET! *****************

	* transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Centralized RSET sending into one place in
	    MAIL/RCPT/DATA loop. Using state variable  do_rset
	    in the SmtpState context to indicate POSSIBLE need
	    for doing it.  Definite non-need is when DATA/BDAT
	    has completed successfully, and also right before
	    the first MAIL.

	* router/libsh/bsdhash.c, router/libdb/bsdbtree.c:
	    Correct clearing of DBM private data storage pointer.

	* scheduler/mailq.c:
	    Fix "mailq -s" access failure printing to use correct
	    directory string pointer.

2003-02-06  Matti Aarnio  <mea@zmailer.org>

	* compat/sendmail/sendmail.c, libsh/builtins.c, libsh/execute.c,
	  router/libdb/bsdbtree.c, router/libdb/bsdhash.c,
	  router/libdb/ndbm.c, transports/libta/ctlopen.c:
	     Do  #include <errno.h>  -- that is definitely needed
	     for correctly compiling code at glibc 2.3.1+,  but is
	     correct for other cases, too.

	* transports/smtp/smtp.c:
	    Convert couple  LOG_ERR  level syslog()s to   LOG_NOTICE.
	    They don't quite deserve being blasted to people's consoles..

	* transports/smtp/smtp.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c:
	    Additional "writeclosed" flag to inform that the socket
	    shall not be written to, no matter what.

	* libsh/execute.c, libsh/zmsh.c:
	    Added option 'J' into ZMSH interpreter to trace a subset of
	    'I' traced things.

	* libsh/expand.c,  libsh/interpret.c:
	    Disable eating away backquotes from expanded variable values.
	    EFFECTS TO BE TESTED MORE THOROUGH!

	* proto/cf/aliases.cf, proto/cf/rrouter.cf, proto/cf/server.cf:
	    Moved  $(dequote ...)  calls into separate variable
	    assignments to analyze things for backquote (non-)processing.

	* libsh/path.c:
	    Don't include <sfio.h>,  it isn't needed.

	* router/daemonsub.c:
	    If message has been (tried to) process earlier, and
	    the "lock pid" is ours, do process the message, otherwise
	    see at first if the system has a process with that pid in
	    it, then skip that item..   (FIXME: this is not perfect...)

	* libsh/regex.h:
	    Moving one #endif upwards a bit to make sure
	    there is always some definition for  __restrict  et.al.

2002-10-07  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c, smtpserver/smtpserver.c,
	  smtpserver/smtptls.c:
	    Oops..  Wrap  HAVE_OPENSSL  around data entries which
	    are available only when the macro is defined...

2002-10-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtptls.c:
	    Make CA file/directory issuance optional for smtpserver.

	* router/daemonsub.c:
	   E.Crosser reported that on some platform (apparently
	   at least Solaris), child process death causes file-
	   handle leakage in process.  (E.g. missing close() calls
	   somewhere.)  While at it, I cleaned a bit of the code..

	* lib/loginit.c:
	   Do lessen the number of syscalls done by this routine.
	   (At Linux with glibc 2.2.x).

2002-09-23  Matti Aarnio  <mea@zmailer.org>

	* compat/sendmail/sendmail.c:
	    Improved the verbose-trace printing code.
	    Turned out the lattest glibc stdio code didn't
	    resume reading from fd, when it had reached EOF once,
	    or some such equally weird thing...
	    Also noticed temporary file usage insecurity
	    whereby somebody could persuade us to append
	    texts into some existing file in systems where
	    mkstemp() call does not exist.. (Not overwrite,
	    nor read what invocator's privileges don't allow
	    to be read...)

	* transports/smtp/smtp.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c:
	    - If TLS mode is mandated, but not available,
	      yield a TEMPFAIL at connection..  Hopefully
	      sysadmin will detect it before a full-blown
	      failure occurs, and traffic is lost.
	    - Also included template code for handling server
	      certificate verification failure at SMTP connection
	      level. (final integration is a TODO thing,)
	    - A bit more of Postfix TLS code into SMTP client
	      system.  (Still the session-cache in TODO..)

2002-09-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtpcmds.c, smtpserver/cfgread.c,
	  smtpserver/smtptls.c:
	    Radical revisioning; adapting current Postfix TLS
	    code into ZMailer environment.
	    TODO: session-cache...

	* transports/smtp/smtp.h, transports/smtp/smtp.c,
	  transports/smtp/smtptls.c:
	    Radical revisioning; adapting current Postfix TLS
	    code into ZMailer environment.
	    TODO: session-cache...

2002-09-19  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtptls.c, transports/smtp/smtp.h, man/smtp.8,
	  proto/smtp-tls.conf.in:
	    The OpenSSL code doesn't (anymore) like to work without
	    proper random pre-seeding...

2002-09-10  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.c:
	    Default the 'expiry2' to be zero, if it can't be set to
	    be anything more appropriate.

2002-09-06  Matti Aarnio  <mea@zmailer.org>

	* SiteConfig.in:
	    Changed the default value for SCHEDULERDIRHASH  to be  2
	    It is important thing for large queue sites, while
	    at small systems it uses deep hashing unnecessarily..

	* configure.in:
	    Mark for presense of header  <sasl/sasl.h>

	* man/scheduler.8, scheduler/scheduler.c:
	    The  -E  option for the scheduler can now have
	    two parameters to better control the pre-scan of
	    the input queue.  Also altered default values.

	* scheduler/readconfig.c, scheduler/scheduler.h, man/scheduler.8,
	  scheduler/agenda.c,  scheduler/conf.c, scheduler/scheduler.c,
	  scheduler/prototypes.h, scheduler/threads.c:
	    Another form of expiry -- when the queues become truly
	    huge, ZMailer's scheduler has not been able to expire
	    messages because it must at first do a delivery attempt
	    at least once. A new "expire2=" time limit _beyond_primary_
	    _expiry_.

	* smtpserver/mxverify.c:
	    The bad T_TXT data detection and cutback, nominally
	    the same thing as with e.g. sendmail.  Also clean
	    up the received string to have only printable
	    characters in ISO-8859-* character-sets.
	    All that this could have done in ZMailer is to pick
	    garbage data from beyond the (received) buffer, not
	    overwrite anything.

	* contrib/clean-mean-contentfilter-1.00.tar.gz:
	    Package from Eugene Crosser: "if you think it's worth,
	    maybe you'll include the attached thing into contrib/.
	    It's running here for more than a week under serious
	    load. It's not very smart and not very portable but
	    it's light (I did not feel any noticable growth of load
	    on the servers)."
	
2002-09-03  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/zpwmatch-pipe.c:
	    Running the legacy application authentication against
	    SASL via an external program..  Turns out the old
	    pipe-matcher code fails (by looping with ECHILD error)
	    when we have active child exit reaper...  Oops.

	* smtpserver/smtpauth-sasl.c:
	    The external program mentioned above.  This program is NOT
	    to be considered as official part of ZMailer MTA, the
	    goal is to provide an official version in the smtpauth.c
	    at some point...  I just needed a QUICK and working thing.

	* smtpserver/smtpcmds.c:
	    From user feedback (helpdesk manager report to developers,
	    wow...): The "rejection due to MX rule" report needs
	    improved text.  Altered wording, and added client IP address
	    printout into the text.

	* router/prototypes.h, router/rfc822.c, lib/rfc822scan.c:
	    Modifications to header parsing.
	    - An all-white-space line shall be CONTINUATION, not
	      end-of-headers (ancient BITNET card-images are other
	      story, but lets not worry about them...)
	    - Altered the makeLetter() function parameters removing
	      a parameter that has not been used for several years.
	    - WorkInProgress: internal changes into  makeLetter()...

	* configure.in, smtpserver/smtpauth.c:
	    Initial configuration hooks for enabling CMU Cyrus Sasl-2.x
	    The code itself is NOT functional as of yet.

2002-09-02  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c:
	    Did something wrong, while scrubbed dead code..
	    Detection of header/body (in RFC822 sense) separation
	    fixed.  (Well, not entirely.. there are things which
	    probably SHOULD stay in headers...)

	* transports/libta/diagnostic.c:
	    A beauty-wart in syslog()ed data, when truncking embedded
	    CR containing diagnostic message, skip over the last CR
	    also...

	* transports/smtp/smtp.c:
	    Support -F connection to  UNIX:/...  sockets.
	    This MUST be defined at the command line! No routing
	    controlled version allowed!  (security, you see..)
	    (This is subject to system having AF_UNIX support in
	     the first place, but that should be quite common...)

	* README.UPGRADING:
	    Change in what  sm  outputs for envelope meta-data to
	    be in line with other transport-agents... (mailbox,
	    in particular.)

	* transports/sm/sm.c:
	    Testing reveals... NULL pointer referrals :-(

	* libc/Makefile.in, libresolv/Makefile.in, router/Makefile.in,
	  router/libdb/Makefile.in, scheduler/Makefile.in,
	  smtpserver/Makefile.in, transports/hold/Makefile.in,
	  transports/libta/Makefile.in, transports/mailbox/Makefile.in,
	  transports/reroute/Makefile.in, utils/makedb/Makefile.in,
	  utils/vacation/Makefile.in:
	    Modified usage of  @GENINCL@  autoconfig macro so that it
	    will always be the LAST inclusion define for the each
	    compilation.  This way if the (as has happened to yours
	    truly) GENINCL ( /usr/local/include ) has a file with
	    same name as something important ZMailer internal (mail.h
	    from UW-IMAP C-client), it won't override internal file..

	* proto/cf/fqdnalias.cf:
	    When doing  fqdnroute  processing on a "plus-full"
	    address, pass proper parameters to the database lookup.

	* include/zmsignal.h, router/daemonsub.c, router/db.c,
	  router/router.c, router/rfc822.c:
	    Observed certain kind of difficulties at abruptly
	    closed database accesses -- SleepyCat DB 3.x CDS
	    goes into bad lock state, unless properly cleaned
	    after with atexit().

	* transports/sm/sm.c:
	    Do similar X-***: header processings as the 'mailbox'
	    does for ORCPT, EnvelopeID, and Envelope-To.
	    Streamline a bit separatorsequence processing.

2002-09-01  Matti Aarnio  <mea@zmailer.org>

	* lib/rfc822scan.c, router/functions.c, router/rfc822.c:
	    Removed code (for printaliases function) that is no longer
	    used, observed situations, when the malformed headers
	    can be split by ZMailer.

	* smtpserver/mxverify.c:
	    When doing varioud "RBL" lookups, always catenate a "."
	    into end of the lookup domain in order to suppress
	    unnecessary "search" work by the resolver libraries.
	    Doing:  _res.options &= ~RES_DNSRCH;  might do it too...

	* smtpserver/smtpcmds.c:
	    Noticed that in unused code there is potential for
	    serious trouble with router call.  '#if 0' wrappers in..
	    Also, modify SIZE= value parameter parser to accept
	    strictly valid value in range 1 thru 1 000 000 000.

	* proto/db/smtp-policy.relay:
	    Add a comment covering user-specific destination addresses.

2002-08-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c:
	    Reworked the  ta-spoolid  generation and presentation
	    in the DATA and BDAT phases after the contentpolicy()
	    call (and even before it..)

	* transports/libta/mime2headers.c:
	    Arnt Gulbrandsen  reported a GI (of GIGO) case
	    producing invalidly encoded header MIME token.
	    namely the double-quote is not legal char unencoded
	    char inside the Q-format token.

	* configure.in:
	    Added missing   utils/smtp-contentfilter  into
	    generated files list.

	* utils/makedb/dblook.c:
	    Use  db_strerror() to report error strings properly.
	    Usage of  strerror()  does not work at DB3/DB4 ..

	* man/smtpserver.c, smtpserver/contentpolicy.c,
	  utils/smtp-contentfilter.in, README.UPGRADING:
	    A change in the  smtpserver <-> contentfilter
	    interface protocol!  Some users have written
	    content-filters based on the sample framework,
	    and those will need matching changes (rather
	    simple!) in the filter code!  See  README.UPGRADING !

2002-08-22  Matti Aarnio  <mea@zmailer.org>

	* proto/post-install.sh.in:
	    Changed behaviour rules a bit.
	    Now the prototype of whatever there are prototypes of
	    will be kept in its original place, and only copies
	    will be made.

	* lib/sleepycatdb.c:
	    Spotted a bug in database opening error handling.

2002-08-19  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Changed logtag() returned tag-string format.
	    New one will tell time (in secs) since start of
	    the program, and incremental sequence number.

	* proto/post-install.sh:
	    Having been asked ... printing more verbose progress
	    reporting while doinga POSTOFFICE subdirectories.

	* smtpserver/smtpauth.c, smtpserver/smtpcmds.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    Format change in the verbose protocol log tags.

2002-08-12  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    In some cases the  smtp_sync()  is called when outbound write
	    socket has already been killed.

	* proto/newdbprocessor.in:
	    Updated internal comment carried documentation, and
	    sample of  dbases.conf  in the script.

	* proto/db/dbases.conf:
	    Documented the existence of "-r" as newdb_compile_option.

2002-07-11  Matti Aarnio  <mea@zmailer.org>

	* sfio2002/*
	    Entire subtree -- SFIO version 2002.1
	    Basic injection, no adaptations yet.

	* include/libz.h, lib/selfaddrs.c, lib/zgetifaddress.c,
	  router/libdb/selfmatch.c, smtpserver/mxverify.c, 
	  smtpserver/policytest.c, smtpserver/smtpserver.h,
	  transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Moving commonly used 'Usockaddr' type into libz.h,
	    and updating interfaces playing with addresses to
	    use that type for the parameters.

	* proto/smtpserver.conf.in, smtpserver/cfgread.c:
	    Eugene Crosser noticed that binding to named interface
	    does not quite succeed..  Address storage goes into
	    slightly wrong place -> binding fails.

2002-07-05  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    A practically unexploitable potential buffer overflow.
	    Exploit requires presense of 'h' flag in EHLO greeting
	    match patterns (non documented, non-default style flag),
	    and that the host address reversal text is long in the
	    extreme. Getting the server to crash is less difficult,
	    than to get it to execute anything..   Repeat: A 'h' must
	    be present in style-flags at the end of the smtpserver.conf
	    file EHLO/HELO-patterns, AND the hostname reversal PTR text
	    must be longer than around 100 bytes.  Then, maybe, it will
	    be possible to feed working buffer overflow exploit..

	* Makefile.in:
	    Version 2.99.56-pre3 (CVS tagged  2-99-56-pre3)

	* transports/smtp/smtp.c:
	    An attempt to create a smart way (at least at Linux and
	    at some BSD's) to de-nagle tcp streams in high-performance
	    manner.   Low-performance de-nagle is:  sleep(1) ...

	* configure.in, acconfig.h, aclocal.m4:
	    Updates to remove couple of deprecated features, adding
	    third parameters (often also second) to AC_DEFINE() macroes.

	* proto/post-install.sh.in, proto/cf/fqdnalias.cf,
	  proto/cd/rrouter.cf, proto/db/dbases.conf,
	  proto/db/fqdnroutes, proto/Makefile.in:
	    - cleaned up a bit the  routes_spec()  function parameter
	      variables -- less confusion with the new name, I hope..
	    - new routing mechanism:
	           fqdnroutes -- user@domain -> chan!data..
	
	* lib/sleepycatdb.c, include/sleepycatdb.c,
	  router/libdb/bsdbtree.c, router/libdb/bsdhash.c
	    More rework on SleepyCat DB driver routines to better use
	    the ZSleepyPrivate structure to carry relevant reference
	    data.
	
	* router/libdb/gdbm.c, configure.in:
	    Similar code work to SleepyCat DB for GDBM.
	    Testing for library having   gdbm_fdesc()   function.

	* router/db.c, router/function.c, router/prototypes.h,
	  router/libdb/search.h:
	    - Renamed the low-level dblookup driver routine from
	      'db()' to 'dblookup()' after having problems of finding
	      the caller...
	    - Reworked the %-substitution code radically; now %[1-9] will
	      be a key of same index at every time.  The  %0 MAY change
	      in case some driver routine (e.g. 'pathalias') is defined
	      at the 'relation' statement.  The relation MUST have
	      '-%' option for the %[0-9] substitutions to be active!

2002-06-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Separating DATA ending dot into separately done write(2),
	    which hopefully leads into separately pushed out frame,
	    and finally packet separation at the DATA-phase ending dot
	    sending..  World is full of braindead firewalls...

	* include/sleepycatdb.h, lib/sleepycatdb.c,
	  router/libdb/bsdbtree.c, router/libdb/bsdhash.c:
	    More work at the SleepyCat DB Concurrent Data Store  support.

	* router/db.c:
	    Clean a bit of the database call mechanism passed parameter
	    block by doing initial memset(,0,) on it..

	* libc/mail.c, libc/sfmail.c:
	    Change (slightly) of how the initial temporary file name
	    is formed so that there are no leading white spaces at a
	    host which has shorter than 7 chars hostname..

2002-06-20  Matti Aarnio  <mea@zmailer.org>

	* include/sleepycatdb.h, lib/sleepycatdb.c,
	  proto/newdbprocessor.in:
	    More of  SleepyCat DB support stuff.

	* smtpserver/smtpauth.c:
	    Stole code (yet incomplete, and not integrated) from sendmail
	    8.12.*  for using SASL code in SMTP server authentication.

2002-06-18  Matti Aarnio  <mea@zmailer.org>

	* configure.in, acconfig.h:
	    Full support for finding SleepyCat DB 4.0, and
	    to inform the system about it.

	* lib/Makefile.in, lib/sleepycatdb.c, include/sleepycatdb.h:
	    Librarize support for SleepyCat DB by allowing more versatile
	    parametrisation, e.g. DBENV things, etc.   This to make it
	    possible to work with "Concurrent Data Store" kind databases.
	    E.g. single-writer, multiple readers to allow online
	    modifying of the databases.

	* router/db.c, router/libdb/search.h:
	    For each online database, supply a private variable usable
	    by the database method itself for whatever needs it has
	    (e.g. storing own structure with private data, like DB
	     structure handle.)

	* router/libdb/bsdbtree.c, router/libdb/bsdhash.c:
	    Usage of librarized SleepyCat DB interface, and radical
	    surgery to discard a bunch of splay-trees that are no longer
	    necessary as the database method handle carries "dbprivate"
	    pointer.

	* smtpserver/policytest.c, utils/makedb/dblook.c,
	  utils/makedb/makedb.c, utils/vacation/vacation.c:
	    Support SleepyCat DB 4.0; use (where can) librarized
	    support interface.

	* transports/smtp/smtp.c:
	    Fix the call parameters to "select_sleep()" so that there
	    is explicite knowledge of when the select is for writing,
	    and when it is for reading.

	* utils/smtp-contentfilter.in:
	    Fix originally inverted test on meta-environment scanner
	    stopping condition part.

2002-05-28  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    Eugene Crosser reported smtpserver spinning in place,
	    and that is indeed possible if the deprecated  ssmtp
	    service is in use.  Moving relevant initialization code
	    upwards slightly fixes the problem.
	    (Later Eugene admitted that there could have been
	     a pilot error -- omitting "make clean" before "make".)

2002-05-20  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c:
	    In some testing cases the "progname" variable is not
	    set with any sane (non-NULL) value.

	* utils/policy-builder.sh.in:
	    Output the "smtp-policy.relay*" file entries only, when
	    there is some data in the line, e.g. no comments, nor
	    blank lines..

	* smtpserver/contentpolicy.c:
	    A bit more of debug output into local log..

	* transports/smtp/smtp.c:
	    Sometimes the  SS->smtpfp  will be NULL, and at such times
	    sferror() on stream yields SEGV..  Additional code armouring.

	* utils/smtp-contentfilter.in:
	    A bit cleaner use of perl's implied default variables..

2002-05-16  Matti Aarnio  <mea@zmailer.org>

	* scheduler/transport.c:
	    The code didn't consume the scheduler-notify input socket
	    at the mux() code, although it was looked for by the
	    select() in the code.

2002-04-20  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    In the obscureish EZMLM mode we LACKED mandatory trailing
	    ">" character at MAIL FROM envelope address.
	    A major goofup.. :-/
	    (Especially as I use the beast myself sometimes..)

	* transports/mailbox/mboxpath.c:
	    At the  usage()  do document also the -X[X] option.

2002-04-18  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c:
	    Finally a bit of understanding about how to manage
	    persistent errno status on sfio streams.

	* transports/smtp/smtp.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c:
	    Persistent error storage things, but as of yet the
	    detail analysis/reporting at calling layers is vague.

	* libc/mail.c, libc/sfmail.c, router/rfc822.c:
	    Add missing  #include "zmsignal.h"  lines...

2002-04-17  Matti Aarnio  <mea@zmailer.org>

	* include/ta.h, transports/libta/diagnostic.c,
	  transports/errormail/errormail.c, transports/smtp/smtp.c,
	  transports/expirer/expirer.c, transports/hold/hold.c,
	  transports/libta/ctlopen.c, transports/mailbox/mailbox.c,
	  transports/smtp/smtp.h:
	    - Add 'FILE *verboselog' parameter to  diagnostic() API
	      call, and get a cascade of things..  That is often the
	      last, undocumented, and most interesting thing anyway..
	    - Play with MAILBOX to detect (and neatly report) when
	      write to a file fails due to EDQUOT ...  Perhaps
	      fail it immediately ? (TODO item..)

2002-04-12  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/getmxrr.c:
	    Extended the test-harness a bit by telling what
	    are the two standard tests for it, and their
	    expected results.

2002-04-05  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Debugging oddball 'yield OK when DEFER is correct' problems..
	    .. and fixed the blunder in the call of  smtpopen().
	    (that oddballness was with PIPELINING capable targets.)

	* transports/libta/ctlopen.c:
	    The RP data block is not initialized completely in all cases,
	    which causes occasional bugs.  Doing   memset()  for it at
	    first, then filling in non-zero values.  This resulted from
	    RP structure expansion a month ago.

2002-03-08  Matti Aarnio  <mea@zmailer.org>

	* transports/reroute/reroute.c, transports/reroute/Makefile.in,
	  transports/Makefile.in:
	    Added a new Transport Agent -- "reroute", e.g. send given
	    messages back to router.  This is intended for quite special
	    (and intimate) interaction with the Scheduler.

	* transports/mailbox/mailbox.c, man/mailbox.8:
	    Add a few subprocess execution environment variables
	    which carry more of message meta-data, than previously.

	* transports/libta/ctlopen.c:
	    Pass the  INFROM= DSN metadata into   rp->infrom  field.

	* transports/hold/hold.c:
	    Detect "channel error" type messages properly.
	    Pass more of DSN Metadata to outgoing message envelope.
	    Output "env-end\n" meta-header after the envelope headers.

	* transports/expirer/expirer.c:
	    Update the comments a bit.

	* router/rfc822.c, libc/mail.c, libc/sfmail.c:
	    Take precautions (just in case) "the next-stage notify"
	    socket closes, and causes a SIGPIPE to be sent to relevant
	    process.

	* proto/scheduler.conf.in:
	    Remove "-8" from a few prototype command lines.

2002-02-22  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.h, utils/makedb/makedb.c,
	  utils/makedb/dblook.c:
	    System with only SleepyCat DB 3.x in it (not 2.x, nor 1.x)
	    didn't support it properly.  Oops..

	* configure.in, libc/Makefile.in, man/Makefile.in:
	    Found out, why  --libdir=,  --includedir=, and
	    --mandir=  options didn't have effect.  D'uh..

2002-02-20  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c:
	    Remove few earlier added ":" characters from places
	    where those went into report form filenames.
	    My blunder :-(

2002-02-18  Matti Aarnio  <mea@zmailer.org>

	* utils/makedb/makedb.c:
	    Remove else -brances causing problems in some cases.
	    I got definite reports about this earlier, but had
	    solid neutronium in my skull...

2002-02-15  Matti Aarnio  <mea@zmailer.org>

	* libc/mail.c, libc/sfmail.c, router/rfc822.c:
	    Oops,  MSG_NOSIGNAL seems to be Linux specific
	    thing, at least Solaris 2.6 doesn't support it
	    for  sendto()  system call.
	
2002-02-11  Matti Aarnio  <mea@zmailer.org>

	* scheduler/transport.c:
	    Match the mailq socket tcp-wrapper behaviour to that of
	    what the man-page says -- "tcp-wrapper is not used for
	    MAILQ-v2 type sockets".

	* SiteConfig.in:
	    By default publish  SCHEDULERDIRHASH=1  value.
	    Publish also  SCHEDULERNOTIFY=  and ROUTERNOTIFY=
	    variables, which are used by the notifier codes.

	* include/libc.h, transports/libta/nonblocking.c:
	    Moved the non-blocking code to be macro in  libc.h.
	    At some places a #include <fcntl.h> is needed before
	    #include "libc.h".

	* include/ta.h, scheduler/mq2.c, scheduler/transport.c,
	  transports/libta/warning.c:
	    The preceding fd-blocking macro thing affected these
	    files.  (Other usage places already did suitable #includes)

	* libc/mail.c, libc/sfmail.c, router/daemonsub.c:
	    If ROUTERNOTIFY is defined in  zmailer.conf, then
	    mail_close() (not .._alternative() !) will presume
	    there might exist an AF_UNIX socket with that name
	    into which a notification message about a new job
	    can be sent.

	* router/rfc822.c, scheduler/transport.c:
	    The Scheduler Notify socket got changed to use
	    SCHEDULERNOTIFY=   ZENV variable, and be AF_UNIX socket.

2002-02-07  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.c, scheduler/conf.c,
	  scheduler/prototypes.h, scheduler/transport.c:
	    Implemented a 'notifysocket', which is an UDP socket
	    (mailq/udp) receiving simple "NEW X/Y/123-456" text lines,
	    and verifying the inputs a bit..  Perhaps should have this
	    configurable, so that the system could have multiple
	    schedulers around...

	* scheduler/scheduler.c:
	    Reworked  2001-10-27 Stephen <steve@activemessage.com>
	    scheduler queue rescan timer thing into less magic..

2002-02-05  Matti Aarnio  <mea@zmailer.org>

	* router/db.c, proto/cf/p-routes.cf, router/libdb/search.h:
	    Support _multiple_ instances of fallback keys, e.g.:
	        $(routesdb "$domain" -: ".:$(get $A type)" -: .)
	    which will look up fallback keys:
	        .:sender
		.:recipient
	    depending on address type, and
	        .
	    if neither of those exist..

2002-02-01  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/fqdnaliases.cf:
	    Instead of:     returns (bitbucket ...)
	    do it properly: returns (((bitbucket ...)))

	* scheduler/update.c:
	    At   u_error2()   log the name of the event fully.

	* router/libdb/bind.c:
	    h_errhost[] change into source material length safe
	    construction.

	* router/libdb/dbm.c:
	    Mark this file with a  "#warning"  for being suspicuously
	    old-fashioned system with various problems...

2002-01-31  Matti Aarnio  <mea@zmailer.org>

	* proto/newdb.in:
	    Match the test in  router/libdb/ndbm.c  about which
	    component file to move _last_.  This has been a bug
	    since  2000-05-18 ...

2002-01-31   Alexey Antipov <rabbit@lipetsk.ru>

	* router/libdb/bind.c:
	    h_errhost[] buffer overflow in some oddball cases.

2001-12-15  Matti Aarnio  <mea@zmailer.org>

	* man/sm.8:
	    Revising the man-page.

2001-12-15  Nicolas Baumgarten <nico@pert.com.ar>

	* transports/sm/sm.c:
	    Added 'O' flag to configuration to output ORCPT data
	    into  X-Orcpt: header.

2001-12-07  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c, transports/libta/swriteheaders.c:
	    When message writing into a file fails with e.g. EDQUOT
	    (quota exceeded), abort writing completely, discard sfio
	    buffers, and truncate away the incompletely received message.
	    This problem appeared at Solaris 8, when using quotas.

	* transports/smtp/getmxrr.c:
	    Cleanup some compiler warnings.

2001-11-07  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtptls.c,
	  man/smtp.8:
	    Trying to figure out what to do with problematic
	    case on a Solaris 2.6 system speaking to some Win-NT
	    SMTP server application which looses all but the
	    first two TCP frames it receives.  The Solaris goes
	    to retransmit backoff from which it never really
	    recovers, and the write connection times out.
	    Implemented thus a '-w 1000' option to define the
	    value of the socket option SO_SNDBUF.

2001-10-27  Stephen <steve@activemessage.com>

	* scheduler/scheduler.c:
	    Observed problems with scheduler's input queue scanning.
	    Sent in a patch (which didn't quite do it..)

2001-10-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtptls.c:
	    - edge comparisons in time handling code cause
	      short (1 sec) busy-loopings every now and then.
	    - When MAIL FROM results a 5xx status with immediate
	      closure of the socket following that report,
	      yield proper rejection, not EX_TEMPFAIL.

	* transports/smtp/smtptls.c, transports/smtp/smtp.h,
	  transports/smtp/smtp.c, transports/libta/ctlopen.c,
	  transports/libta/tasyslog.c, include/ta.h:
	    Move the "taspoolid()" invokation into ctlopen()
	    processing from within  tasyslog()  call.
	    At  smtp,  copy also the "->taspoolid" pointer
	    field into the SmtpState structure.

2001-10-23  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c, scheduler/scheduler.c,
	  scheduler/scheduler.h, scheduler/update.c:
	    Added couple  zsyslog()  calls to conditionally syslog
	    when scheduler has completed processing of a message.

	* router/rfc822.c:
	    Added a bit of double-colons on squirel() and
	    reject() calls when the thing is FATAL.
	    (Its me again being dense and forgetting documentation
	    elsewere, but the ":error-on-error" tag looked so neat...)

	* router/libdb/bsdbtree.c, router/libdb/bsdhash.c,
	  smtpserver/policytest.c, utils/makedb/dblook.c,
	  utils/makedb/makedb.c:
	    Reworked SleepyCat DB 1.x/2.x/3.x conditionals.

2001-10-21  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mq2.c:
	    Tracked wrong resource accounting at mailq2 code;
	    it used to increment the number of (tracked) childs
	    in a place where such increment is harmfull, and
	    did lead to sort of "inflation" of children to such
	    an extent that there were phantoms in all allowed
	    resource slots..  Thus the 'mailq -Q' thing begun
	    to fail in most annoying way.
	    Also allowed for 'challenge' subfield to be filled
	    with a NULL pointer by the  strdup(), which a bit
	    later could lead to NULL referral, and thus SigSEGV..

2001-10-21  Michael Loftis <mloftis@wgops.com>

	* scheduler/scheduler.c:
	    In queue injection spotted a test of time which is reversed!

2001-10-16  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mq2.c:
	    Correct the way how orderly close ("QUIT") of mailq is
	    handled -- the socket needs to be discarded properly...

	* libsh/builtins.c, router/functions.c, router/daemonsub.c:
	    Fixup the various return codes, specifically use EX_USAGE
	    for the usage report.

2001-10-10  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf,  proto/cf/aliases-new.cf,
	  proto/cf/canon.cf, proto/cf/crossbar.cf,
	  proto/cf/fqdnaliases.cf, proto/cf/server.cf,
	  proto/cf/fussy-aliases.cf, proto/cf/i-smtp.cf,
	  proto/cf/i-uucp.cf, proto/cf/p-bitnet.cf,
	  proto/cf/rrouter.cf, proto/cf/standard.cf:
	    Noticed strange bounces which turned out to be due to
	    calls of functions which have optional options beginning
	    with '-' character.  These fixes handle cases where localpart
	    and/or domain name begins with a minus.  A full throughout
	    analysis of all functions inside the router, and related
	    documentation in the ZMailer Manual is future project.

2001-10-09  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h, smtpserver/smtpcmds.c,
	  smtpserver/cfgparse.c, proto/smtpserver:
	    PARAM force-rcpt-notify-never
	    Whatever the incoming DSN NOTIFY= value is, we force it
	    always to be NOTIFY=NEVER.   This is for those who won't
	    like to let others even to find out that the message made
	    into the system, but still want to support incoming DSN.
	    (That is, not to disable DSN!)

2001-10-04  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/p-smtp.cf, proto/cf/standard.cf, proto/cf/trusted.cf:
	    Add a bit of 'provide nnn' things.

	* scheduler/mq2.c, scheduler/mq2auth.c, scheduler/prototypes.h,
	  scheduler/transport.c, scheduler/update.c:
	    Track the number of open mailq2 sockets.  Track also
	    memory usage, and abort the connection of MQ2 socket if
	    the buffer size needed for the input line exceeds 16k.

2001-10-02  Matti Aarnio  <mea@zmailer.org>

	* scheduler/readconfig.c:
	    Support arbitrary large sets of:
	         AAAA/*
		 BBBB/*
		 CCCC/*
		 DDDD/*
		    params
	    channel/host selector pairs preceding common
	    parameter sets.  Original was just AAAA+BBBB,
	    adding third did fail the first dataset...

	* proto/cf/crossbar.cf, proto/cf/fqdnalias.cf,
	  proto/cf/p-uucp.cf, proto/cf/rrouter.cf,
	  proto/cf/standard.cf:
	    A bit more of revisions of 'returns' vs. 'return'
	    primitives.  Mostly adding comment: "error code return"

	* libsh/builtins.c:
	    Damn!  The  'returns'  primitive WAS NOT returning
	    _string_ in all cases.

2001-10-01  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    SH-script bug in SleepyCat DB 3.x tests.

	* proto/newdbprocessor.in, proto/cf/UTAI.cf, proto/cf/UTGPU.cf,
	  proto/cf/aliases-new.cf, proto/cf/aliases.cf, proto/cf/canon.cf,
	  proto/cf/crossbar.cf, proto/cf/fqdnalias.cf, proto/cf/p-routes.cf,
	  proto/cf/p-iproutes.cf, proto/cf/p-smtp.cf, proto/cf/p-usenet.cf,
	  proto/cf/p-uucp.cf, proto/cf/rrouter.cf, proto/cf/standard.cf:
	    Reports about problems when aliases map into purely decimal
	    digit containing local name prompted rewriting parts of the
	    scripts (and newdbprocessor tool!) with old(*) 'returns' return
	    in place of the original 'return' return.  The difference is
	    that 'returns' will _always_ yield a string, while 'return'
	    may yield an integer value if the username/whatever is made
	    of purely decimal digits...
	    ( *: "old" as "long existing" )

	* Makefile.in:
	    CVS tagged version 2.99.56-pre1

	* include/libc.h, proto/zmailer.sh.in, man/zmailer.1:
	    Update the beast at Solaris 2.6, and learn some
	    new things...

2001-09-30  Matti Aarnio  <mea@zmailer.org>

	* configure.in, acconfig.h:
	    Autoconfig detection of  SleepyCat DB 3.x

	* router/db.c, router/libdb/bsdbtree.c, router/libdb/bsdhash,
	  smtpserver/policytest.c, utils/makedb/dblook.c,
	  utils/makedb/makedb.c, utils/vacation/vacation.c:
	    Use the SleepyCat DB 3.x call API; even prefer it!
	    (Except for vacation: Prefer NDBM, then GDBM, BSD DB...)

	* README.UPGRADING:
	    Note the usage of SleepyCat DB 3.x !

	* transports/mailbox/mailbox.c:
	    Got a spotting of code which isn't needed..

	* utils/rotate-logs.sh.in:
	    Let the $PATH to handle command binary locating.
	    That is, 'mv' and 'touch' are trusted to $PATH...

	* proto/zmailer.sh.in:
	    Fix typos at '-q' option processing!

2001-09-27  Matti Aarnio  <mea@zmailer.org>

	* packaging/rpm/*:
	    Updated version of RPM specs file, et.al. from
	    Xosé Vázquez

2001-09-26  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c:
	    For HELO/EHLO parameters, do a bit less work, ignore
	    case of '[1.2.3.4]' type parameters completely.

	* proto/scheduler.conf.in:
	    Set default expiration to be 5 days (from old 3 days).
	    RFC 2821 does suggest 4-5 days.

2001-09-22  Matti Aarnio  <mea@zmailer.org>

	* acconfig.h, config.h.in, configure.in, include/hostenv.h,
	  lib/nobody.c, lib/trusted.c, router/db.c, router/functions.c,
	  router/rfc822.c, router/libdb/nbm.c, scheduler/scheduler.c,
	  sfio/src/lib/sfio/sfio.h, sfio/src/lib/sfio/Sfio_dc/sfdcdio.c,
	  sfio/src/lib/sfio/Sfio_dc/sfdcdos.c, smtpserver/policytest.c,
	  sfio/src/lib/sfio/Sfio_dc/sfdcfilter.c,smtpserver/policytest.h,
	  sfio/src/lib/sfio/Sfio_dc/sfdcseekable.c, smtpserver/smtpcmds.c,
	  sfio/src/lib/sfio/Sfio_dc/sfdcsubstream.c, transports/hold/hold.c,
	  sfio/src/lib/sfio/Sfio_dc/sfdctee.c, transports/expirer/expirer.c,
	  sfio/src/lib/sfio/Sfio_dc/sfdcunion.c, transports/fuzzyalias/db.c,
	  transports/mailbox/mailbox.c, transports/smtp/getmxrr.c,
	  transports/sm/sm.c, transports/smtp/smtp.c, utils/makedb/dblook.c,
	  utils/makedb/makedb.c, utils/vacation/vacation.c:
	    A very large OpenBSD patch cluster; including:
	    - Revision of database facility autoconfig
	    - several printf warnings
	    - sfio #define collision avoidance
	    - SETEUID() and friends

	* proto/zmailer.sh.in:
	    A  -q  option for completely quiet operation
	    (part of OpenBSD patch cluster)

	* utils/mxverify/mxverify-cgi.c, utils/mxverify/getaddrinfo.c:
	    Some radical cleanups in the TEXT/HTML presentation

	* transports/smtp/smtp.c:
	    Certain diagnostics control bits fixed so that RSETs won't
	    overwrite last real command performed on connection and
	    having done something which e.g. caused a reject

	* smtpserver/cfgread.c, smtpserver/smtpdata.c,
	  smtpserver/smtpserver.c, smtpserver/smtpserver.h:
	    "PARAM outlook-tls-bug" -- Outlook Express seems to kick on
	    TLS when it is told to use TLS, and the destination port is
	    not 25, but _anything_else_ !

2001-07-31  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c:
	    Had omitted couple  fflush()  calls in DATA and BDAT
	    to commit accumulated buffered data into file so that
	    external  contentfilter()  program can analyze it.

2001-07-29  Matti Aarnio  <mea@zmailer.org>

	* utils/autoanswer.pl.in:
	    Fixing buggy tests; originally about "$nosend", but
	    there were some other too..	

	* include/mail.h.in:
	    Forgot this from the inject below...

2001-07-05  Matti Aarnio  <mea@zmailer.org>

	* include/libc.h, include/mail.h.in, libc/mail.c, libc/sfmail.c,
	  scheduler/msgerror.c, smtpserver/smtpdata.c, 
	  transports/errormail/errormail.c, transports/smtp/getmxrr.c:
	    Changed (properly) the _*mail_close_() inode parameter to
	    be 'long'.

2001-07-04  Matti Aarnio  <mea@zmailer.org>

	* transports/errormail/errormail.c:
	    Recognize source channel 'error', and produce the destination
	    address accordingly -- ugly thing to do an "error-in-error"
	    message that way, but..

	* transports/mailbox/mailbox.c:
	    Recognize (and wipe out, and re-insert at delivery) incoming
	    headers "Original-Recipient:"  (for RFC 2298 section 2.3),
	    and "Envelope-ID:".

2001-06-15  Matti Aarnio  <mea@zmailer.org>

	* transport/smtp/smtp.c:
	    In synchronous SMTP connections, handle the result
	    processing correctly so that permanent reject with
	    MAIL FROM will permanently reject the message..

2001-06-11  Matti Aarnio  <mea@zmailer.org>

	* utils/mxverify/mxverify-cgi.c:
	    Print out the user supplied input (arg strings) properly
	    protected so that even if the input happens to be HTML
	    text in disguise, it shows up as "a string".

2001-06-04  Matti Aarnio  <mea@zmailer.org>

	* scheduler/transport.c, scheduler/msgerror.c:
	    Oh no, one-off string length after  cfgdirpath()  function
	    behaviour change.   Got around to write \0 to child, which
	    promptly misbehaved...

	* scheduler/transport.c, scheduler/conf.c:
	    Under some mysterious conditions (Linux kernel 2.4.5-pre4. ?)
	    the scheduler does not get select on read on dead childrens
	    stdout ??

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtptls.c, smtpserver/smtpdata.c:
	    Got rid of all  alarm()  calls in the server code, and use
	    select() instead everywhere. Along with NON-BLOCKING sockets.
	    The previous code has apparently allowed accumulation of
	    servers, which never die out...

2001-06-03  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mailq.c:
	    Oops time; closing FILE * object twice is BAD THING to do
	    in some cases.  Must not do so.  Early closing of the
	    underlying read socket is ok.

	* proto/smtpserver.conf.in:
	    In  smtp-auth  related PARAMs, do emphasise their security
	    implications!

2001-05-30  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.c, scheduler/msgerror.c,
	  scheduler/qprint.c, scheduler/threads.c,
	  scheduler/transport.c, scheduler/update.c:
	    I suspect that in certain cases the scheduler should do
	    "resync" on message file instead of just logging a complaint
	    into stderr like it now does at the end of  findvertex().
	    Adding some debugging data so that I can verify the thing.

2001-05-25  Matti Aarnio  <mea@zmailer.org>

	* README.UPGRADING:
	    Semi-forgotten note about the results of 2001-05-15's
	    libta/dianostic.c + scheduler/update.c + smtp TA/scheduler
	    interaction protocol detail.  You can have NEWER scheduler,
	    than smtp-ta, because this is backwards channel detail.

	* lib/cfgets.c:
	    Darryl Miles <darryl@netbauds.net>  found strange looking
	    problem with certain kind of "malformed" input for scheduler
	    configuration file.  Turns out that when this function
	    encounters EOF, and it isn't at the beginning of the line,
	    the line buffer never gets zero-terminated causing possibly
	    strange side-effects when thus revealed previous content of
	    the buffer may reappear.

	    Additional coding to always zero-terminate the allocated
	    buffer.   The code is being used both as classical  fgets(),
	    but also by returning exact number of characters collected.

	    I am doubtfull that the previous state was in any way capable
	    to produce system security threat.

2001-05-22  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/fqdnaliases.cf, proto/cf/process.cf,
	  proto/cf/aliases.cf:
	    Some experiments on doing message-wide 'didexpand' analysis
	    to see if complicated duplicate recipient removal code works.

2001-05-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpetrn.c:
	    Tell to the remote scheduler [source.ip.address]@mynodename
	    when issueing ETRN thru MQ2 mechanism.
	    Helps to hunt down cases where lots of ETRN requests are
	    appearing into the scheduler for domains that we don't serve,
	    and/or other such strange things...

	* configure.in, libc/gai_strerror.c:
	    Problems at compling "replacement-ipv6-libc"
	    with RH 7.1 libc.

2001-05-16  Matti Aarnio  <mea@zmailer.org>

	* ssl/Makefile.in, ssl/ssl.c, ssl/ssl:sst.[ch], ssl/ssl_sst.[ch]:
	    Changed references from  ssl:sst.[ch]  files to  ssl_sst.[ch]

2001-05-15  Matti Aarnio  <mea@zmailer.org>

	* include/ta.h, scheduler/update.c,  transports/smtp/smtp.c,
	  transports/libta/diagnostic.c, transports/smtp/getmxrr.c:
	    Define and use  EX_DEFERALL  exit code, which introduces
	    a new, somewhat differently behaving handling of temporary
	    kind of failures -- intended for smtp transport-agent for
	    DNS lookup failures of some domains, and connection failures.
	    To large extent this behaves as if "retryat +60" were
	    defined, but this will also mark ALL subsequent messages
	    in the thread (via "nextitem" chain) to 1) have been
	    attempted, and 2) with the same message as we initially have.
	    (It does not, however, expire any messages - at least
	     directly.)

	* scheduler/mailq.c:
	    The 'mailq -v' did show the ta-work-specification-file
	    size, not message size in 'bytes %ld' printout.. :-(

	    Also:  Have options:  "-c channel -h host"
	    which TOGETHER will let querying of some particularly
	    interesting destination channel/host pair among all that
	    the system may have active.  Requires MAILQ-V2 mode, and
	    '-v' option use (not '-Q'!).

2001-05-10  Matti Aarnio  <mea@zmailer.org>

	* include/libc.h:
	    Copy the 'GETNAMEINFOFLAGTYPE' test code into this
	    file too from  libc/getnameinfo.c.  Bloody Solaris..

2001-05-08  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version 2.99.55-patch1

	* transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Reworking (simplifying) DATA phase processing,
	    and quick-retry handling of socket write/read
	    failure induced closes.  There is limit of three
	    attempts on any given host for the delivery before
	    giving up entirely.  (Passing the failure to the
	    scheduler..)

2001-05-04  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/p-routes.cf:
	    Wrong function called to pick the flag data..

	* transports/smtp/smtp.c:
	    Fixup into pipelined error diagnostics accumulation
	    methodology.

	* proto/newdbprocessor.in:
	    PERL 5.6.0+ specific syntax altered back to earlier syntax,
	    which even the lattest perl does support.

	* configure.in:  --with-zconfig-noload   option to disable
	    preloading of possibly existing ZCONFIG file contents
	    into configuration variables.

2001-04-04  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/getmxrr.c:
	    If destination has one MX, and lookup for its A yields
	    EAI_AGAIN, remember to report SS->mxcount = 0 ...

2001-04-03  Matti Aarnio  <mea@zmailer.org>

	* proto/forms/delivery:
	    Changed the URL reference to a "decode key" at
		http://www.zmailer.org/delivery-report-decoding.html

	* acconfig.h, configure.in:
	    When supporting local  _getaddrinfo_() function,
	    have a HAVE_ variable for it too!

	* include/mail.h.in, router/rfc822.c:
	    Rearranged the _CF_*** defines into the order at which
	    the router uses them -- while editing documentation,
	    and needing coherent view at the things.

	* scheduler/threads.c:
	    When running parallel TAs at same thread, remember to
	    traverse pointer chain when showing process list..
	    (verbose debugging to stderr..)

	* libc/getaddrinfo.c:
	    Present at the debug vlog file the g->gaih() return code
	    in octal (it is a bitset, after all)

	* smtpserver/mxverify.c, transports/smtp/getmxrr.c:
	    Use the  HAVE__GETADDRINFO_  flag for local debug version..
	    Also done changes for retrieving AF_INET and AF_INET6
	    addresses separately, as there seems to be some problems
	    when trying to use  ai_family == 0  ("any goes") form.

2001-03-08  Matti Aarnio  <mea@zmailer.org>

	* include/mailer.h, router/rfc822.c, router/libdb/header.c,
	  transports/errormail/errormail.c, scheduler/msgerror.c,
	  proto/cf/p-routes.cf, router/functions.c:
	    New envelope header:  "errormsg"  telling that a message
	    is internally generated error message; router script has
	    new function:  $(iserrmessage) yielding this flag.

	* include/libc.h, include/libsh.h, include/sysprotos.h,
	  libc/getopt.c, libsh/builtins.c, libsh/interpret.c,
	  libsh/main.c, libsh/zmsh.c, router/router.c, router/db.c,
	  router/functions.c:
	    Changed all Router/ZMSH internal instances of getopt() to be
	    zgetopt() with additional capability -- optionset can now
	    contain doublecolon as an option, IF the ':' is the FIRST
	    character at the option specifier string...

	* proto/newdbprocessor.in, proto/db/dbases.conf, router/db.c,
	  proto/cf/p-routes.cf, proto/cf/rrouter.cf, proto/db/routes,
	  router/libdb/search.h:
	    Implemented DBlookup routine to be able to pick some options
	    at runtime, '-:' (with string arg) supplies default lookup
	    key in case the normal iteration fails.
	    Cases where the "zmailer newdb" should generate the lookup
	    wrapper function with user parameter passing.
	    Also support 'incore' database by compiling from source file
	    to "db add" statements in the ``relationname.zmsh'' script.

	* router/rfc822.c, router/functions.c, router/prototypes.h:
	    Streamlined the recognition of the message being coming
	    from an Error Channel ( not same as "errmessage" !)

	* proto/cf/aliases.cf:
	    The FOO+TAG needs to cut off at the first '+' char, not
	    by the last (or whatever the REGEXP code happens to use)

	* libsh/regex.c libsh/regex.h:
	    Updated this pair to a very recent GLIBC contained version.

	* transports/smtp/smtp.c:
	    At response wait timeout, do have a GOAL TIME of when
	    to timeout, not returning to it over and over again..

	* configure.in, aclocal.m4, config.h.in:
	    Using experimental  autoconf 2.49d  mandated couple of
	    changes...

2001-03-02  Matti Aarnio  <mea@zmailer.org>

	* README.UPGRADING:
	    Added a note about the ALTERED default locations
	    of  zmailer.conf  and  mail.conf  files.

	* man/smtpserver.8, proto/smtpserver.conf.in:
	    Fix up the tcp-wrapper related documentation, and the default
	    stuff in the  smtpserver.conf  template.

	* scheduler/threads.c:
	    Print the gauges of message counts in the queue with SIGNED
	    values, thus making underflows (negatives) more obvious.

2001-03-01  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mailq.c:
	    Embarassing uninitialized array elements used for checking
	    if loop ends - Tomasz Bojakowski <mad@devil.inside.pin.pl>
	    reported errors.

2001-02-27  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    At  smtp_sync()  when running in PIPELINING, if the
	    MAIL FROM has produced 400 or 500 series response,
	    do fault the RCPT TO responses in every case.
	    (With EX_UNAVAILABLE for 500-series, not EX_TEMPFAIL.)

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c:
	    Track Z_read() return errno code more properly to
	    the 'Session closed w/o QUIT' log report.
	    Case where this was needed was actually some firewall
	    product which f**d OUTBOUND SMTP session of raporter...

2001-02-26  Matti Aarnio  <mea@zmailer.org>

	* utils/listexpand.c, transports/smtp/smtp.c, include/ta.h,
	  transports/libta/ctlopen.c:
	    Implemented "EZMLM-alike" listexpander which does
	    the envelope MAIL FROM address content rewrite at
	    tne outgoing SMTP session.  This is done with 'DSN'
	    dataentry  EZMLM=  which is presumed to have valid
	    stuff to be appended to the localpart of the address
	    envelope:  '+recipient=40address.dom', for example.

	    When compared with more classical approach, this does
	    message routing in system-friendly way, and only changes
	    the output stage slightly.  (At classical case the message
	    is expanded for each recipient, say 3000 copies of 60 kB
	    each..  This mechanism is way faster.)

2001-02-24  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    Make RCPT TO synchronous router reporting to be a copy
	    of MAIL FROM one -- report things correctly, that is.

2001-02-23  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c, router/rtsyslog.c:
	    Added the time to process the message to the router syslog
	    report.  Both 'delay' and 'xdelay' just like at the TA's.
	    'delay' is time from message injection to routing completion,
	    'xdelay' is the time spent at the routing.

	* utils/listexpand.c, utils/Makefile.in:
	    Added '+ezlml' option, changed the low limit at
	    the -bundlesize -- and set its default to 6000!
	    Also re-learned that 'skip821address()' can only
	    be used with *valid* addresses,  rfc821_path2()
	    is for possibly invalid input scanning!

2001-02-21  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version 2.99.55  (the real release!)

	* router/functions.c:
	    At  $(listaddresses ..) and $(listexpand ..)  functions,
	    removed the '"%1"@..' type substitutions with '-l' option.
	    See the comment about '-%' at 'relation' function below.
	
2001-02-20  Matti Aarnio  <mea@zmailer.org>

	* scheduler/agenda.c, scheduler/scheduler.c, scheduler/mq2.c,
	  smtpserver/smtpetrn.c:
	    Report the ETRN information with contactee's IP address, and
	    timestamp when writing it into the scheduler's log.

	* proto/newdbprocessor.in, proto/db/dbases.conf, man/router.8,
	  proto/cf/fqdnalias.cf, router/db.c, router/functions.c:
	    Add '-%' option to the 'relation' routine to control, when
	    looked up data contained '%0' thru '%9' may get substituted.

	* proto/Makefile.in:
	    Remove at 'distclean' files which are autoconf generated.

2001-02-19  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/getmxrr.c:
	    Format printing of '%s' with NULL argument -> NULL-
	    referral -> ...

	* scheduler/mailq.c:
	    When doing some slow  'mailq -vv', and using MAILQv2, do
	    query all data out of the scheduler before poking into
	    the files (which may be a lot).  Limit the time of inter-
	    action with the scheduler to the minumum.

2001-02-16  Matti Aarnio  <mea@zmailer.org>

	* scheduler/readconfig.c:
	    One-off bug in ${ZENV} substitution code.

	* configure.in:
	    Derive  ZCONFIG  (formely defaulted to  /etc/zmailer.conf)
	    from  --prefix  !  The same way as --prefix derives
	    $MAILSHARE.    Officially zmailer.conf's new location
	    *is* $MAILSHARE.

2001-02-15  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/fqdnaliases.cf:
	    Moved the local-part (user) extraction up a bit so that
	    it can be given to the listaddresses as expansion parameter.

	* router/functions.c:
	    At  $(listaddresses ..) and $(listexpand ..)  functions,
	    support '"%1"@..' type substitutions with '-l' option.
	    I am now considering this *wrong* approach, and am doing
	    more sendmailish approach to %N substitutions.

	* router/functions.c, router/db.c, router/libsh/search.h:
	    Support up to 8-9 additional substitution options at the
	    database lookups.  At the moment is lacking the actual %N
	    substitution code!  WORK IN PROGRESS!

	* scheduler/mailq.c:
	    a bit of comments & one missing newline on error printouts.

2001-02-14  Matti Aarnio  <mea@zmailer.org>

	* router/router.c:
	    Cut down logging/log printing a bit -- duplicated data
	    actually.

2001-02-13  Matti Aarnio  <mea@zmailer.org>

	* proto/scheduler.conf.in, scheduler/readconfig.c:
	    Allow ${ZENV} substitutions in PARAM lines.
	    ("PARAMauthfile" and "PARAMmailqsock", to be exact.)

	* smtpserver/policytest.c:
	    Do Test-Rcpt-DNS-RBL also based on FULL userid lookup.
	    Allows some users to want the lookup, others not.

	* proto/cf/SMTP.cf.in, proto/cf/SMTP+UUCP.cf.in:
	    Search for the 'mail.conf' from  $MAILSHARE/mail.conf,
	    and not from  /etc/.

2001-02-08  Matti Aarnio  <mea@zmailer.org>

	* router/functions.c:
	    At  $(filepriv ...)  function, when the call supplies
	    file userid, do presume valid REGULAR file.  This is true
	    for several databases which produce privilege controlling
	    results.

	* proto/cf/canon.cf, proto/cf/rrouter.cf:
	    More issues at DECNET-IV type address analysis.
	    Now we support a bit of being DECNET-IV gateway, although
	    we propably need to rewrite headers major way to be able to
	    route to and from DECNET-IV domains.

	* smtpserver/Makefile.in:
	    Do refer to wantconn.o file in the OBJS macro, it needs to
	    be compiled in case it is wanted to be used...

2001-02-01  Matti Aarnio  <mea@zmailer.org>

	* man/mailbox.8, transports/mailbox/mailbox.c:
	    Add two more environment variables to pre-existing
	    ones at the mailbox driven subprocesses:
	    - MSGSPOOLID=<ZMailer-internal-spoolfile-id>
	    - MESSAGEID=<somebody-supplied-string>
	    These were created when I had a need, of course..
	    Pipe driven application should be able to syslog(3)
	    meaningfully what was the message disposition.
	    (Majordomo in my case ;) )

2001-01-31  Matti Aarnio  <mea@zmailer.org>

	* configure.in, acconfig.h:
	    - --with-routeruser-is-abnormal  option
	    - detect possible pre-existing ROUTERUSER_IN_ABNORMAL_UNIX
	      value in zmailer.conf file
	    - in case of wanting to use tcp-wrappers, do analyze if it
	      needs adding -lnsl library in addition to -lwrap -- some
	      unfortunate systems (RedHat 6.2-7.0) compile the bloody
	      wrapper library with one NIS call, and the ZMailer does not
	      use NIS libraries for anything (except if router wants..)

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/smtpdata.c:
	     Arm the alarm(2) just before call to read(), and re-arm
	     it right after return from it.  This *may* cut down the
	     number of alarm(2) calls a bit.
	
	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/wantconn.c, scheduler/transport.c,
	  scheduler/wantconn.c:
	    #ifdef  USE_TCPWRAPPER   in addition to  #ifdef HAVE_TCPD_H

2001-01-30  Matti Aarnio  <mea@zmailer.org>

	* libresolv/gethnamaddr.c:
	    Silence the code in several occasions.
	    Getting SIG data is *not* a problem, it *does* happen.

	* smtpserver/smtpserver.c:
	    Clean "RSET" response from
	      "250 2.0.0 2.0.0 Reset processed.."
	    to one with: "250 2.0.0 Reset processed.."

2001-01-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Change all instances of  getaddrinfo()  parameters of
	    service name "smtp" to port-number "0".  Give also
	    some detail on what the getaddrinfo() diagnostics gave.

	* router/functions.c:
	    - In  $(listaddresses ..)  and  $(listexpand ..)  functions,
	      explicitely support receiving lines with '#'- starting them
	      (comments, you see).  Also when found no addresses,
	      explicitely do mention A) what EUID the expansion was
	      running, and B) that user should check the file/directory
	      protections of the original file.
	    - Also, the $(filepriv ...)  function will from now on
	      allow wider opening privileges in some cases -- if
	      residence directory does not have X-bits in group
	      and/or world, then related bits in the file are not
	      checked -- i.e. if the directory is not world-
	      accessible, it is irrelevant if file has w-bit in
	      world set.

	* proto/cf/SMTP+UUCP.cf.in, proto/cf/SMTP.cf.in:
	    Couple of fixes, and code rearrangements into
	    the sample boiler plate.

	* transports/smtp/getmxrr.c:
	    Play a bit more with  rmsgappend()  calls here.
	    Specifically report if  getaddrinfo()  calls report
	    some diagnostics!

2001-01-24  Matti Aarnio  <mea@zmailer.org>

	* lib/selfaddrs.c, transports/smtp/smtp.c:
	    If resolver supports option flag  RES_USE_INET6, but
	    system doesn't support IPv6 socket, clear that flag.

	* libresolv/gethnamaddr.c, libresolv/netdb.h:
	    When using   --with-bundled-libresolv  silence things a bit
	    as one particular #define may be set before calling this.
	    Also, do explicitely at first lookup /etc/hosts file for
	    host, only then do resolver lookups.

2001-01-22  Matti Aarnio  <mea@zmailer.org>

	* include/libz.h, include/mailer.h, compat/sendmail/sendmail.c,
	  lib/nobody.c, lib/pwdgrp.c, lib/trusted.c, router/functions.c,
	  router/router.c, scheduler/readconfig.c, smtpserver/zpwmatch.c,
	  transports/hold/hold.c, transports/mailbox/fmtmbox.c,
	  transports/mailbox/mailbox.c, transports/mailbox/mboxpath.c,
	  transports/smtp/smtp.c, transports/smtp/smtp.h,
	  utils/vacation/Makefile.in, utils/vacation/vacation.c:
	    Use  zgetpwnam()  everywhere where there used to be
	    getpwnam(),  supply also our very own   struct Zpasswd
	    for the data referral.
	    Library  lib/pwdgrp.c  is the location of the wrapper
	    function, which intention is to clarify error handling
	    of various systems -- getpwnam() returning NULL may mean
	    many things, and interpreting  errno  is -- challenging.

	* libsh/builtin.c, libsh/interpret.c, libsh/variables.c,
	  proto/cf/SMTP+UUCP.cf.in, proto/cf/SMTP.cf.in,
	  proto/cf/aliases-new.cf, proto/cf/aliases.cf,
	  proto/cf/consist.cf, proto/cf/fuzzy-aliases.cf,
	  proto/cf/process.cf, proto/cf/rrouter.cf,
	  proto/cf/server.cf, proto/cf/standard.cf, README.UPGRADING:
	    Change internal variable expantion to never do IFS
	    tokenisation at expanded strings.
	    Supply  $(ifssplit ...)  function in case it is needed
	    for something, and just token-lists don't make it.
	    Write some definite words on README.UPGRADING !

2001-01-22  Eugene Crosser <crosser@online.ru>

	* transports/libta/mimeheaders.c:
	    Sometimes quoted string (to de stripped) is really not,
	    and we must be carefull to do it only with a string of
	    minimum length of 3.

2001-01-22  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    When the reply collection goes to timeout ( smtp_sync() ),
	    CLOSE the smtp-connection.  Also do rmsgappend() a report,
	    that reply collection went into timeout..

2001-01-16  Matti Aarnio  <mea@zmailer.org>

	* transports/hold/hold.c:
	    Do same processing here as at router/functions.c.

	* router/functions.c:
	    Condition "no such user" can be signaled with   getpwnam()
	    yielding NULL and errno == 0.  Not only   errno == ENOENT.

	* lib/dbpwdgrp.c, lib/nobody.c, lib/pwdgrp.c, lib/trusted.c,
	  router/daemonsub.c, router/functions.c, router/router.c,
	  transports/mailbox/mailbox.c:
	    Essentially in front of *every*  getpwnam(),  do place
	    explicite clear of   errno  variable.
	    Apparently at Solaris 2.6 it isn't cleared/set quite always
	    when doing error paths...

2001-01-15  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c:
	    Typo -- mmfd_mode which should be  mmdf_mode ...

	* transports/libta/diagnostic.c:
	    #include <errno.h> -- apparently cc at Solaris 2.6
	    didn't like it without :-/

	* smtpserver/smtpserver.h, smtpserver/cfgread.c:
	    More Sol26/SunSoft CC things.

	* lib/rfc822scan.c:
	    Recognize  "HOST::USER"@decnet-IV.gw  syntax,
	    and don't ever unquote it.  We don't support
	    being the DECNET-IV gateway ourselves.

	* proto/zmailer.sh.in:
	    If  dbases.conf  is not in use, and we execute
	    'zmailer newdb', do 'newdb' the $MAILSHARE/db/mboxmap
	    also.

2000-12-31  Matti Aarnio  <mea@zmailer.org>

	* transports/mailbox/mailbox.c:
	    At normal success path, do proper  fsync(2)  return
	    status analysis - if the filesystem where the write
	    goes to is ever truly asynchronous, the only way to
	    know if it runs out of diskspace, or whatever is after
	    the return of fsync(2).

	* libc/mail.c, libc/sfmail.c, scheduler/msgerror.c,
	  router/rfc822.c, transports/libta/diagnostic.c:
	    More of carefull  fsync(2)  calls.

	* transports/mailbox/mailbox.c, smtpserver/smtpcmds.c,
	  transports/libta/diagnostic.c:
	    Also carefull wrappers for  ftruncate(2)  calls.

2000-12-30  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/mimeheaders.c:
	    Survive bad control characters in input.

	* proto/cf/aliases.cf:
	    Sender address rewrite function to yield full
	    "$user$plustail$domain" - incoming quad arrives
	    without domain part.

	* router/rfc822.c
	    When in 'trace sequencer', do debug print call
	    parameters to $(crossbar ...) before the call.

	* scheduler/readconfig.c, scheduler/transport.c:
	    setpriority() syscall autoconfig things

2000-12-14  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c:
	    "BDAT 0 LAST" is valid per explicite example at RFC 3030.
	    It is also valid per syntax, but not quite so by mere
	    engineering thought...
	
2000-12-04  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/mimeheaders.c:
	    ElectricFence is your friend!  Writing over
	    the end of the allocated array by on element :-/

2000-12-02  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Don't soften reception of RCPT TO if MAIL FROM gave
	    500 series code -- there was some reason for this...

	* transports/libta/tasyslog.c:
	    Report correctly if we have detected MULTIPART(QP).

	* lib/selfaddrs.c:
	    Something odd at Solaris -- none of supported functions
	    got called ??? -- realloc() bug :-(

	* All over the place;
	    Changeing  getzenv()'s  return value to 'const char *'
	    caused all kinds of nuisance warnings to sprout...

	* All over the place; (Makefile.in):
	    More "make -j N" work.

2000-12-01  Matti Aarnio  <mea@zmailer.org>

	* lib/linebuffer.c, lib/selfaddrs.c, router/daemonsub.c,
	  scheduler/scheduler.c:
	    Changed some code doing
	    	if (!ptr) ptr = malloc(..); else ptr = realloc(ptr,..);
	    into
	    	ptr = realloc(ptr,...)
	    after wanting to simplyfy one part of code and reading
	    man-page..

	* Makefile.in, libident/Makefile.in, libs/Makefile.in,
	  libsh/Makefile.in, router/Makefile.in, smtpserver/Makefile.in,
	  router/libdb/Makefile.in, sfio/Makefile.in,
	  sfio/src/lib/sfio/makefile.in, 
	  sfio/src/lib/sfio/Stdio_b/Makefile.in, 
	  sfio/src/lib/sfio/Stdio_b/sfstdhdr.sh:
	    Tried to "make -j 20" and learned things about parallellism..
	    Things really aren't correct yet, and at least sfio may end
	    up being compiled some N-4 times in parallel...

	* transports/smtp/smtp.c:
	    Modify some loops - removed unnecessary state free()er code
	    from within the  smtp_sync()  -- with a theory that the
	    pipecmds[] array goes boinkers somewhen...

2000-11-30  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/mimeheaders.c, transports/mailbox/mailbox.c,
	  transports/smtp/smtp.c, include/ta.h:
	    Content-Type Parser had reversed pointers -- oops
	    Changed parsers (multiple) parameters from (char **)
	    to (char *)

	* transports/libta/mimeheaders.c:
	    RFC822 ATOM skipping didn't.. (single-char atoms)

	* transports/libta/swriteheaders.c,
	  transports/libta/fwriteheaders.c:
	    Reusing variable caused wrong content at the pointer,
	    and rare SIGSEGVs lurking ...

2000-11-24  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/mimeheaders.c:
	    Simplify!  More of the simplification of code.

	* transports/libta/ctlopen.c:
	    add a bit to an allocation -- not that it really
	    should matter, but ...
	
	* transports/smtp/smtp.c:
	    sprinkled  smtp_flush() around places while hunting one
	    nasty memory corruption.

	* transports/libta/swriteheaders.c,
	  transports/libta/fwriteheaders.c:
	    Some leftover counter adjustments in places where
	    it now harmed...

	* transports/smtp/smtp.c:
	    Debugging most peculiar problems - propably at swriteheader.c
	    Showing at the verbose log the WRITTEN headers.

	* transports/smtp/smtp.c:
	    A bit different handling on pipelined response collection.
	    If MAIL FROM yields an error, report it, never mind what
	    socket read did later..

	* transports/libta/mimeheaders.c:
	    Simplify!  Don't try to be smart when playing with malloced
	    buffers -- it doesn't pay, quite contrary...  Found a number
	    of cases where a buffer got reallocated, but a pointer into
	    it wasn't adjusted into the new area.

	* transports/libta/swriteheaders.c,
	  transports/libta/fwriteheaders.c:
	    Changed the code from "scan the input to determine future
	    space needs" to "(re)expand as more space is needed" to
	    make sure there is no discrepancy in between the two.

2000-11-23  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Few hours of going over the  smtp_sync()'s smtp_nbread()
	    call, and its surroundings.  Inverted its logic, and finally
	    got simple, clean, understandable code.  ("I smell Wumpus!")

	* scheduler/mailq.c:
	    Wondered that "mailq -vv" didn't show diagnostic messages
	    along other data.  Now it does.  Plus other small tuneups
	    of the result.

	* transports/smtp/smtp.c:
	    A bit more of care on referencing 'logfile' variable.
	    Not using uninitialized one.

	* transports/mailbox/mailbox.c:
	    A trivialish  return-receipt-to  processing fixup at
	    the mailbox so that the user-supplied string is unfolded
	    into single line with spaces in places of folds (newlines).
	    (Proper fix is FULL RFC 822 scanner to pick the recipient
	     address, but perhaps not...)

	* transports/smtp/smtp.c:
	    Blocking read waiting was done with busy-loop, and
	    if the connection *stays* in ESTABLISHED state, but
	    never timeouts --> busy spin goes on, and on...

	* scheduler/msgerror.c:
	    Don't try to be clever with cfp->mid field reuse at
	    the slurp()ed instance -- use incoming 'cfpi->mid'.

2000-11-21  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Meaningless variable name changes (and some revoked changes
	    which got committed into CVS - and now removed.)

	* transports/libta/fwriteheaders.c,
	  transports/libta/swriteheaders.c:
	    One subtle bug in BDAT buffering mode left in line-ending
	    newline handling --> surprising crashes seen.

	* transports/libta/mimeheaders.c:
	    Reserve a bit more space for coalesced mime-headers
	    (of "totlen" type).

	* transports/smtp/appendlet.c:
	    Outch! Messages without Content-Type: header did SIGSEGV!

	* lib/selfaddrs.c:
	    there is no field called ifr_ifindex, there is: ifr_index
	    -- returned to previous: memset(ptr, 0, size)
	    -- because Linux glibc 2.1+ has ifr_ifindex, solaris has
	       ifr_index   (barf...)

2000-11-19  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8, smtpserver/policytest.c:
	    Lowercasify the lookup key for alias item lookups,
	    and fill in the doc/guides/smtp-policy header into
	    the manual page of the smtpserver.

2000-11-17  Matti Aarnio  <mea@zmailer.org>

	* scheduler/threads.c, scheduler/mailq.c:
	    Some experiments of making the  mailq-v2  mode mailq
	    to show same things as the old version was able with
	    'verbose' mode turned on.

	* **/Makefile.in:
	    Changes on what we refer at LIBDEB= definitions.

	* transports/libta/mimeheaders.c:
	    - Missing initialization of one buffer -> result is
	      memory scrible and utter chaos..
	    - Wondering of X-Warning: writer does something fishy,
	      as the Received: header generated by the site where
	      that writer is used does not appear in the message..

	* proto/scheduler.conf.in, proto/db/routes:
	    Define channel   smtp-log  which (obviously) logs
	    the SMTP protocol into log-file.  See "-l" option
	    at  smtp(8) man-page.

2000-11-16  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Some reworking around NDBM tests -- we *MAY* have
	    problems when <ndbm.h> is actually from BSD DB 1.85.
	    Specifically in OpenBSD 2.7, several other BSDs as well.

	* transports/smtp/getmxrr.c, scheduler/mailq.c,
	  libc/myhostname.c:
	    BSD  getaddrinfo()  call returns ai_canonname member as NULL
	    in very common cases!  Uargh :-(

	* lib/Makefile.in:
	    At  'make selfaddrs-test', do use autoconfigured @LIBRESOLV@
	    library reference.

2000-11-14  Matti Aarnio  <mea@zmailer.org>

	* lib/selfaddrs.c, lib/zgetifaddress.c:
	    Fix the support for FreeBSD 4.2*/OpenBSD 2.7* featured
	    getifaddrs() function.

	* Makefile.in:
	    Mark version "2.99.55-pre1cvs" (which means nothing much)

	* include/ta.h, transports/libta/fwriteheaders.c,
	  transports/libta/swriteheaders.c, transports/libta/markoff.c,
	  transports/libta/mime2headers.c, transports/libta/stringlib.c,
	  transports/libta/mimeheaders.c, transports/smtp/appendlet.c,
	  transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Initial steps towards doing proper format downgrade
	    during (SMTP) transport.
	    - Modified header handling to process folded lines as single
	      string, not as a sequence of strings.
	    - Wrote proper RFC822/MIME token scanner into  mimeheaders.c
	      which is able to correctly skip over places where
	      (folded)LWSP is allowed, including possible (comments)
	      in them.

2000-11-12  Matti Aarnio  <mea@zmailer.org>

	* CVS tagged this as Version zmailer-2-99-54-patch1
	  Made also CVS based diff against 2.99.54.

	* lib/selfaddrs.c:
	    Learned something about the SIOCGIFFLAGS/SIOCGLIFFLAGS
	    ioctl parameters, and what is necessary for initializing
	    its call.

	* transports/smtp/smtp.c:
	    Some oddball moments don't fail properly after response
	    timeout during certain critical periods -- mainly of
	    DATA/RSET.
	    Doing   smtpclose()  where we used to RSET  right after
	    DATA has been sent, and response to it has been waited
	    for way too long..

2000-11-02  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c:
	    Turn the listening sockets into NON-BLOCKING mode,
	    and once connection is accept(2)ed, turn the communication
	    socket into blocking mode.

	* transports/smtp/getmxrr.c:
	    Randomish bounces seen at  vger.kernel.org  for domains
	    which have non-functional DNS servers (likely due to
	    network failure, or some such.)  Symptom seems to
	    indicate NXDOMAIN DNS query reply status, but the
	    darn thing happens *rarely*...
	    ... I am not sure this change is a smart thing to do,
	    ... and later on I removed this change.
	    It looks like getting NXDOMAIN is trouble at whatever
	    system happens to be the DNS server, and we are better
	    off when we don't trouble ourselves too much with
	    circumventations at the resolver code for it.

2000-10-31  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Move the  notarystatsave()  function call up so that it will
	    always be called for all collected replies.  Formelly there
	    were cases where it didn't get called, which caused somewhat
	    weird looking results when the TA program switched to
	    alternate destination domain.

	* libc/getaddrinfo.c:
	    Disable entirely the AF_LOCAL support.
	    The code in question used tmpnam() which created some
	    complaints from the recent linker/libc at RH 6.2/7.0
	    hybride system.

	* configure.in, proto/smtpserver.conf(.in):
	    Turns out that "make install" when working in "adjacent
	    directory" setup doesn't pick correctly the smtpserver.conf
	    for the installation.  Returning to generated smtpserver.conf
	    file, although strictly speaking that is not needed.

	* proto/db/dbases.conf, utils/policy-builder.sh.in,
	  proto/newdbprocessor.in:
	    Spotted a few mistakes at the perl scripts of newdbprocessor.
	    With a hindsight -- me stupid...
	    Spotted also missing "-d pathalias" at "routesdb"
	    specification.  And some awk cleanups at policy-builder
	    as well, of course.

	* packaging/solaris/README:
	    Some additional comments on usage of this tool subset.

2000-10-24  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/rrouter.cf, proto/cf/canon.cf:
	    Support magic trick:
		@[CHANNELNAME]:user@domain
	    in such a manner as to produce
		(((CHANNELNAME domain user@domain ATTRIBUTES)))
	    routing result

2000-10-23  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, utils/mxerify/mxverify-cgi.c:
	    For IPv4 addresses, verify that our connect(2)
	    destination is of valid IPv4 network (first octect
	    is in range of 1..223), at mxverify exclude loopback.

	* transports/smtp/Makefile.in:
	    Add into "make install" installation of $MAILBIN/getmxrr-test
	    so that it will be available at all installations...

	* utils/mxverify/mxverify-cgi.c:
	    Small text changes.

	* transports/smtp/smtp.c:
	    Noticed a few places where we need to reset the
	    "SS->rcptstates" variable.

2000-10-20  Matti Aarnio  <mea@zmailer.org>

	* proto/Makefile.in, packaging/Makefile.in:
	    'make install' will install also 'doc/guides/*' files
	    into $MAILSHARE/guides/  -- there seems to be call for
	    those files from some users...  In other environs,
	    like Linux distributions, there could be some sort
	    of  /usr/share/doc/zmailer-NNN/guides/ for them.

	* doc/guides/smtp-policy, utils/policy-builder.sh.in:
	    Defined ".manual" versions for ".mx", and ".relay"
	    of  smtp-policy driver files.  This enables more
	    wide-spread automated data fill-in, plus local
	    ".manual overrides".

2000-10-17  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/ctlopen.c:
	    Return NULL, not 'void' in certain silence case.

	* transports/libta/diagnostic.c:
	    Try not to do so verbose diagnostic report over
	    syslog as via TA->scheduler channel.

	* smtpserver/smtpdata.c:
	    Parse possible "contentpolicy" analysis report, and present
	    it (in several cases) to the user.

	* smtpserver/smtphelp.c:
	    Small fixes for help presentation, and parameter recognition.

2000-10-16  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpdata.c, smtpserver/smtphelp.c,
	  smtpserver/smtptls.c, smtpserver/smtpserver.c:
	    Rethought of things, killed the Z_printf() abomination.
	    Also fixed inadverent NULL referral which Eugene Crosser
	    found as well.  (It blocked my incoming email :-( )

	* man/smtpserver.8, smtpserver/contentfilter.c,
	  smtpserver/smtpdata.c:
	    Improved documentation of the CONTENTFILTER INTERFACE
	    ( = wrote it ), and modified a bit of the interface itself.

	* configure.in, proto/smtpserver.conf, smtpserver/cfgread.c,
	  man/smtpserver.8, proto/Makefile.in, 
	    Allow $ZENV expansions in smtpserver's configuration.
	    Thus allow simpler moving of the thing to other location
	    without needing to edit anything but  zmailer.conf  file..
	    Also removed  smtpserver.conf  from autoconfigured
	    protofiles.

	* scheduler/readconfig.c, smtpserver/cfgread.c,
	  transports/sm/sm.c, transports/mailbox/mailbox.c,
	  transports/smtp/smtptls.c:
	    Changed all instances of macro-in-macro style CPP things
	    of 'SKIPWHILE(testfunction,varname)' to be appropriate
	    'SKIPSPACE(varname)' and 'SKIPTEXT(varname)'.
	    (RedHat 7.0 gcc version does not work correctly with those..)

	* smtpserver/policytest.c, smtpserver/rfc821scn.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c,
	  smtpserver/smtpetrn.c, smtpserver/smtpserver.c,
	  smtpserver/smtpserver.h, smtpserver/smtphelp.c,
	  smtpserver/mxverify.c:
	    Aimed for some coherence at debug mode printouts/flushes
	    in some cases.  Mainly the problem is that at
	    the policytest.c,  and at the mxverify.c the debug output
	    goes to stdout via printf(), while elsewere it goes
	    via type() to SFIO attached to the connection.
	    TO BE ACCURATE, AS THINGS ARE NOW IS NOT SUITABLE
	    FOR DEBUGGING E.G. SSL WRAPPED SESSIONS!

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  smtpserver/cfgread.c, smtpserver/smtptls.c:
	    - Have new runtime flag (-t) telling that this is a session
	      running immediately under TLS (port tcp/465, "ssmtp"),
	      which feature predates STARTTLS facility.
	    - Have parallel listen socket for two different services;
	      namely plain 'smtp', and 'ssl/smtp')

	* scheduler/mq2auth.c, scheduler/msgerror.c, include/libz.h,
	  scheduler/readconfig.c, lib/cfgets.c, smtpserver/cfgread.c,
	  transports/errormail/errormail.c, transports/mailbox/mailbox.c,
	  transports/sm/sm.c, transports/smtp/appendlet.c:
	    Renamed that function to be   csfgets()  -- after I myself
	    got confused about its calling convention...
	    (That is: FILE * or Sfio_t * thing..)

2000-10-13  Matti Aarnio  <mea@zmailer.org>

	* sfio/src/lib/sfio/makefile.in,
	  sfio/src/lib/sfio/Stdio_b/Makefile.in:
	    Noticed an omission in cross-directory compilations.
	    Sometimes 'iffe' would fail when directory 'FEATURES' didn't
	    exist at the running position.  Oops.

2000-10-12  Matti Aarnio  <mea@zmailer.org>

	* utils/makedb/dbdump.c:
	    New option:  -policydump   which decodes the policy
	    binary set into a text.

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c,
	  man/smtpserver.8, smtpserver/cfgread.c, smtpserver/smtphelp.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpdata.c:
	    Implemented experimental LMTP (RFC 2033) support,
	    this is *not* for real LMTP use, merely for debugging
	    LMTP clients.

	* transports/smtp/smtp.c, transports/smtp/smtp.h,
	  proto/scheduler.conf.in:
	    Completed the LMTP (-M) mode, tested it quite a bit with
	    and without remote speaking PIPELINING. Can support even
	    remotes announcing STARTTLS capability in the LMTP port.
	    Removed duplicate remote response analysis code from
	    synchronous (non pipelined) code path, now using only
	    the  smtp_sync()  to collect replies.

	    Supplied sample "smtp-lmtp/*" configuration for use. 

	* proto/zmailer.sh.in:
	    Do cd to $POSTOFFICE  when starting smtpserver.
	    Dropping cores to system root is not polite..

	* man/sendmail.8, man/zmsh.1:
	    Changed <mea@utu.fi> to <mea@nic.funet.fi>

	* man/smtp.8:
	    Mention RFC 2033 and LMTP at the RFC list in the end.

	* man/scheduler.8, scheduler/mq2auth.c, proto/scheduler.auth.in:
	    Allow multiple instances of same userid by scanning
	    the address ACLs at each UID.  Thus nobody@localhost
	    can get different level of access from nobody@elsewere.

2000-10-10  Ambrose Li <acli@mingpaoxpress.com>

	* utils/vacation/vacation.c:
	    Removed some duplicate code, and detect autoreplies whose
	    source address is:  <>

2000-10-10  Matti Aarnio  <mea@zmailer.org>

	* lib/Makefile.in:
	    "make install" did put zmailer.h into
	    $prefix/$prefix/include/,    which is "somewhat" wrong...

	* man/smtp.8, transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Implemented LMTP (RCF 2033) at the smtp TA program.
	    To enable LMTP, use option '-M'.

	* scheduler/mq2.c:
	    When reporting "unknown" command, do tell things differently:
	      "Unknown command, or refused by access control;" ...

	* smtpserver/mxverify.c:
	    Fix the IPv6 nybble-reverse code to do proper in6 type
	    reverser, although an alternate (binary labels) is defined
	    these days...

	* transports/libta/ctlopen.c:
	    See if the message to be opened is an ETRN request -- if yes,
	    just return with failure...  (manual-expirer triggers this.)

	* transports/libta/mimeheaders.c:
	    While parsing for Content-Type: parameters, allow LWSP in
	    same lines.  Full specification really calls for RFC 822
	    tokens along with CWSP and commend handling.

	* transports/mailbox/mailbox.c:
	    Separates "From MAILER-DAEMON " from "Return-Path: <>".
	    Produces "X-Envelope-To: <...>" header.

	* ChangeLog, INSTALL, Overview, README.TCP-WRAPPER,
	  README.UPGRADING, compat/sendmail/sendmail.c,
	  doc/guides/configure, doc/guides/smtp-etrn,
	  include/zmsignal.h, lib/hashtest.c,
	  man/smtpserver.8, proto/smtpserver.conf.in,
	  proto/cf/aliases-new.cf,
	  proto/cf/aliases.cf, proto/cf/rrouter.cf,
	  proto/cf/standard.cf, router/prototypes.h,
	  router/rfc822walk.c, scheduler/msgerror.c,
	  scheduler/scheduler.c, smtpserver/rfc821scn.c,
	  transports/sm/sm.c, smtpserver/smtprouter.c,
	  transports/libta/diagnostic.c,  transports/mailbox/mailbox.c,
	  transports/smtp/smtp.c,  utils/smtpserver-log-parser.pl.in,
	  utils/pop-proxy/pop-proxy.c:
	    A great speller-bee of "propab*" -> "probab*".

2000-09-26  Matti Aarnio  <mea@zmailer.org>

	* man/sm.8, transports/sm/sm.c:
	    Updated (with a radical hand) the manual page to list
	    what sendmail 8.11 does with flag characters, and what
	    the ``sm'' does with same characters (and some more).

2000-09-25  Matti Aarnio  <mea@zmailer.org>

	* transports/hold/hold.c:
	    This was left out from the commit 4 days ago.

	* libresolv/sys/bitypes.h, sfio/src/lib/sfio/sfhdr.h,
	  ssl/ssl.c:
	    Experimental changes to support compilation at AIX 4.1.

	* proto/db/dbases.conf:
	    The 'thishost' relations used to carry '-d pathalias'
	    driver option on original systems, now it was missing..

2000-09-22  Matti Aarnio  <mea@zmailer.org>

	* proto/Makefile.in:
	    An adjacent directory install failed when system
	    does not have suitable binary 'install' program, and
	    'install.sh' is needed.  Rearranged things.

2000-09-21  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mq2auth.c, scheduler/scheduler.c:
	    File leakage at authuser(), which caused opendir() to fail,
	    and its resulting NULL was used unprotected -> SEGV.
	    (Ran out of free file descriptors.)

	* router/functions.c, transports/hold/hold.c,
	  proto/cf/aliases.cf:
	    "hold" handling for the $(homedirectory ...) function.

2000-09-20  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/rrouter.cf, proto/db/routes:
	    Generalizing on various smtp* mechanisms.

	* proto/scheduler.conf.in:
	    Channel prototypes for  smtp77/*, smtp77x/*, and others.
	    Some reordering, and log option rearrangements.

	* transports/smtp/smtp.c, man/smtp.8:
	    ESMTP disabler feature. ( -77 option )

	* packaging/solaris/Makefile.in, packaging/solaris/README,
	    More work at package manufacturing, now it likely works
	    and produces suitable Solaris PKG files.

	* Makefile.in:
	    Copy current compilation time valid  config.status  and
	    ChangeLog files into $MAILSHARE  directory.  Those give
	    a very good idea of HOW the package was made.

	* packaging/solaris/*:
	    Reworked a bit with Solaris pkgmk wizard..

	* proto/cf/aliases.cf:
	    A nuisance (unlikely a security problem) with *-group
	    expansion.  One pair of double-quotes missing.

	* scheduler/mq2.c:
	    mq2_discard() function did completely bogus chain traverse.
	    Oops..

2000-09-19  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version 2.99.54 (retagged here)
	
	* lib/getaddrinfo.c, lib/getzenv.c,
	  smtpserver/mxverify.c, smtpserver/smtpcmds.c:
	    Pointer arithmetic with (void*) !! Urgh..

	* smtpserver/Makefile.in:
	    Oops.. QC failure, wrong dependency order -> compilation
	    failure

	* router/functions.c, proto/cf/aliases.cf, proto/cf/fqdnalias.cf:
	    Suspended the  $(zapDSNnotify ...) processing development.
	    The issues I am trying solve there are rather -- complicated.

	* router/daemonsub.c:
	    Do test for "an inode in processing" while looking for
	    tasks in the router subdirs -- thus won't reinsert a
	    task already in active handling back into the queue.

	* proto/newdbprocessor.in:
	    Test for "^bind", "ldap", "ordered" and "unordered" db
	    types while regenerating the dbases.conf relations.

2000-09-18  Matti Aarnio  <mea@zmailer.org>

	* scheduler/transport.c:
	    A verbose debug printing of the 

2000-09-14  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpetrn.c:
	    Teached IPv6 support to the ETRN-Cluster code.

	* scheduler/transport.c, scheduler/mq2auth.c:
	    If system allows, create the "mailq" port in IPv6 space.
	    Know how to turn IPv4-Mapped-in-IPv6 address into IPv4 one,
	    and thus be able to test it neatly.

2000-09-08  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/getmxrr.c:
	    Even when we have seen EAI_AGAIN results, be a happy
	    camper in the end if we get ANY MX entries which have
	    valid address records.

2000-09-07  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/bsdbtree.c router/libdb/gdbm.c:
	    At iterative DB walkthroughs there were some
	    problems at these two functions.  Now they
	    should a) find data, b) terminate.

2000-09-04  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Change linkage order of  -lnsl vs. -lxnet.
	    If -lxnet leads, SEGV is about guaranteed. :-( 
	    (That is utterly weird problem...)
	
	* libc/myhostname.c:
	    If system does not carry  getaddrinfo(3)  function
	    in its standard repertoire (or we are told not to use
	    possibly existing system instance due to e.g. bugs),
	    then use "old-fashioned"  gethostbyname(3)  function
	    to resolve canonic hostname.

	* utils/makedb/dblook.c:
	    The "-dump" mode has been broken for a while.
	    Turned out that auto-variables for key & data need
	    (apparently) be zeroed before even the R_FIRST
	    position pickup succeeds.  D'uh !

	* lib/selfaddrs.c:
	    Solaris resolver function don't apparently like (at all)
	    if the host parameter to e.g. gethostbyname() is 0-size
	    string.

	* smtpserver/cfgread.c, man/smtpserver.8:
	    Recognize "PARAM bindaddr iface:...." syntax to define
	    named interface on which SOME address you want to bind.
	    (Prefers IPv6 if such exists, otherwise IPv4.)

	* smtpserver/smtpdata.c:
	    During DATA and BDAT processing, if the feeder
	    failed to send first 1024 bytes of content, our
	    data transfer watchdog timer was not initialized.
	    I was wondering why one Solaris machine kept
	    collecting hanging smtpserver processes...

	* libc/mailvars.c, libc/mail.c, libc/sfmail.c:
	    - Rearranged couple of variables to separate file
	      so that  mail.c  object won't be included when
	      not needed..  (at the scheduler, and at the mailbox)
	    - reworked file renaming to always use ino based
	      decimal number string at the destination directory.
	    - reconverted mail.c to SFIO based sfmail.c

2000-08-30  Matti Aarnio  <mea@zmailer.org>

	* compat/sendmail/sendmail.c:
	    - Recognize  "sendmail -bd"  as an order to run "zmailer"
	      script.
	    - Input and encode INFROM= data into DSN dataset.

	* proto/cf/aliases.cf, proto/cf/crossbar.cf,
	  proto/cf/fqdnalias.cf, proto/cf/standard.cf,
	  router/functions.c, router/prototypes.h,
	  router/rfc822.c, router/shliaise.c:
	    - New experiental code to handle DSN data handling bugs
	      in alias expansion-like situations.
	      This is NOT complete thing!
	    - Debug code to analyze the effects of the SCHEDULERDIRHASH
	      ZENV variable.

	* transports/libta/ctlopen.c:
	    Recognize (but skip)  INFROM=  DSN metadata.

	* utils/Makefile.in, utils/mxverify/getaddrinfo.c:
	    Copied the  getaddrinfo.c  from libc/  to this
	    utility.  Made "make clean" and "make distclean"
	    work from toplevel so that they will also clean
	    the  utils/mxverify/ subdir.

	* Makefile.in:
	    At the end of "make install", correct the "post-install"
	    suggestion to correct program name.

	* scheduler/mailq.c:
	    Do set the PORTNUM to the destination socket addresses
	    before trying to connect -- connecting to port 0 is not
	    usually a successfull thing...

	* libc/getaddrinfo.c:
	    At Solaris the  uname(2)  call return NON NEGATIVE
	    value on success, not necessarily ZERO as in Linux...

2000-08-29  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mq2auth.c:
	    Copy addresses into separate range buffers for
	    masking and comparison.  (Generalized the function).

	* scheduler/msgerror.c:
	    Construct the report message somewhat differently

	* scheduler/udpate.c:
	    Do certain diagnostics only when  (verbose)  flag is set.

	* transports/smtp/getmxrr.c, transports/smtp/smtp.c:
	    Remove more old debug statements, make sure that
	    lack of memory from  getaddrinfo() is handled
	    properly (e.g. exit(EX_OSERR) -- not best, but..)

2000-08-23  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mailq.c:
	    Use  getaddrinfo()  to pick the peer address.

	* include/listutils.h:
	    Incorrect ANSI-C pre-processor string concatenation
	    directive use.

	* libc/myhostname.c:
	    Pick any of my possible addresses, don't specify port.
	    (We are looking for CANONIC NAME, after all..)

	* smtpserver/smtpdata.c:
	    Pipelined BDAT after failed MAIL FROM segfaulted
	    on one unprotected SS->mfp referral.  Oops.

2000-08-21  Matti Aarnio  <mea@zmailer.org>

	* libc/getaddrinfo.c:
	    Complete IPv4/IPv6 functionality with proper
	    timeout error handling, and malloc()ed memory
	    garbage collection.  This supplies the function
	    for   --with-ipv6-replacement-libc   cfg option.
	    (Necessary at all systems with GNU LIBC versions
	     up to 2.2. -- up to 2.3.2, very least)

2000-08-19  Matti Aarnio  <mea@zmailer.org>

	* proto/newdbprocessor.in:
	    Process the owner/group/mode triplet too.

2000-08-18  Ambrose Li <acli@ada.dhs.org>

	* configure.in, acconfig.h, scheduler/transport.c,
	  transports/smtp/getmxrr.c:
	    Linux 2.2.* with libc5 fixes.

2000-08-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/policytest.c, router/libdb/bsdhash.c,
	  router/libdb/bsdbtree.c, utils/makedb/makedb.c,
	  utils/vacation/vacation.c:
	    RedHat 6.0 BSD DB surprised somewhat... Fixes for
	    the configuration senses.

	* configure.in, libs/Makefile.in:
	    library building order correction, and autoconfiguration
	    straightening so that lack of dbm databases is reported
	    corrently. (The NDBM even with its faults is sort of ok,
	    but the DBM - its predecessor - is not...)

2000-08-02  Matti Aarnio  <mea@zmailer.org>

	* include/libz.h, scheduler/scheduler.c, scheduler/update.c,
	  lib/esyslib.c, include/ta.h:
	    To track strange looking  eunlink()  problem reported
	    by Eugene my first approach is to add identity tags for
	    eunlink() calls so I can have some additional clue as
	    to *which* of four possible places the problems are
	    occurring at.  (Fift place is impossible, fortunately.)

2000-08-02  Eugene Crosser <crosser@online.ru>

	* transports/smtp/getmxrr.c:
	    Yet another wrong index variable usage -- one which affects
	    MX-list purge of self-identity matching of MX servers.
	    Symptom:  "No MX, no address"
	    [mea: That may have been part of the problem,  getaddrinfo()
	          yielding EAI_NONAME in places of EAI_AGAIN may have
		  been another.. -- at least for me.]
	
2000-08-02  Matti Aarnio  <mea@zmailer.org>
	
	* libc/getaddrinfo.c, libc/getnameinfo.c:
	    Picked lattest versions out from  GLIBC 2.1.92 source,
	    and cleaned it up to be simple single-threaded thing
	    without locks, and without IPv6 support.
	    STILL PROBABLY LEAKS MEMORY!

2000-08-01  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Some debug printout revisions.  Somewhat embarassing to have
	    a SEGV at debug code when work-code without it works..

	* configure.in:
	    Modifications on how NDBM vs. GDBM vs. BSD DB libraries
	    are linked to ZMailer.  NDBM must be explicitely linked
	    as '-lc' if it is at libc, *and* that linkage reference
	    must be before any other as only then will there be change
	    to get real NDBM, and not some fake layers which all those
	    others do provide!

2000-07-31  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.h, scheduler/scheduler.c,
	  scheduler/msgerror.c:
	    Recognize our internal NOTIFY=TRACE flag.

	* transports/smtp/smtp.c:
	    When 'NOTIFY=TRACE' flag is present, don't send it out
	    as it is our INTERNAL thing.  Thus the change from string
	    based output to flag-based output routine.

	* include/ta.h, include/mailer.h, include/libz.h:
	    Moved  STREQ()/STREQN()/CISTREQ()/CISTREQN()  macroes
	    from  mailer.h (and ta.h)  to libz.h.

	* utils/md5sum.c:
	    Completed  usage()  function, and some comments.

	* compat/sendmail/sendmail.c:
	    Added acceptance for our internal  -N TRACE flag, which
	    is for eased debugging of RFC 2852 features.

2000-07-30  Matti Aarnio  <mea@zmailer.org>

	* libident/identuser.c:
	    A buglet in read loop.  The 'break' affects only
	    the innermost loop construct, and it needed to go
	    out the outer too..  Nuisance thing, I would say.
	    (And usage of indent is questionable anyway..)

	* smtpserver/smtpserver.h, smtpserver/smtpcmds.c,
	  smtpserver/cfgread.c, smtpserver/smtpserver.c,
	  include/ta.h, transports/libta/ctlopen.c:
	    Initial hooks for RFC 2852.

	* transports/libta/diagnostic.c:
	    Turn on, temporarily, O_APPEND flag on the file.

	* scheduler/msgerror.c:
	    Missed variable inits, and malformed format statement.

	* transports/smtp/getmxrr.c:
	    dnscache by djb produces replies which don't have NS or AD
	    sections, and when scanning replies, we had one-off
	    comparison error which bailed out in case the ANSWER
	    section reached the end of the reply packet.

	* man/scheduler.8:
	    Updating on data formats and communication protocols.

	* transports/libta/lockaddr.c:
	    Be carefull as *not* to overwrite part of diagnostic
	    data with spaces.  This has never been a bug, except
	    that trying to understand some aspects of the system
	    while updating documents revealed that we do unnecessary
	    scrubbing there.

2000-07-29  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/Makefile.in, transports/smtp/smtp.h,
	  transports/smtp/smtp.c, transports/smtp/getmxrr.c:
	    Moved  getmxrr()  function to separate file, and
	    wrapped it with a test shell in attempt to understand
	    *why* it seems to fail at some inputs at some machines.

	* scheduler/msgerror.c:
	    Hooks for "expanded" action status.

	* transports/smtp/smtp.c:
	    Streamlined error handling when returning from getmxrr().

2000-07-27  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    - At getmxrr() a missed state variable initialization
	      (to zero) caused errorneous eternal loops. OOPS!
	    - smtp_sync() didn't handle RCPTSTATE_500 at all.. (oops).
	    - calls to  stashmyaddresses()  don't need to carry
	      determined self-host-identity.

2000-07-24  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c:
	    A simple spelling error in normally invisible text sent
	    towards the user inside the delivery status reports.

2000-07-18  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Possibly  ssfgets()  fell on over-by-one allocation/storage
	    error so that the buffer tail got stomped over, and some
	    systems didn't like it --> they crashed.

	* configure.in, router/db.c, router/libdb/bsdbtree.c,
	  router/libdb/bsdhash.c, smtpserver/policytest.h,
	  smtpserver/policytest.c, utils/makedb/makedb.c,
	  utils/makedb/dblook.c, utils/vacation/vacation.c,
	  README.UPGRADING:
	    Reworked things to support another kind of set of
	    SleepyCat DB libraries.  Not yet covering version 3.x.

	* lib/rfc822scan.c:
	    A bit more characters into "no need to quote these here"
	    set -- allow address <@[1.2.3.4]:foo@bar> and <foo@[1.2.3.4]>

2000-07-17  Matti Aarnio  <mea@zmailer.org>

	* libs/Makefile.in, Makefile.in:
	    Merge  libsfio.a  generation into this file also, so that
	    there is no absolute need to run its make as the first
	    thing among subdirs.
	    Also made top-level "make libs" target which recompiles
	    and/or just reconstructs (with ar) all libraries.

	* transports/smtp/smtp.c:
	    Oops.. Solaris 2.6 --with-bundled-libresolv  does not
	    know about BIND 8 resolver's AD and CD bits.  Don't use
	    them.

	* Makefile.in:
	    Version 2.99.53

	* smtpserver/smtpcmds.c:
	    At MAIL FROM policy reporting we did always yield
	    400-series reply even when actual code directed us
	    to yield 500-series..

2000-07-14  Grace He <ghe@scs.Ryerson.CA>

	* router/dateparse.c:
	    Fix for "Date: 00-06-29 03:50:11" induced crashes

2000-07-14  Matti Aarnio  <mea@zmailer.org>

	* lib/selfaddrs.c:
	    Rearrange SIOCGLIFCONF / SIOCGIFCONF code a bit, will
	    prefer SIOCGLIFCONF over SIOCGIFCONF if both are available.

	* lib/selfaddrs.c, lib/zgetifaddress.c, include/libz.h,
	  configure.in, utils/makedb/Makefile.in:
	    Solaris 8 test derived fixes.

2000-07-12  John D Groenveld <jdg117@elvis.arl.psu.edu>

	* man/Makefile.in:
	    If "${MANDIR}/man3" directory does not exist, create it.

2000-07-11  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Sometimes printing to logfp was done unconditionally -- when
	    the logfp variable carries NULL :-/

2000-06-22  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, smtpserver/mxverify.c:
	    Further commentary from  bind-workers  told me that unless
	    the AA-bit (authoritative answer) is set, the received ADDATA
	    isn't possibly good enough to trust - some of A/AAAAs may
	    have expired.  Thus we shall use that reply section for
	    A/AAAA only if AA-bit is set.

2000-06-21  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/mxverify.c, transports/smtp/smtp.c:
	    Made smtpserver MXVERIFY to use DNS ADDITIONAL DATA,
	    and reorganized A record collection so that if some
	    MX server does not have A, that is asked for it
	    explicitely, and if ipv6 is in use, if AAAA data
	    does not exist for a server, it is asked for.
	    In case ipv6 is not in use, this collapses into plain
	    A type data retrieval.

	* lib/selfaddrs.c:
	    Removed a test which is never true.

	* transports/smtp/smtp.c:
	    Some more tuning of  getmxrr()  pathology processing.

2000-06-20  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Use  zgetifaddress() for '-L iface:eth0' binding.

	* configure.in, include/libz.h, lib/Makefile.in,
	  lib/selfaddrs.c, lib/zgetifaddress.c:
	    Autoconfigure  BSDI derived  getifaddrs()  call,
	    and have sensible IOCTL set for both interface
	    list, and for interface address lookup code.

	* scheduler/mailq.c:
	    One-off in array realloc() biting us at Solaris..

	* transports/smtp/smtp.c, nam/smtp.8:
	    Coded '-L' option processing to bind to named local
	    interface.

	* lib/selfaddrs.c:
	    Experimental SIOCGLIFCONF code for IPv6 speaking
	    some-BSD systems -- to pick IPv6 interface addresses
	    from the system.

	* transports/smtp/smtp.c, transports/smtp/smtp.h:
	    When doing   getmxrr()  for MX data, will use also
	    the DNS supplied ADDITIONAL DATA segment materiel
	    for MX machine addresses.

2000-06-19  Matti Aarnio  <mea@zmailer.org>

	* scheduler/update.c:
	    Organically relating to  smtpopen() -> "retryat +60"
	    code, if NEXT thing to feed has its expiry tag in
	    past (and non-zero), then *stay* in CFSTATE_STUFFING
	    so that possible next thing will be quickly diagnosed
	    out of the queue at the end of its expiry time..
	    ALSO fixed double-counting of attempts on therads
	    and vertices!

	* transports/smtp/smtp.c:
	    If smtpopen() yields EX_TEMPFAIL, always do diagnostics
	    with 60 seconds timeout flag.. ( -> "retryat +60" )
	    so that the entire message queue will not be retried
	    there just for no good reason..

	* smtpserver/smtptls.c:
	    Following some discussion at OpenSSL list, I noticed
	    that DH type keys are not supported by our current code.
	    Now we should match that of OpenSSL: apps/s_server.c
	    sample code again.

	* transports/smtp/smtp.c:
	    Allow  ssfgets()  to enlarge the input string in runtime,
	    which enables us later to make weird things like multiple
	    hosts feeding in same connection... (perhaps)

	* transports/smtp/smtp.c:
	    Continued the rewrite by handling weird looking errors
	    from some sites which mistakenly limit the number of
	    recipients per smtp connection (session)!  Will do
	    close of the socket after each case where RCPT TO yields
	    400 series code.  (That will also knock on some real
	    temporary failures, like DNS timeouts when recipient
	    does verify the through-going address for e.g. MX analysis.)

	* transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Rewrote (in a sane way) the pipelined smtp_sync()
	    status code formulation so that we won't reject
	    recipients just because their system yields 400
	    code for all RCPTs which they get, and then said
	    to DATA that 'no recipients given yet'..

2000-06-14  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/fqdnalias.cf:
	    Don't fqdn-alias if it looks like RFC-822 source route
	    address.

	* lib/rfc822scan.c:
	    Allow RFC-822 source route addresses to go thru without
	    needing quotes -- allow ',' and ':' to be included into
	    addresses without quotes.

2000-06-13  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/fqdnalias.cf:
	    A missed thing in privilege processing in case db lookup
	    succeeds.

	* scheduler/scheduler.h, scheduler/mq2.c, scheduler/mailq.c,
	  scheduler/threads.c:
	    Implemented (in C) initial part of 'mailq' and 'mailq -v'
	    commands for MAILQ-V2 protocol.

	* scheduler/scheduler.c, man/scheduler.8, scheduler/mq2.c,
	  scheduler/mailq.pl:
	    Playing with MAILQ-V2 code to get (experimental) version
	    of detailed reporting a'la old mailq-v1 code.

	* scheduler/mailq.pl:
	    Now this PERL mailq supports functions:
		mailq
		mailq -Q
		mailq -QQ
		mailq -QQQ
	    and has also option '-U' for logging with non-default
	    username/password pair.

2000-06-07  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/ctlopen.c:
	    If ctlopen() contained open() of message body file fails,
	    send a warning() up to the scheduler log WITH errno of
	    that open() call..

	* proto/db/smtp-policy.src:
	    _RBL* alias labels are turned to LOWER CASE -- those keys
	    are lowercased during encoding, but data attributes are
	    not modified while compiling the database, nor when looking
	    up tags..

	* smtpserver/smtpserver.h, smtpserver/smtpdata.c,
	  smtpserver/cfgread.c,    smtpserver/contentpolicy.c,
	  utils/smtp-contentfilter.in:
	    CONTENT policy interface, and sample filter implementation..

	* scheduler/scheduler.c, scheduler/conf.c, scheduler/msgerror.c,
	  man/scheduler.8:
	    Modify the '-n' option semantics to control how DSN RET
	    option value is set in absense of originator supplied value.

2000-06-02  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mailq.c:
	    Count files in POSTOFFICE/router/ directory also when
	    it is subdir-hashed..

	* router/daemonsub.c:
	    Tried actually to use ROUTERDIRHASH=1 mode, and learned
	    of bitter errors at the subchild feeder code...  Dirname
	    was written twice to the workfilename.

	* router/libdb/header.c:
	    Allow just about *any* character to appear at headers
	    database key fields..  old limits were too strict anyway.

	* proto/post-install.sh.in:
	    More minor tweaks.

2000-05-28  Matti Aarnio  <mea@zmailer.org>

	* proto/Makefilein, proto/post-install.sh.in:
	    Small fixes that disjoint installation test shows up..

2000-05-26  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtp.h:
	    Cosmetics-like things about diagnostics tracking.

	* proto/newdb.in, proto/newdbprocessor.in,
	  proto/post-install.sh.in:
	    These are all PERL scripts now -- that last one should be
	    renamed, thinking about it...

2000-05-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtptls.c:
	    Proper network timeout monitored non-blocking wrapper
	    for SSL_connect()  code.

	* transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Reworked diagnostics codes a bit to collect only relevant
	    SMTP transaction bits per each recipient.
	    (Although still not *quite* correct for problems diagnosed
	     at DATA/dot time, which need all recipients, not just the
	     last one...)

2000-05-24  Matti Aarnio  <mea@zmailer.org>

	* proto/newdb.in:
	    Rewritten into PERL(v5) script.

	* smtpserver/rfc821scn.c, smtpserver/smtpcmds.c:
	    Eugene Crosser wanted to have:  <foo!_bar@some.dom>,
	    our scanner demanded an alphanum starter character for
	    the sub-fields of the local-part.  Now allowing also
	    the underscore as starter there -- for a username..
	    (smtpcmds.c has some diagnostics report beauty warts.)

2000-05-18  Matti Aarnio  <mea@zmailer.org>

	* proto/newdb.in, router/libdb/ndbm.c, router/libdb/dbm.c:
	    At NewDBM (ndbm) the dbm_dirfno() does not always yield
	    success at the dbm_open().  It *may* yield some scrap data
	    for a while -- especially if the db is *very* small.
	    The  dbm_pagfno()  yields always ok filehandle number,
	    and thus we use it -- and change file moving order to
	    .DIR .PAG to match which is tested later.

2000-05-10  Matti Aarnio  <mea@zmailer.org>

	* proto/Makefile.in, proto/post-install.sh.in:
	    Moved POSTOFFICE directory subdir generation into
	    the  post-install.sh  script.  Execution of that
	    script before system becomes ready for running is
	    now MANDATORY!  (At least at fresh installations.)

2000-05-09  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c:
	    Existence of ZENV variable ``SCHEDULERDIRHASH'' drives
	    movement of files from router to the scheduler to go
	    straight to hashed subdirs at the scheduler.

	* router/daemonsub.c:
	    A lot more work at the daemon subsystem.
	    Now it runs a dedicated set of router processes for
	    the primary router directory, plus one for each of
	    ``ROUTERDIRS'' variable defined auxiliary directories.

	* libc/mail.c, router/daemonsub.c, man/router.8,
	  SiteConfig.in:
	    If ZENV variable ``ROUTERDIRHASH'' exists, and has value
	    ``1'', all message submissions will be using direct moving
	    nto ``A'' thru ``Z'' hash-subdirectories -- if they don't
	    exist, things FAIL!

	* scheduler/mq2auth.c, scheduler/transport.c:
	    Mailq-V2 IP-ACL system works!

	* scheduler/scheduler.c, scheduler/transports.c:
	    Call  syncweb()  also inside the   mux()  routine
	    so that new jobs will get assimilated faster.

2000-05-08  Matti Aarnio  <mea@zmailer.org>

	* libc/mail.c, router/rfc822.c:
	    Simplified message injection code a bit; especially
	    tried to lessen the number of directory operations.
	    (Even though comments in the source say that rename(2)
	     isn't safe, we are using it...)

	* INSTALL:
	    Refer to HTML renderation of ZMailer manual's install part..

	* scheduler/msgerror.c:
	    Drop leading \r from report data.  No weird looking blank
	    line in resulting report.

	* transports/smtp/smtp.c:
	    Don't diagnose TLS status unconditionally, it is annoying
	    thing to have accumulating into scheduler's log..

	* smtpserver/smtpserver.c:
	    When --with-whoson  is used at configuration, and
	    smtpserver is run without '-w' option, policy test
	    is falling on default of "yes this is always ok relay
	    source" behaviour -- which in general is wrong :-(

2000-05-04  Matti Aarnio  <mea@zmailer.org>

	* lib/selfaddrs.c:
	    Yet Another small surprise at Linux systems about
	    self-address extraction.  :-/

2000-04-20  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c, smtpserver/smtpserver.c:
	    Fix "from_box" setting to match current treatment
	    of user input string (e.g. not stomping things
	    with '\0' chars..)
	    Synced  MaxErrorRecipients  default value with
	    documentation.

	* smtpserver/cfgread.c:
	    Documentation (proto/smtpserver.conf.in) says that
	    PARAM name is:  RcptLimitCount,  while it was recognized
	    only as  RcptLimitCnt ...  Oops.

2000-04-18  Matti Aarnio  <mea@zmailer.org>

	* router/db.c:
	    A mistake in cache LRU chain handling caused eternal
	    loop to form sometimes.  Oops.

2000-04-14  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/ctlopen.c:
	    An odd corner case of error handling allowed access to
	    uninitialized elements of an array -> junk data blew up..

	* scheduler/threads.c, scheduler/update.c:
	    Trying to understand why 'deferred' diagnostics causes
	    practically immediate reissuance of a task..
	    Understanding dawns, thread rescheduling was implemented
	    in fumes, so crazy it was (but then, I don't drink nor
	    smoke...)

	* router/functions.c, lib/rfc822scan.c:
	    Router function "$(dequote ...)" was previously castrated
	    a bit too much.  This isn't like sendmail-8's dequote class,
	    but far more brutal beast..

	* proto/Makefile.in:
	    Fix db subdir installation to work on a system without
	    GNU/BSD install (using locally supplied script).

	* compat/rmail/Makefile.in:
	    Allow  "mkdir -p ..." to fail on Solaris. (Anywhere actually)

	* libc/whathost.c:
	    Improved error handling by adding posixy redo of things
	    in case stat()s yield an error.. (Solaris 2.6 is complaining
	    somewhat in these routines..)

	* transports/smtp/smtptls.c:
	    Moved things around so that it works also when compiled
	    WITHOUT (Open)SSL.

2000-04-13  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    Moved one instance of  tls_conf_file  inside HAVE_OPENSSL
	    conditional.  Oops..

	* transports/smtp/smtp.c, transports/smtp/smtptls.c,
	  transports/smtp/smtp.h:
	    Try to combat certain TLS related problems mentioned before.
	    (An hour later: Cured them apparently..)

	* smtpserver/smtptls.c, smtpserver/smtpserver.c:
	    Under TLS do always flush replies - to simulate one other
	    MTA running under TLS wrapper.
	    (This was removed a bit later.)

2000-04-12  Matti Aarnio  <mea@zmailer.org>

	* router/db.c:
	    For Matthias Urlich; a method to declare at RELATION entry
	    if NEGATIVE CACHE is used at the particular relation (pre-
	    requires that cache is also used..) Driven with: -N option.

2000-04-11  Matti Aarnio  <mea@zmailer.org>

	* scheduler/mq2.c, scheduler/mq2auth.c, scheduler/prototypes.h,
	  scheduler/scheduler.h, scheduler/scheduler.c,
	  scheduler/transport.c:
	    Hooks for verifying MAILQv2 contactee IP address.

	* router/db.c:
	    Mathias Ulrichs <smurf@noris.de> suggest negative cache
	    for DB lookup related caches.  It is simple to do, but
	    not so simple to explain to be usefull...

2000-04-08  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c, scheduler/prototypes.h,
	  scheduler/threads.c, scheduler/transport.c:
	    Tracked possible reasons for processing crashes
	    when maxthr>1.

	* transports/smtp/smtp.c:
	    Changed the commentary log accumulation method, now
	    it will clear only at "MAIL FROM..." and from then
	    on collect all until next "MAIL FROM...".
	    Should make easier to understand some odd error reports.

	* scheduler/scheduler.c, scheduler/threads.c, scheduler/update.c:
	    Added some debugging related  memset()s just before freeing
	    some pointer containing memory blocks.
	    Also modified unvertex() slightly to forward nextfeed in
	    case current vertex is (at all) in any sort of processing.

2000-04-07  Matti Aarnio  <mea@zmailer.org>

	* scheduler/update.c:
	    Log only really important diagnostics about error
	    conditions in the system, not errors in email receiving.

	* scheduler/threads.c:
	    One instance of vertex free() has been processed
	    improperly.  If the 'nextfeed' is still pointing
	    to the vertex which is being deleted, it must be
	    advanced..  Although getting this means that the
	    scheduler has just fed the same job twice to TAs..

2000-04-06  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtptls.c:
	    Disable TLS read_ahead setting.  That mode doesn't
	    work quite well, and can definitely groak against
	    Stalker Software's  CommuniGate Pro smtpserver when
	    running in PIPELINING mode.

2000-04-02  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf, proto/cf/fqdnalias.cf:
	    - More work on rewritten expansion loop prevention measures.
	    - Added UserDB sender address rewriter into fqdnalias.cf too.

	* lib/rfc822scan.c, router/functions.c, proto/cf/aliases.cf:
	    Reworked alias (et.al.) expansion loop preventation
	    machinery.  Now a message aliased as:
		user1: user2, user1
	    will be delivered to both, unless some other mapping diverts.
	    NOT YET A COMPLETE THING!

2000-03-30  Matti Aarnio  <mea@zmailer.org>

	* proto/zmailer.sh.in, proto/newdb.in, proto/db/dbases.conf:
	    Now 'zmailer newdb' uses the  $MAILVAR/db/dbases.conf  file,
	    if it exists.  (But the converted needs to be rewritten,
	    and security issues need more thought...)

2000-03-29  Matti Aarnio  <mea@zmailer.org>

	* scheduler/threads.c:
	    thread_reschedule() crashed on thr->thvertices being NULL ??

	* router/rfc822hdrs.c:
	    Sometimes missed sending out at least one space after the
	    header name tag.

	* scheduler/transport.c, scheduler/update.c,
	  scheduler/mq2auth.c,  transports/smtp/smtptls.c:
	    Various bad diagnostics seen (from smtp) which in turn
	    crashed scheduler :-/  Oops..   Some new comments into
	    mq2auth.c about possible future directions.

	* proto/cf/crossbar.cf, proto/db/userdb:
	    Some more work on this, now allowing rather peculiar
	    ZMailerish keying at least for ":mailname" keys..

	* router/db.c:
	    Reworked cache code to be faster (I hope) by means of having
	    a crc32 hash value against which the matching is done.
	    The goal is to support in order of 10k entries in the cache
	    without too large of an impact on performance.
	    ( The hash collisions are resolved by means of doing actual
	      key  strcmp() )
	    The cache at each DB relation interface is still an LRU
	    with linear (urgh..) search time.  (A splay-tree was also
	    considered, but decided not to use.)

2000-03-28  Matti Aarnio  <mea@zmailer.org>

	* proto/cf/aliases.cf, proto/cf/crossbar.cf,
	  proto/cf/standard.cf, proto/db/dbases.conf,
	  proto/db/kill-headers, proto/db/userdb:
	    Created a way (always on when DB is defined, and
	    rewrite (at crossbar.cf) happens via 'internet') to
	    do ``username'' mapping to given FQDN address,
	    e.g.  ``user.name@here.domain''
	    Reworked kill-headers initialization.

	* include/mailer.h, proto/Makefile.in, proto/cf/standard.cf,
	  proto/db/kill-headers, router/rfc822.c, router/libdb/header.c:
	    Runtime configuration mechanism for killing named headers.
	    We have some uses for removing e.g. gateway generated
	    "X-Login-ID:" type of things which no recipient has any
	    business of seeing.

	* Makefile.in:
	    Version 2.99.53-pre1

2000-03-27  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    When the outbound SMTP fp is closed, don't truncate the
	    reported address -- mainly to stop "." appearing as the
	    last outbound state, when "data" really is it..

	* scheduler/MAILQ-V2, scheduler/mailq.pl, scheduler/mq2.c,
	  scheduler/prototypes.h, scheduler/threads.c:
	    Playing with ideas regarding MAILQ-V2 protocol.
	
2000-03-24  Matti Aarnio  <mea@zmailer.org>

	* configure.in, transports/mailbox/dotlock.c:
	    Autosense 'HAVE_GETHOSTID', and if it isn't, try to
	    create it in couple different ways (For earlier Solaris,
	    and HPUX systems, very least.)

2000-03-23  Matti Aarnio  <mea@zmailer.org>

	* INSTALL, configure.in, Makefile.in, sfio/Makefile.in,
	  sfio/src/lib/sfio/makefile.in,
	  sfio/src/lib/sfio/{Sfio_{dc,f},Stdio_{b,s}}:
	    Made SFIO compilation environment to work also when
	    running in "subdirectory" configuration (e.g. using
	    ../configure ...)
	    Also cleaned up the SFIO configuration system a bit.

	* doc/guides/smtp-policy:
	    Added some words about the policy testing by using -T option.

2000-03-21  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c:
	    Implemented  -T  option for a local interactive policy
	    testing without having connectivity all around the world.
	    See the man-page.

2000-03-18  Matti Aarnio  <mea@zmailer.org>

	* router/daemonsub.c, router/conf.c:
	    Spotted a self-healing misbehaviour in the child process
	    feeder, which skipped messages from queue quite *often*.
	    Cured that by waiting in proper place for successfull
	    delivery.  Also changed some default values for
	    "stability" processing.

	* router/rfc822hdrs.c, router/rfc822.c, lib/token.c:
	    Aborted (and deactivated) foldable tokens processing on
	    headers we don't know about right now.  Perhaps need to
	    have some other approach on the problem...

2000-03-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c, smtpserver/smtprouter.c:
	    Instead of using printf format:  %*s  we need to use  %.*s

	* transports/libta/swriteheaders.c:
	    Eugene Crosser spotted CHUNKING mode problem with
	    message header TAB expansion.  Outch!

	* router/router.c:  logit()
	    Changed  stdout  written log printf() format so that
	    quite large lists of addresses are allowed.

2000-03-15  Matti Aarnio  <mea@zmailer.org>

	* configure.in, transports/mailbox/mailbox.c:
	    "--without-maillock" configuration option from
	    Eugene Crosser.   We don't seem to be quite
	    as happy chaps with Solaris maillock() as we
	    would like to be in all cases :-/
	    (E.g. if we use any other than  /var/mail/ directory
	     for mailboxes, Solaris  maillock()  will still put
	     locks into /var/mail/ directory :-?  Hmm..)

2000-03-14  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c:
	    Reworked report suppression; if all RCPTs have NOTIFY=NEVER,
	    no report shall be made.   Some cleanup of report generation.

	* transports/mailbox/mailbox.c:
	    Small cleanup of RFC 1894 action status reports.

	* transports/smtp/smtp.c:
	    - Do (at least try) shunt new scheduler TA driver state-
	      machine only when connection fails, not when a message
	      delivery yields some 400 series status code.
	    - PIPELINING mode in smtp_sync() did react suboptimally
	      (wrong) to DATA yielding 500 series code when MAIL FROM
	      or any/all RCPT TO commands yield 400 series status.
	    - DRUMS/SMTPUPD tells that if MX records are available,
	      but none are usable (preference pruning rule), this
	      must be reported as an error.  We allow '-W' mode to
	      override this so that when '-W' is present, this case
	      is not an error, IF destination domain has A + WKS/smtp
	      permitting delivery there.

	* smtpserver/smtpcmds.c:
	    DRUMS/SMTPUPD tells that policy based rejections of
	    recipients shall use 550 (and 450) codes.

2000-03-09  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/diagnostic.c, include/ta.h,
	  transports/smtp/smtp.c:
	    Some diagnostics related rework due to absolutely
	    insanely behaving SMTP reception.     Diagnostic
	    output in EX_TEMPFAIL or EX_IOERR are not per default
	    (actually never) stored directly to the file by the TA
	    program, and anyway doing diagnostics in such case is
	    marginally usefull -- retries may happen, for example!
	    Now things should allow recipient address to be retries
	    properly even with mode locking working ok.

2000-03-05  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    More systematic approach at MAIL FROM and RCPT TO
	    related reporting where related addresses are wanted
	    to be included into the diagnostic messages.  All that
	    just for completely braindead approach prevalent in
	    M$ client software...

2000-03-03  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c:
	    Basic footwork for DELAYED reporter.
	    (Incomplete yet.)

	* scheduler/scheduler.c:
	    Reverted earlier change which counted already processed
	    recipients into MTA-MIB variables.

	* doc/Makefile.in, man/Makefile.in, libresolv/Makefile.in,
	  scheduler/Makefile.in:
	    Fixed "make depend" to work.

	* scheduler/Makefile.in, scheduler/servauth.h:
	    DELETED servauth.h -- something entirely forgotten,
	    and same stuff reimplemented elsewere.

	* man/smtp.8, man/smtpserver.8:
	    Updates/fixes to text.

	* scheduler/scheduler.c, scheduler/scheduler.h,
	  scheduler/conf.c, scheduler/agenda.c, scheduler/msgerror.c,
	  scheduler/readconfig.c, scheduler/prototypes.h,
	  man/scheduler.8:
	    - Slightly simplified doagenda()
	    - Created accumulated report collector/reporter subservice.

2000-03-01  Matti Aarnio  <mea@zmailer.org>

	* proto/forms/delivery:
	    Added an URL reference to a "decode key" at
		http://www.zmailer.org/reports.html

	* scheduler/scheduler.h, scheduler/update.c, scheduler/threads.c,
	  scheduler/prototypes.h, scheduler/readconfig.c,
	  scheduler/msgerror.c, man/scheduler.8:
	    - Reworked how IDLE handles idle process recycling; always
	      the channel must match, host may or may not need to match.
	    - Reworked parts of error reporting in preparation for
	      creating delay reports.
	      (And earlier FAILED/DELIVERED/RELAYED reports at the same
	       time, of course..)

	* proto/cf/fqdnalias.cf:
	    Spotted some FIXME things..

	* transports/smtp/smtp.c:
	    When socket write failure causes shutdown of write direction
	    socket, do turn all back reported 500 series errors into
	    softer  400 series codes.  Won't unnecessarily reject
	    messages.

2000-02-29  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpetrn.c, man/smtpserver.8, man/scheduler.8:
	    Completed the etrn-cluster code. Seems to work, even.
	    Updated man-pages a bit.

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/cfgread.c, smtpserver/smtpcmds.c:
	    - PARAM sum-sizeoption-value  -- modify how
	      MAIL FROM:<> SIZE=nn option value is processed
	      when compared against various limits in the system;
	      if the option is present, effectively the system required
	      free space is message size multiplied by the recipient
	      count.
	    - PARAM max-unknown-commands nn -- how many pure junk
	      commands can be accepted before our side hungs the
	      connection. Default limit: 10

2000-02-28  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, smtpserver/smtpserver.h,
	  smtpserver/cfgread.c, smtpserver/smtpetrn.c,
	  proto/smtpserver.conf.in, doc/guides/etrn-cluster:
	    - A bug in '-l SYSLOG' which bite me at Solaris.. Oops..
	    - some reworking of ETRN-CLUSTER code, but no completition
	       yet.

2000-02-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    If DATA-dot-phase ending dot yields EX_TEMPFAIL, don't
	    do diagnostics right after smtpwrite(".").  It leads
	    to bad retry results :-/

	    Reworked something else; simplified code for header
	    output -- which will be "obviously correct".

	* smtpserver/smtpserver.c:
	    Make '-l SYSLOG' option to work in parallel with possible
	    '-l /path/to/file' logging option.

2000-02-18  Matti Aarnio  <mea@zmailer.org>

	* configure.in:
	    Moved   --with-zconfig=  code around a bit, apparently
	    it was quite ineffective, and has been that way for quite
	    a while :-/
	    (More so the documentation spoke of some other option..)

2000-02-17  Eugene Crosser  <crosser@online.ru>

	* smtpserver/smtpdata.c, configure.in, acconfig.h:
	    (Auto)configure  USE_TRANSLATION  into smtpserver.
	    [mea] minimized Eugene's patch inside smtpserver code by
	          rearrangeing 'USE_TRANSLATION' usage in smtpdata.c
		  (e.g.: Eugene wrote it, Matti possibly botched it..)

2000-02-15  Matti Aarnio  <mea@zmailer.org>

	* scheduler/agenda.c, scheduler/mq2.c, scheduler/prototypes.h,
	  scheduler/scheduler.c, scheduler/scheduler.h,
	  scheduler/threads.c, scheduler/transport.c,
	  man/scheduler.8, scheduler/MAILQv2:
	    - Streamlined MAILQv2 processing -- it should now be as low
	      latency service as possible, even with long-lasting
	      operations blocking at things like input queue scanner.
	    - Implemented a 30 second apopteosis for MAILQv2 sockets.
	    - Implemented MAILQv2 action ETRN -- exactly alike the SMTP-
	      server one.

2000-02-12  Matti Aarnio  <mea@zmailer.org>

	* lib/selfaddrs.c:
	    In *addition* to interface picked addresses, collect also
	    z-environment defined  SELFADDRESSES=  listed addresses.
	    (For the support of an ETRN-CLUSTER.)

	* transports/smtp/smtp.c:
	    A read timeout at response wait after write timeout is now
	    limited to 300 seconds.

	* smtpserver/Makefile.in, smtpserver/smtpserver.h,
	  smtpserver/cfgread.c, smtpserver/smtpserver.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpetrn.c, SiteConfig.in,
	  proto/smtpserver.conf.in, doc/guides/etrn-cluster:
	    Some initial work for an ETRN-CLUSTER.

2000-02-08  Matti Aarnio  <mea@zmailer.org>

	* man/smtpserver.8, smtpserver/smtpserver.h,
	  smtpserver/smtpserver.c, smtpserver/smtpdata.c,
	  smtpserver/smtpcmds.c, smtpserver/smtpauth.c:
	    Created smtpserver runtime command-line option "-l SYSLOG",
	    which is a magic thing to send logfile material through
	    syslog()  facility.  Beware there is *huge* amount of
	    dataflow there!
	    Some updates to smtpserver.8 man-page.

2000-02-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.c, lib/taspoolid.c:
	    Changed (again) the logtag prefix for smtpserver's "-l"
	    parameter defined logfile.  Considering enabling it to
	    be also diverted via syslog() to where-ever that goes.
	    (But server process can have only one syslog() session
	     active with one facility..)

2000-02-03  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/smtptls.c:
	    Grumble...  Still seeing wrong kind of timeouts..

2000-02-02  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c:
	    An oddball log error - misreported outwritten message header
	    size into smtp client's log file.

	* README.UPGRADING, include/mail.h.in, scheduler/scheduler.c,
	  transports/libta/markoff.c:
	    Prepared for adding _CF_MIMESTRUCT multiline entity into
	    the TA-specsfile.  It will contain preparsed result of what
	    the message structure is - and be able to prevent e.g.
	    decoding  QP when the end result exceeds linelength limits..
	    (And do proper body structure processings where appropriate)

	* transports/smtp/smtp.c:
	    Lengthened the -Ttcpw= default to 5 minutes
	    (RFC 1123: 3 minutes)

	* router/parsedate.c:
	    Armour  lilian()  function against bad MON or DAY inputs.
	    (Especially zero month is deadly..)  However this code is
	    currently completely dead -- not used, so...

	* scheduler/mq2.c, transports/mailbox/mailbox.c,
	  transports/sm/sm.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c, transports/smtp/smtp.c,
	  transports/smtp/appendlet.c:
	    Turns out the  sfsetfd()  has a undesirable side-effect,
	    which might be turnable off, but...  Namely it does sfsync()
	    on the stream before setting the fd -- we don't want that.

	* libsh/io.c, router/functions.c, router/prototypes.h,
	  router/rtsyslog.c, smtpserver/smtprouter.c,
	  transports/libta/diagnostic.c:
	    Cleaned up several GCC 2.96 reported/complained things.
	    (Couple of which stopped compilation..)

	* transports/smtp/smtp.c:
	    More of hunting of strange errors at protocol transmission.

	* smtpserver/smtpserver.c:
	    When reporting '-- pipeline input exists', do that
	    immediately after collecting previous input line, not
	    after SYNCing out previous reply.

2000-02-01  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/appendlet.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c,   transports/smtp/smtp.c:
	    More of the same work as yesterday evening/today
	    early morning..

	* transports/smtp/smtp.c, transports/smtp/smtptls.c,
	  transports/libta/swriteheaders.c:
	    Some code rearrangements to better(?) handle stream
	    write errors.

2000-01-31  Matti Aarnio  <mea@zmailer.org>

	* utils/mxverify/mxverify-cgi.c:
	    Move "test with user-suppled address" before the
	    "test with postmaster" case.  In case the Postmaster
	    doesn't exist (which is an error in itself, though..),
	    the user supplied address was tested very least.

2000-01-25  Matti Aarnio  <mea@zmailer.org>

	* transports/smtp/smtp.c, transports/smtp/appendlet.c:
	    Small error test rearrangements so that if  sferror()
	    is set at the output stream, no writing will happen.

2000-01-24  Matti Aarnio  <mea@zmailer.org>

	* transports/libta/swriteheaders.c,
	  transports/libta/fwriteheaders.c:
	    Do proper TAB-expand in entire header strings,
	    if so directed.

	* utils/mxverify/*
	    Made it as stand-alone as possible; it still uses ZMailer's
	    configuration system, but does not need rest of the system
	    for compilation -- all parts it needs are localized copies.

	* transports/smtp/smtptls.c:
	    smtp_sfwrite() didn't break out at write-timeout quite
	    as I had intended..

	* transports/smtp/smtp.c, transports/smtp/smtptls.c:
	    More debug stuff for hunting strance message breaks..

2000-01-23  Matti Aarnio  <mea@zmailer.org>

	* lib/token.c, router/rfc822hdrs.c:
	    Turn all header start spaces to optimized TABs plus spaces.

	* smtpserver/smtpcmds.c:
	    Now (!) people tell me that the most common M$ email
	    clients are absolutely stupid, and won't be able to
	    correlate outgoing SMTP verbs to responses they receive.
	    They just tell to user the error which Z returns, and
	    as it doesn't repeat the address in fault (why should it?),
	    user has no clue...   (So the one-line reports will from
	    now on also mention the received address...)

	* utils/mxverify/Makefile.in, utils/mxverify/mxverify-cgi.c,
	  utils/mxverify/mxverify-cgi.html, utils/Makefile.in,
	  utils/mxverify-cgi.c, utils/mxverify-cgi.html
	    Moved the thing to subdirectory.
	    Now it can be compiled without compiling the *entire*
	    other ZMailer -- just:
		./configure --prefix=/usr
		cd utils/mxverify ; make

2000-01-20  Matti Aarnio  <mea@zmailer.org>

	* utils/listexpand.c:
	    Added parametrization on how large bundles to make.
	    Default is the same old 200..

	* transports/smtp/smtp.c:
	    Turned out that Linux glibc 2.1 getaddrinfo() has some
	    strange bugs when it is left to its devices to scan for
	    a generic address suite -- it doesn't scan only IPv4 and
	    IPv6, but also some others, and if it gets error anywhere,
	    it seems to barf..  Will now scan for IPv4 and IPv6
	    separately :-/  So much for the great transparent API ...

	* utils/mxverify-cgi.c, utils/mxverify-cgi.html:
	    Detected the above problem while playing with this utility,
	    and developed that change here..
	    Reworked quite some things after initial deployment, added
	    that page into CVS for supplementary info.

2000-01-19  Matti Aarnio  <mea@zmailer.org>

	* include/ta.h,           transports/libta/diagnostic.c,
	  transports/smtp/smtp.c, transports/libta/tasyslog.c:
	    Report (at smtp) also the conversion mode used
	    at the reported session.

	* utils/mxverify-cgi.c, utils/Makefile.in:
	    Writing a utility to ease destination domain verification
	    by testing *all* MXes of given domain.

2000-01-17  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c:
	    Accept SMTP verbs which have numbers in them.
	    Treat verb "550" by responding SILENTLY to it -- e.g.
	    don't reply anything when get it.

	* smtpserver/mxverify.c:
	    Treat RBL-type lookups as ERRORS only when the DNS
	    yields A record under mask: 127.0.0.0/24.  There exists
	    a zone:  .ok.orbs.org  which has  127.127.0.0/24 and
	    THOSE are verified to be ok.  If using ORBS, use first
	    the OK zone, only then the RELAYS zone.
	    ( -> On larger blocked zone, an individual OK entry can
	         accept email. )

2000-01-14  Matti Aarnio  <mea@zmailer.org>

	* scheduler/msgerror.c, include/ta.h,
	  transports/libta/diagnostic.c, transports/smtp/smtp.c:
	    Extend the notary report with "X-ZTAID:" which is
	    diagnostic about which TA process did generate the error
	    report.    Allows one to hunt things from the syslog..

	* smtpserver/smtpserver.c:
	    Doing  longjmp()  from within a signal handler isn't
	    kosher -> sigsetjmp()/siglongjmp() and friends..
	    (Not that that signal handler should ever be called in
	     normal operation of the smtpserver..)

	* scheduler/readconfig.c:
	    Pulled back (disabled) code related to selector clause
	    wild-card testing in clause's "channel" part.

	* proto/cf/standard.cf:
	    Fixed recent thoughts mentioned below - coded test end
	    statement ("fi") was missing.

2000-01-07  Matti Aarnio  <mea@zmailer.org>

	* scheduler/threads.c:
	    Sometimes adding new tasks into a long-running thread did
	    cause the "unfed" count to go to *negative* value.
	    Now counting tasks there always when they arrive to
	    the thread, not only when all previous ones have already
	    been fed.. (caring about it only when a process is active
	    on the thread.)

	* proto/cf/aliases.cf, proto/cf/fqdnalias.cf,
	  proto/cf/i-iprouter.cf, proto/cf/i-router.cf,
	  proto/cf/standard.cf, proto/db/dbases.conf:
	    Some collected thoughts about how to do multiple instances
	    of several popular databases (like aliases) in varying DB
	    formats.

	* router/libdb/bind.c, proto/cf/i-smtp.cf:
	    Created sub-mode 'mxlocal' for the BIND database.
	    If local system is lowest MX for given domain, then
	    it yields string (query domain) and zero return code,
	    else NIL and non-zero return code.

	* Makefile.in, bin/usa-itar-stripper.sh:
	    'make dist-usa' creates now
	       - DIRNAME-usa.tar  package (vs. DIRNAME.tar of 'make dist')
	       - crypto-DIRNAME.diff  file

	* transports/smtp/smtp.h, transports/smtp/smtp.c:
	    Seen strange junk commands fed out to the remote
	    systems, trying to determine what is going on..

2000-01-05  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpcmds.c:
	    Change several policy situation '550' codes to '553';
	    temporary failure indicators shall stay as '440'.

2000-01-04  Matti Aarnio  <mea@zmailer.org>

	* smtpserver/smtpserver.h, smtpserver/smtpserver.c:
	    Killed 'HAVE_TCPD_H' code from these files; using
	    smtpserver's policy database is better -- way better..

	* transports/smtp/smtp.c, include/libz.h, lib/parseintv.c,
	  lib/Makefile.in, scheduler/readconfig.c:
	    - Moved  parse_interval()  into library (from scheduler).
	    - Using it at smtp-ta for timeout parameter parsing

	* transports/smtp/smtp.c:
	    If 'DATA' yields '500' series, don't just do RSET + retry
	    at the same stream. (EX_IOERR)

2000-01-03  Matti Aarnio  <mea@zmailer.org>

	* router/libdb/headers.c:
	    Darn..  Can't just disable "date" from known headers,
	    however changeing their semantics to 'nilHeaderSemantics'
	    should do it.

	* scheduler/threads.c:
	    abort() replaced with correct code -- "the thing never to
	    happen *did* happen"...

2000-01-02  Matti Aarnio  <mea@zmailer.org>

	* router/rfc822.c, lib/skip821address.c,
	  transports/libta/ctlopen.c:
	    Have seen one mighty strange local non-delivery,
	    and learned ways to use quotes in addresses which
	    are not always safe from router to scheduler, and to TAs..

	* man/smtp.8, proto/smtp-tls.conf{,.in}, doc/guides/openssl,
	  configure.in, proto/Makefile.in, proto/scheduler.conf.in,
	  proto/post-install.sh.in:
	    - Updated 'smtp.8' man-page
	    - Updated OpenSSL GUIDE
	    - Updated the prototype of  smtp-tls.conf  (and renamed
	      it for autoconf reasons)
	    - Install the  smtp-tls.conf  prototype file
	      (for post-install)
	    - Updated  post-install.sh
	    - Added example usage clause to scheduler.conf.in

	* transports/smtp/smtp.c, transports/smtp/smtp.h,
	  transports/smtp/smtptls.c, transports/smtp/appendlet.c:
	    Reworked the timeout parametrizations somewhat
	    (per what a colleque of mine had asked for)

	* router/libdb/header.c, router/rfc822hdrs.c:
	    Remove the "Date" headers from specially recognized set.
	    Will end PARSING of the headers completely - it is an UA
	    problem, after all.
	    --> WHOOPS! Must fix also  router/rfc822hdrs.c !

	* scheduler/scheduler.c:
	    Properly analyze how many FDs each bidirectional TA
	    connection needs.  One or two.  Calculate the maximum
	    number of TA childs we can run.

	* scheduler/threads.c, scheduler/readconfig.c,
	  scheduler/scheduler.h, scheduler/transport.c:
	    Modified the process state algorithms a bit.
	    - Process will stay in STUFFING until it gets #hungry in
	      that state without that the thread has any 'nextfeed'
	      available.
	    - Only when there are no more things to feed in STUFFING-
	      state, process moves to FINISHING-state
	      ("retryat" processing being sole exception.)
	    - A new vertex to a thread while there are active processes,
	      but 'nextfeed == NULL' will be placed into 'nextfeed'.
	    - A new clause parameter ``WakeupRestartOnly'' works by
	      allowing a newly created thread to be processed
	      immediately, but if existing thread is in ``Retry Delay''
	      state, this new message will not auto-start the thread
	      right away.
	
	* proto/scheduler.conf.in:
	    Explained a lot (more) about the scheduler usage of
	    various selector clause parameters in the initial
	    comment lines.

	* transports/smtp/smtp.c, transports/smtp/smtptls.c,
	  transports/smtp/smtp.h, doc/guide/openssl:
	    Debugged the client-mode STARTTLS, it *works*!

1999-12-31  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version 2.99.52-patch1

	* transports/mailbox/mailbox.c:
	    Spotted lurking SFIO usage bug which caused
	    missing safe buffer zone newlines at the ends
	    of the mailbox stored messages.  At least
	    my MUTT seem to be a happy camper even with
	    this problem present, but perhaps not all
	    are so good..

	* transports/libta/swriteheaders.c:
	    Missed reserving space for TAB-expansions in CHUNKING
	    mode operation of SMTP.  Only against other ZMailers,
	    and a few other rare systems..

1999-12-30  Matti Aarnio  <mea@zmailer.org>

	* Makefile.in:
	    Version 2.99.52

1999-12-30  Matti Aarnio  <mea@zmailer.org>

	* contrib/zmailer-spec/*:
	    SPECS files for RPM generation
	    from XosÉ Vázquez <xose@ctv.es>

	* Makefile.in:
	   Version 2.99.52-pre5

	* scheduler/scheduler.c:
	    At RESYNC processing do lock verification SILENTLY,
	    and do break the lock...

	* transports/mailbox/mailbox.c:
	    When SFIO was introduced here, write to pipes wasn't
	    anymore working quite as it should -- namely EPIPE
	    is something which shall just be *ignored*.  Wrote
	    SFIO write discipline to handle this case.

	* utils/Makefile.in, utils/smtpserver-log-parser.pl:
	    Autoconfigure the perl for that script, and install
	    it during normal system install (and install-bin).

	* transports/smtp/smtp.c:
	    - Some remote servers misbehave by issueing an error
	      to MAIL FROM just because receiver doesn't do proper
	      state clearance at end of DATA phase, but claims
	      that "MAIL FROM already given" :-(  Issue an RSET,
	      and try feeding the thing again.
	    - Subtle dangling pointers seen related to reconnect
	      processing, fixed them now.

	* scheduler/threads.c:
	    Print "mailq -Q" always as is threads are running in
	    multi-TA mode (instead of the default of maxthr=1)

	* scheduler/update.c:
	    An oddball ETRN caused SEGV - not quite sure this fix
	    was right in the long run...

	* libmalloc/botch.c, libmalloc/defs.h, libmalloc/dumpheap.c,
	  libmalloc/malloc.c, include/zmalloc.h, libmalloc/_strdup.c,
	  libmalloc/align.h, libmalloc/globals.c, libmalloc/emalloc.c,
	  libmalloc/malloc.h, libmalloc/strdup.c
	    memory debugging tools -- glibc malloc hooks are better!
	    (See  smtp.c  "_hook" things..)

	* scheduler/mq2.c:
	    Use SFIO instead of STDIO for some debug reports, and
	    do clean them too!
	
	* include/ta.h, transports/libta/ctlopen.c,
	  transports/libta/diagnostic.c, transports/libta/mimeheaders.c,
	  transports/libta/fwriteheaders.c, transports/smtp/smtp.c,
	  transports/libta/swriteheaders.c,
	  transports/libta/routermxes.c:
	    Tracked memory freeup order failure!  D'uh it was difficult!
	    ( ctlclose() did free(d.contents) too early... )

1999-12-29  Matti Aarnio  <mea@zmailer.org>

	* scheduler/scheduler.h, scheduler/prototypes.h,
	  scheduler/mq2.c, scheduler/threads.c, scheduler/transport.c,
	  scheduler/readconfig.c, scheduler/qprint.c,
	  scheduler/update.c, proto/scheduler.conf.in,
	  scheduler/agenda.c:
	    Implemented changes needed for running multiple TAs
	    at threads.

1999-12-28  Matti Aarnio  <mea@zmailer.org>

	* include/netdb.h, libc/getnameinfo.c:
	    Fixes from Eugene Crosser for Cobalt box.

1999-12-23  Matti Aarnio  <mea@zmailer.org>

	* transports/hold/Makefile.in, transports/mailbox/Makefile.in,
	  transports/sm/Makefile.in, transports/smtp/Makefile.in:
